/***********************************************************************/
/*                                                                     */
/*                                                                     */
/*                                                                     */
/*  DESCRIPTION :define the sfr register. (for C language)             */
/*                                                                     */
/*                                                                     */
/*  This file is generated by Renesas Project Generator.               */
/*                                                                     */
/***********************************************************************/
/****************************************************************************
*																			*
*	file name	: definition of M30245's SFR								*
*																			*
*	Copyright	: RENESAS TECHNOLOGY CORPORATION							*
*																			*
*	Version 	: 1.00	( 2003- 7-14 ) Initial								*
*****************************************************************************/
/*
  note:
	This data is a freeware that SFR for M30245 groups is described.
	Mitsubishi Electric Corporation assumes no responsibility for any damage
	that occurred by this data.
*/
/**********************************************/
/*			   declare SFR address			  */
/**********************************************/
#pragma ADDRESS 	pm0_addr		0004H		/* Processor mode register 0 */
#pragma ADDRESS 	pm1_addr		0005H		/* Processor mode register 1 */
#pragma ADDRESS 	cm0_addr		0006H		/* System clock control register 0 */
#pragma ADDRESS 	cm1_addr		0007H		/* System clock control register 1 */
#pragma ADDRESS 	csr_addr		0008H		/* Chip select control register */
#pragma ADDRESS 	aier_addr		0009H		/* Address match interrupt enable register */
#pragma ADDRESS 	prcr_addr		000aH		/* Protect register */
#pragma ADDRESS 	usbc_addr		000cH		/* USB control register */
#pragma ADDRESS 	wdts_addr		000eH		/* Watchdog timer start register */
#pragma ADDRESS 	wdc_addr		000fH		/* Watchdog timer control register */
#pragma ADDRESS 	rmad0_addr		0010H		/* Address match interrupt register 0 */
#pragma ADDRESS 	rmad1_addr		0014H		/* Address match interrupt register 1 */
#pragma ADDRESS 	cse_addr		001bH		/* Chip select expansion register */
//#pragma ADDRESS	  reserved		  001eH 	  /* reserved */
#pragma ADDRESS 	usbad_addr		001fH		/* USB Attach/Detach register */
#pragma ADDRESS 	sar0_addr		0020H		/* DMA0 source pointer */
#pragma ADDRESS 	dar0_addr		0024H		/* DMA0 destination pointer */
#pragma ADDRESS 	tcr0_addr		0028H		/* DMA0 transfer counter */
#pragma ADDRESS 	dm0con_addr 	002cH		/* DMA0 control register */
#pragma ADDRESS 	sar1_addr		0030H		/* DMA1 source pointer */
#pragma ADDRESS 	dar1_addr		0034H		/* DMA1 destination pointer */
#pragma ADDRESS 	tcr1_addr		0038H		/* DMA1 transfer counter */
#pragma ADDRESS 	dm1con_addr 	003cH		/* DMA1 control register */
#pragma ADDRESS 	kupic_addr		0041H		/* Key input interrupt control register */
#pragma ADDRESS 	s2ric_addr		0042H		/* UART2 receive/ACK interrupt control register */
#pragma ADDRESS 	s13bcnic_addr	0043H		/* UART1/3 Bus collision interrupt control register */
#pragma ADDRESS 	int1ic_addr 	0044H		/* INT1~ interrupt control register */
#pragma ADDRESS 	ta1ic_addr		0045H		/* Timer A1 interrupt control register */
#pragma ADDRESS 	ep0ic_addr		0046H		/* USB Endpoint 0 interrupt control register */
#pragma ADDRESS 	ta2ic_addr		0047H		/* Timer A2 interrupt control register */
#pragma ADDRESS 	s1ric_addr		0048H		/* UART1 receive/ACK/SSI1 receive interrupt control register */
#pragma ADDRESS 	s02bcnic_addr	0049H		/* UART0/2 Bus collision interrupt control register */
#pragma ADDRESS 	s0ric_addr		004aH		/* UART0 receive/ACK/SSI0 receive interrupt control register */
#pragma ADDRESS 	adic_addr		004bH		/* A-D conversion interrupt control register */
#pragma ADDRESS 	dm0ic_addr		004cH		/* DMA0 interrupt control register */
#pragma ADDRESS 	s3tic_addr		004dH		/* UART3 transmit/NACK interrupt control register */
#pragma ADDRESS 	dm1ic_addr		004eH		/* DMA1 interrupt control register */
#pragma ADDRESS 	s2tic_addr		004fH		/* UART2 transmit/NACK interrupt control register */
#pragma ADDRESS 	dm2ic_addr		0050H		/* DMA2 interrupt control register */
#pragma ADDRESS 	s1tic_addr		0051H		/* UART1 transmit/NACK/SSI1 transmit interrupt control register */
#pragma ADDRESS 	dm3ic_addr		0052H		/* DMA3 interrupt control register */
#pragma ADDRESS 	s0tic_addr		0053H		/* UART0 transmit/NACK/SSI0 transmit interrupt control register */
#pragma ADDRESS 	ta0ic_addr		0054H		/* Timer A0 interrupt control register */
#pragma ADDRESS 	s3ric_addr		0055H		/* UART3 receive/ACK interrupt control register */
#pragma ADDRESS 	suspic_addr 	0056H		/* USB suspend interrupt control register */
#pragma ADDRESS 	ta3ic_addr		0057H		/* Timer A3 interrupt control register */
#pragma ADDRESS 	rsmic_addr		0058H		/* USB resume interrupt control register */
#pragma ADDRESS 	ta4ic_addr		0059H		/* Timer A4 interrupt control register */
#pragma ADDRESS 	rstic_addr		005aH		/* USB reset interrupt control register */
#pragma ADDRESS 	sofic_addr		005bH		/* USB SOF interrupt control register */
#pragma ADDRESS 	vbdic_addr		005cH		/* USB Vbus detect interrupt control register */
#pragma ADDRESS 	usbfic_addr 	005dH		/* USB function interrupt control register */
#pragma ADDRESS 	int2ic_addr 	005eH		/* INT2~ interrupt control register */
#pragma ADDRESS 	int0ic_addr 	005fH		/* INT0~ interrupt control register */

#pragma ADDRESS 	sar2_addr		0180H		/* DMA2 source pointer */
#pragma ADDRESS 	dar2_addr		0184H		/* DMA2 destination pointer */
#pragma ADDRESS 	tcr2_addr		0188H		/* DMA2 transfer counter */
#pragma ADDRESS 	dm2con_addr 	018cH		/* DMA2 control register */
#pragma ADDRESS 	sar3_addr		0190H		/* DMA3 source pointer */
#pragma ADDRESS 	dar3_addr		0194H		/* DMA3 destination pointer */
#pragma ADDRESS 	tcr3_addr		0198H		/* DMA3 transfer counter */
#pragma ADDRESS 	dm3con_addr 	019cH		/* DMA3 control register */

#pragma ADDRESS 	usba_addr		0280H		/* USB address register */
#pragma ADDRESS 	usbpm_addr		0282H		/* USB power management register */
#pragma ADDRESS 	usbis_addr		0284H		/* USB interrupt status register */
#pragma ADDRESS 	usbic_addr		0286H		/* USB interrupt clear register */
#pragma ADDRESS 	usbie_addr		0288H		/* USB interrupt enable register */
#pragma ADDRESS 	usbfn_addr		028aH		/* USB frame number register */
#pragma ADDRESS 	usbisoc_addr	028cH		/* USB ISO control register */
#pragma ADDRESS 	usbepen_addr	028eH		/* USB endpoint enable register */
#pragma ADDRESS 	usbdma0_addr	0290H		/* USB DMA0 request register */
#pragma ADDRESS 	usbdma1_addr	0292H		/* USB DMA1 request register */
#pragma ADDRESS 	usbdma2_addr	0294H		/* USB DMA2 request register */
#pragma ADDRESS 	usbdma3_addr	0296H		/* USB DMA3 request register */
#pragma ADDRESS 	ep0cs_addr		0298H		/* USB EP0 control/status register */
#pragma ADDRESS 	ep0mp_addr		029aH		/* USB EP0 max packet size register */
#pragma ADDRESS 	ep0wc_addr		029cH		/* USB EP0 write count register */
#pragma ADDRESS 	ep1ics_addr 	029eH		/* USB EP1 IN control/status register */
#pragma ADDRESS 	ep1imp_addr 	02a0H		/* USB EP1 IN max packet size register */
#pragma ADDRESS 	ep1ifc_addr 	02a2H		/* USB EP1 IN FIFO configuration register */
#pragma ADDRESS 	ep2ics_addr 	02a4H		/* USB EP2 IN control/status register */
#pragma ADDRESS 	ep2imp_addr 	02a6H		/* USB EP2 IN max packet size register */
#pragma ADDRESS 	ep2ifc_addr 	02a8H		/* USB EP2 IN FIFO configuration register */
#pragma ADDRESS 	ep3ics_addr 	02aaH		/* USB EP3 IN control/status register */
#pragma ADDRESS 	ep3imp_addr 	02acH		/* USB EP3 IN max packet size register */
#pragma ADDRESS 	ep3ifc_addr 	02aeH		/* USB EP3 IN FIFO configuration register */
#pragma ADDRESS 	ep4ics_addr 	02b0H		/* USB EP4 IN control/status register */
#pragma ADDRESS 	ep4imp_addr 	02b2H		/* USB EP4 IN max packet size register */
#pragma ADDRESS 	ep4ifc_addr 	02b4H		/* USB EP4 IN FIFO configuration register */
#pragma ADDRESS 	ep1ocs_addr 	02b6H		/* USB EP1 OUT control/status register */
#pragma ADDRESS 	ep1omp_addr 	02b8H		/* USB EP1 OUT max packet size register */
#pragma ADDRESS 	ep1wc_addr		02baH		/* USB EP1 OUT write count register */
#pragma ADDRESS 	ep1ofc_addr 	02bcH		/* USB EP1 OUT FIFO configuration register */
#pragma ADDRESS 	ep2ocs_addr 	02beH		/* USB EP2 OUT control/status register */
#pragma ADDRESS 	ep2omp_addr 	02c0H		/* USB EP2 OUT max packet size register */
#pragma ADDRESS 	ep2wc_addr		02c2H		/* USB EP2 OUT write count register */
#pragma ADDRESS 	ep2ofc_addr 	02c4H		/* USB EP2 OUT FIFO configuration register */
#pragma ADDRESS 	ep3ocs_addr 	02c6H		/* USB EP3 OUT control/status register */
#pragma ADDRESS 	ep3omp_addr 	02c8H		/* USB EP3 OUT max packet size register */
#pragma ADDRESS 	ep3wc_addr		02caH		/* USB EP3 OUT write count register */
#pragma ADDRESS 	ep3ofc_addr 	02ccH		/* USB EP3 OUT FIFO configuration register */
#pragma ADDRESS 	ep4ocs_addr 	02ceH		/* USB EP4 OUT control/status register */
#pragma ADDRESS 	ep4omp_addr 	02d0H		/* USB EP4 OUT max packet size register */
#pragma ADDRESS 	ep4wc_addr		02d2H		/* USB EP4 OUT write count register */
#pragma ADDRESS 	ep4ofc_addr 	02d4H		/* USB EP4 OUT FIFO configuration register */
//#pragma ADDRESS	  USB reserved	  02d8H 	  /* reserved */
//#pragma ADDRESS	  USB reserved	  02d9H 	  /* reserved */
//#pragma ADDRESS	  USB reserved	  02daH 	  /* reserved */
//#pragma ADDRESS	  USB reserved	  02dbH 	  /* reserved */
//#pragma ADDRESS	  USB reserved	  02dcH 	  /* reserved */
//#pragma ADDRESS	  USB reserved	  02ddH 	  /* reserved */
//#pragma ADDRESS	  USB reserved	  02deH 	  /* reserved */
//#pragma ADDRESS	  USB reserved	  02dfH 	  /* reserved */
#pragma ADDRESS 	ep0i_addr		02e0H		/* USB EP0 IN  FIFO register */
#pragma ADDRESS 	ep0o_addr		02e2H		/* USB EP0 OUT FIFO register */
#pragma ADDRESS 	ep1i_addr		02e4H		/* USB EP1 IN  FIFO register */
#pragma ADDRESS 	ep1o_addr		02e6H		/* USB EP1 OUT FIFO register */
#pragma ADDRESS 	ep2i_addr		02e8H		/* USB EP2 IN  FIFO register */
#pragma ADDRESS 	ep2o_addr		02eaH		/* USB EP2 OUT FIFO register */
#pragma ADDRESS 	ep3i_addr		02ecH		/* USB EP3 IN  FIFO register */
#pragma ADDRESS 	ep3o_addr		02eeH		/* USB EP3 OUT FIFO register */
#pragma ADDRESS 	ep4i_addr		02f0H		/* USB EP4 IN  FIFO register */
#pragma ADDRESS 	ep4o_addr		02f2H		/* USB EP4 OUT FIFO register */
#pragma ADDRESS 	fmr0_addr		02f7H		/* Flash memory control register 0 */

#pragma ADDRESS 	ssi0mr0_addr	0310H		/* Serial Sound Interface 0 mode register 0 */
#pragma ADDRESS 	ssi0mr1_addr	0311H		/* Serial Sound Interface 0 mode register 1 */
//#pragma ADDRESS	  reserved		  0312H 	  /* reserved */
//#pragma ADDRESS	  reserved		  0313H 	  /* reserved */
#pragma ADDRESS 	ssi0txb_addr	0314H		/* Serial Sound Interface 0 transmit buffer register */
#pragma ADDRESS 	ssi0rxb_addr	0316H		/* Serial Sound Interface 0 receive buffer register */
#pragma ADDRESS 	ssi0rf_addr 	0318H		/* Serial Sound Interface 0 rate feedback register */
//#pragma ADDRESS	  reserved		  031aH 	  /* reserved */
//#pragma ADDRESS	  reserved		  031bH 	  /* reserved */
#pragma ADDRESS 	u3smr4_addr 	0324H		/* UART3 special mode register 4 */
#pragma ADDRESS 	u3smr3_addr 	0325H		/* UART3 special mode register 3 */
#pragma ADDRESS 	u3smr2_addr 	0326H		/* UART3 special mode register 2 */
#pragma ADDRESS 	u3smr_addr		0327H		/* UART3 special mode register */
#pragma ADDRESS 	u3mr_addr		0328H		/* UART3 transmit/receive mode register */
#pragma ADDRESS 	u3brg_addr		0329H		/* UART3 bit rate generator */
#pragma ADDRESS 	u3tb_addr		032aH		/* UART3 transmit buffer register */
#pragma ADDRESS 	u3c0_addr		032cH		/* UART3 transmit/receive control register 0 */
#pragma ADDRESS 	u3c1_addr		032dH		/* UART3 transmit/receive control register 1 */
#pragma ADDRESS 	u3rb_addr		032eH		/* UART3 receive buffer register */
#pragma ADDRESS 	u2smr4_addr 	0334H		/* UART2 special mode register 4 */
#pragma ADDRESS 	u2smr3_addr 	0335H		/* UART2 special mode register 3 */
#pragma ADDRESS 	u2smr2_addr 	0336H		/* UART2 special mode register 2 */
#pragma ADDRESS 	u2smr_addr		0337H		/* UART2 special mode register */
#pragma ADDRESS 	u2mr_addr		0338H		/* UART2 transmit/receive mode register */
#pragma ADDRESS 	u2brg_addr		0339H		/* UART2 bit rate generator */
#pragma ADDRESS 	u2tb_addr		033aH		/* UART2 transmit buffer register */
#pragma ADDRESS 	u2c0_addr		033cH		/* UART2 transmit/receive control register 0 */
#pragma ADDRESS 	u2c1_addr		033dH		/* UART2 transmit/receive control register 1 */
#pragma ADDRESS 	u2rb_addr		033eH		/* UART2 receive buffer register */
#pragma ADDRESS 	ifsr_addr		035fH		/* interrupt cause select register */
#pragma ADDRESS 	u1smr4_addr 	0364H		/* UART1 special mode register 4 */
#pragma ADDRESS 	u1smr3_addr 	0365H		/* UART1 special mode register 3 */
#pragma ADDRESS 	u1smr2_addr 	0366H		/* UART1 special mode register 2 */
#pragma ADDRESS 	u1smr_addr		0367H		/* UART1 special mode register */
#pragma ADDRESS 	u1mr_addr		0368H		/* UART1 transmit/receive mode register */
#pragma ADDRESS 	u1brg_addr		0369H		/* UART1 bit rate generator */
#pragma ADDRESS 	u1tb_addr		036aH		/* UART1 transmit buffer register */
#pragma ADDRESS 	u1c0_addr		036cH		/* UART1 transmit/receive control register 0 */
#pragma ADDRESS 	u1c1_addr		036dH		/* UART1 transmit/receive control register 1 */
#pragma ADDRESS 	u1rb_addr		036eH		/* UART1 receive buffer register */
#pragma ADDRESS 	ssi1mr0_addr	0370H		/* Serial Sound Interface 1 mode register 0 */
#pragma ADDRESS 	ssi1mr1_addr	0371H		/* Serial Sound Interface 1 mode register 1 */
//#pragma ADDRESS	  reserved		  0372H 	  /* reserved */
//#pragma ADDRESS	  reserved		  0373H 	  /* reserved */
#pragma ADDRESS 	ssi1txb_addr	0374H		/* Serial Sound Interface 1 transmit buffer register */
#pragma ADDRESS 	ssi1rxb_addr	0376H		/* Serial Sound Interface 1 receive buffer register */
#pragma ADDRESS 	ssi1rf_addr 	0378H		/* Serial Sound Interface 1 rate feedback register */
//#pragma ADDRESS	  reserved		  037aH 	  /* reserved */
//#pragma ADDRESS	  reserved		  037bH 	  /* reserved */
#pragma ADDRESS 	tabsr_addr		0380H		/* Count start flag */
#pragma ADDRESS 	cpsrf_addr		0381H		/* Clock prescaler reset flag */
#pragma ADDRESS 	onsf_addr		0382H		/* One-shot start flag */
#pragma ADDRESS 	trgsr_addr		0383H		/* Trigger select register */
#pragma ADDRESS 	udf_addr		0384H		/* Up-down flag */
#pragma ADDRESS 	ta0_addr		0386H		/* Timer A0 register */
#pragma ADDRESS 	ta1_addr		0388H		/* Timer A1 register */
#pragma ADDRESS 	ta2_addr		038aH		/* Timer A2 register */
#pragma ADDRESS 	ta3_addr		038cH		/* Timer A3 register */
#pragma ADDRESS 	ta4_addr		038eH		/* Timer A4 register */
#pragma ADDRESS 	ta0mr_addr		0396H		/* Timer A0 mode register */
#pragma ADDRESS 	ta1mr_addr		0397H		/* Timer A1 mode register */
#pragma ADDRESS 	ta2mr_addr		0398H		/* Timer A2 mode register */
#pragma ADDRESS 	ta3mr_addr		0399H		/* Timer A3 mode register */
#pragma ADDRESS 	ta4mr_addr		039aH		/* Timer A4 mode register */
#pragma ADDRESS 	u0smr4_addr 	03a4H		/* UART0 special mode register 4 */
#pragma ADDRESS 	u0smr3_addr 	03a5H		/* UART0 special mode register 3 */
#pragma ADDRESS 	u0smr2_addr 	03a6H		/* UART0 special mode register 2 */
#pragma ADDRESS 	u0smr_addr		03a7H		/* UART0 special mode register */
#pragma ADDRESS 	u0mr_addr		03a8H		/* UART0 transmit/receive mode register */
#pragma ADDRESS 	u0brg_addr		03a9H		/* UART0 bit rate generator */
#pragma ADDRESS 	u0tb_addr		03aaH		/* UART0 transmit buffer register */
#pragma ADDRESS 	u0c0_addr		03acH		/* UART0 transmit/receive control register 0 */
#pragma ADDRESS 	u0c1_addr		03adH		/* UART0 transmit/receive control register 1 */
#pragma ADDRESS 	u0rb_addr		03aeH		/* UART0 receive buffer register */
#pragma ADDRESS 	dm2sl_addr		03b0H		/* DMA2 cause select register */
#pragma ADDRESS 	dm3sl_addr		03b2H		/* DMA3 cause select register */
#pragma ADDRESS 	crcsar_addr 	03b4H		/* CRC snoop address register */
#pragma ADDRESS 	crcmr_addr		03b6H		/* CRC mode register */
#pragma ADDRESS 	dm0sl_addr		03b8H		/* DMA0 cause select register */
#pragma ADDRESS 	dm1sl_addr		03baH		/* DMA1 cause select register */
#pragma ADDRESS 	crcd_addr		03bcH		/* CRC data register */
#pragma ADDRESS 	crcin_addr		03beH		/* CRC input register */
#pragma ADDRESS 	ad0_addr		03c0H		/* A-D register 0 */
#pragma ADDRESS 	ad1_addr		03c2H		/* A-D register 1 */
#pragma ADDRESS 	ad2_addr		03c4H		/* A-D register 2 */
#pragma ADDRESS 	ad3_addr		03c6H		/* A-D register 3 */
#pragma ADDRESS 	ad4_addr		03c8H		/* A-D register 4 */
#pragma ADDRESS 	ad5_addr		03caH		/* A-D register 5 */
#pragma ADDRESS 	ad6_addr		03ccH		/* A-D register 6 */
#pragma ADDRESS 	ad7_addr		03ceH		/* A-D register 7 */
#pragma ADDRESS 	adcon2_addr 	03d4H		/* A-D control register 2 */
#pragma ADDRESS 	adcon0_addr 	03d6H		/* A-D control register 0 */
#pragma ADDRESS 	adcon1_addr 	03d7H		/* A-D control register 1 */
#pragma ADDRESS 	fsccr_addr		03dbH		/* Frequency synthesizer clock control */
#pragma ADDRESS 	fsc_addr		03dcH		/* Frequency synthesizer control */
#pragma ADDRESS 	fsm_addr		03ddH		/* Frequency synthesizer multiply register */
#pragma ADDRESS 	fsp_addr		03deH		/* Frequency synthesizer prescaler register */
#pragma ADDRESS 	fsd_addr		03dfH		/* Frequency synthesizer divider */
#pragma ADDRESS 	p0_addr 		03e0H		/* Port P0 register */
#pragma ADDRESS 	p1_addr 		03e1H		/* Port P1 register */
#pragma ADDRESS 	pd0_addr		03e2H		/* Port P0 direction register */
#pragma ADDRESS 	pd1_addr		03e3H		/* Port P1 direction register */
#pragma ADDRESS 	p2_addr 		03e4H		/* Port P2 register */
#pragma ADDRESS 	p3_addr 		03e5H		/* Port P3 register */
#pragma ADDRESS 	pd2_addr		03e6H		/* Port P2 direction register */
#pragma ADDRESS 	pd3_addr		03e7H		/* Port P3 direction register */
#pragma ADDRESS 	p4_addr 		03e8H		/* Port P4 register */
#pragma ADDRESS 	p5_addr 		03e9H		/* Port P5 register */
#pragma ADDRESS 	pd4_addr		03eaH		/* Port P4 direction register */
#pragma ADDRESS 	pd5_addr		03ebH		/* Port P5 direction register */
#pragma ADDRESS 	p6_addr 		03ecH		/* Port P6 register */
#pragma ADDRESS 	p7_addr 		03edH		/* Port P7 register */
#pragma ADDRESS 	pd6_addr		03eeH		/* Port P6 direction register */
#pragma ADDRESS 	pd7_addr		03efH		/* Port P7 direction register */
#pragma ADDRESS 	p8_addr 		03f0H		/* Port P8 register */
#pragma ADDRESS 	p9_addr 		03f1H		/* Port P9 register */
#pragma ADDRESS 	pd8_addr		03f2H		/* Port P8 direction register */
#pragma ADDRESS 	pd9_addr		03f3H		/* Port P9 direction register */
#pragma ADDRESS 	p10_addr		03f4H		/* Port P10 register */
#pragma ADDRESS 	pd10_addr		03f6H		/* Port P10 direction register */
#pragma ADDRESS 	kupm_addr		03f9H		/* Key-input mode register */
#pragma ADDRESS 	p7dr_addr		03faH		/* P7 drive capacity */
#pragma ADDRESS 	pur0_addr		03fcH		/* Pull-up control register 0 */
#pragma ADDRESS 	pur1_addr		03fdH		/* Pull-up control register 1 */
#pragma ADDRESS 	pur2_addr		03feH		/* Pull-up control register 2 */
#pragma ADDRESS 	pcr_addr		03ffH		/* Port control register */

/**********************************************/
/*			   declare SFR char 			  */
/**********************************************/
/*----------------------------------------------
	Watchdog Timer
----------------------------------------------*/
unsigned char	wdts_addr;			/* Watchdog timer start register */
#define 	wdts	wds_addr

/*----------------------------------------------
	Serial function registers
----------------------------------------------*/
unsigned char	u0brg_addr; 		/* UART0 bit rate generator */
#define 	u0brg	u0brg_addr
unsigned char	u1brg_addr; 		/* UART1 bit rate generator */
#define 	u1brg	u1brg_addr
unsigned char	u2brg_addr; 		/* UART2 bit rate generator */
#define 	u2brg	u2brg_addr
unsigned char	u3brg_addr; 		/* UART3 bit rate generator */
#define 	u3brg	u3brg_addr

/*----------------------------------------------
	CRC calculation circuit
----------------------------------------------*/
unsigned char	crcin_addr; 		/* CRC input register */
#define 	crcin	crcin_addr

/*----------------------------------------------
	Frequency synthesizer
----------------------------------------------*/
unsigned char	fsm_addr;			/* Frequency synthesizer multiply register */
#define 	fsm 	fsm_addr
unsigned char	fsp_addr;			/* Frequency synthesizer prescaler register */
#define 	fsp 	fsp_addr
unsigned char	fsd_addr;			/* Frequency synthesizer divider */
#define 	fsd 	fsd_addr

/*----------------------------------------------
	Timer A   Up-down flag ; Use "MOV" instruction when writing to this register.
----------------------------------------------*/
unsigned char	udf_addr;			/* UP-down flag */
#define 	udf 	udf_addr

/**********************************************/
/*				declare SFR int 			  */
/**********************************************/
/*----------------------------------------------
	DMAC
----------------------------------------------*/
unsigned short	tcr0_addr;
#define 	tcr0	tcr0_addr		/* DMA0 transfer counter */
unsigned short	tcr1_addr;
#define 	tcr1	tcr1_addr		/* DMA1 transfer counter */
unsigned short	tcr2_addr;
#define 	tcr2	tcr2_addr		/* DMA2 transfer counter */
unsigned short	tcr3_addr;
#define 	tcr3	tcr3_addr		/* DMA3 transfer counter */

/*----------------------------------------------
	Timer A : Read and write data in 16-bit units.
----------------------------------------------*/
unsigned short	ta0_addr;			/* Timer A0 register */
#define 	ta0 	 ta0_addr
unsigned short	ta1_addr;			/* Timer A1 register */
#define 	ta1 	 ta1_addr
unsigned short	ta2_addr;			/* Timer A2 register */
#define 	ta2 	 ta2_addr
unsigned short	ta3_addr;			/* Timer A3 register */
#define 	ta3 	 ta3_addr
unsigned short	ta4_addr;			/* Timer A4 register */
#define 	ta4 	 ta4_addr

/*----------------------------------------------
	Serial function registers
----------------------------------------------*/
unsigned short	  ssi0txb_addr; 	/* Serial Sound Interface 0 transmit buffer register */
#define 	ssi0txb  ssi0txb_addr
unsigned short	  ssi0rxb_addr; 	/* Serial Sound Interface 0 receive buffer register */
#define 	ssi0rxb  ssi0rxb_addr
unsigned short	  ssi0rf_addr;		/* Serial Sound Interface 0 rate feedback register */
#define 	ssi0rf	 ssi0rf_addr

unsigned short	  ssi1txb_addr; 	/* Serial Sound Interface 1 transmit buffer register */
#define 	ssi1txb  ssi1txb_addr
unsigned short	  ssi1rxb_addr; 	/* Serial Sound Interface 1 receive buffer register */
#define 	ssi1rxb  ssi1rxb_addr
unsigned short	  ssi1rf_addr;		/* Serial Sound Interface 1 rate feedback register */
#define 	ssi1rf	 ssi1rf_addr

/*----------------------------------------------
	CRC calculation circuit
----------------------------------------------*/
unsigned short	  crcd_addr;		/* CRC data register */
#define 	crcd	 crcd_addr

/**********************************************/
/*			 declare SFR union bit			  */
/**********************************************/
/*============================================*/
/*				declare bit (byte)			  */
/*============================================*/
struct bit_def {
		char	b0:1;
		char	b1:1;
		char	b2:1;
		char	b3:1;
		char	b4:1;
		char	b5:1;
		char	b6:1;
		char	b7:1;
};
union byte_def{
	struct bit_def bit;
	unsigned char  byte;
};
/*============================================*/
/*				  Processor Mode			  */
/*============================================*/
/*----------------------------------------------
	Protect register
----------------------------------------------*/
union byte_def prcr_addr;
#define 	prcr	prcr_addr.byte

#define 	prc0		prcr_addr.bit.b0	/* Enables writing to system clock control registers 0 and 1 and Frequency Synthesizer registers */
#define 	prc1		prcr_addr.bit.b1	/* Enables writing to processor mode registers 0 and 1 */

/*----------------------------------------------
	Processor mode register 0
----------------------------------------------*/
union byte_def pm0_addr;
#define 	pm0 	pm0_addr.byte

#define 	pm00		pm0_addr.bit.b0 	/* Processor mode bit */
#define 	pm01		pm0_addr.bit.b1 	/* Processor mode bit */
#define 	pm02		pm0_addr.bit.b2 	/* R/W mode select bit */
#define 	pm03		pm0_addr.bit.b3 	/* Software reset bit */

#define 	pm06		pm0_addr.bit.b6 	/* Port P40 to P43 function select bit */
#define 	pm07		pm0_addr.bit.b7 	/* BCLK output disable bit */

/*----------------------------------------------
	Processor mode register 1
----------------------------------------------*/
union byte_def pm1_addr;
#define 	pm1 	pm1_addr.byte

#define 	pm16		pm1_addr.bit.b6 	/* W~R~ length control bit */
#define 	pm17		pm1_addr.bit.b7 	/* Wait bit */

/*----------------------------------------------
	Chip select control register
----------------------------------------------*/
union byte_def csr_addr;
#define 	csr 	csr_addr.byte

#define 	cs0 		csr_addr.bit.b0 	/* CS0~ output enable bit */
#define 	cs1 		csr_addr.bit.b1 	/* CS1~ output enable bit */
#define 	cs2 		csr_addr.bit.b2 	/* CS2~ output enable bit */
#define 	cs3 		csr_addr.bit.b3 	/* CS3~ output enable bit */
#define 	cs0w		csr_addr.bit.b4 	/* CS0~ wait bit */
#define 	cs1w		csr_addr.bit.b5 	/* CS1~ wait bit */
#define 	cs2w		csr_addr.bit.b6 	/* CS2~ wait bit */
#define 	cs3w		csr_addr.bit.b7 	/* CS3~ wait bit */
/*----------------------------------------------
	Chip select expansion register
----------------------------------------------*/
union byte_def cse_addr;
#define 	cse 	cse_addr.byte

#define 	cse0w0		cse_addr.bit.b0 	/* CS0~ wait expansion bit */
#define 	cse0w1		cse_addr.bit.b1 	/* CS0~ wait expansion bit */
#define 	cse1w0		cse_addr.bit.b2 	/* CS1~ wait expansion bit */
#define 	cse1w1		cse_addr.bit.b3 	/* CS1~ wait expansion bit */
#define 	cse2w0		cse_addr.bit.b4 	/* CS2~ wait expansion bit */
#define 	cse2w1		cse_addr.bit.b5 	/* CS2~ wait expansion bit */
#define 	cse3w0		cse_addr.bit.b6 	/* CS3~ wait expansion bit */
#define 	cse3w1		cse_addr.bit.b7 	/* CS3~ wait expansion bit */

/*============================================*/
/*			  System Clock Control			  */
/*============================================*/
/*----------------------------------------------
	System clock control register 0
----------------------------------------------*/
union byte_def cm0_addr;
#define 	cm0 	cm0_addr.byte

#define 	cm02		cm0_addr.bit.b2 	/* WAIT peripheral function clock stop bit */
#define 	cm03		cm0_addr.bit.b3 	/* Xcin-Xcout drive capacity select bit */
#define 	cm04		cm0_addr.bit.b4 	/* Port Xc select bit */
#define 	cm05		cm0_addr.bit.b5 	/* Main clock stop bit */
#define 	cm06		cm0_addr.bit.b6 	/* Main clock division select bit 0 */
#define 	cm07		cm0_addr.bit.b7 	/* System clock select bit */

/*----------------------------------------------
	System clock control register 1
----------------------------------------------*/
union byte_def cm1_addr;
#define 	cm1 	cm1_addr.byte

#define 	cm10		cm1_addr.bit.b0 	/* All clock stop control bit */

#define 	cm15		cm1_addr.bit.b5 	/* Xin-Xout drive capacity select bit */
#define 	cm16		cm1_addr.bit.b6 	/* Main clock division select bit 1 */
#define 	cm17		cm1_addr.bit.b7 	/* Main clock division select bit 1 */

/*============================================*/
/*		  Frequency Synthesizer Control 	  */
/*============================================*/
/*----------------------------------------------
	Frequency Synthesizer Control register
----------------------------------------------*/
union byte_def fsc_addr;
#define 	fsc 	fsc_addr.byte

#define 	fse 		fsc_addr.bit.b0 	/* Frequency Synthesizer enable bit */
#define 	vco0		fsc_addr.bit.b1 	/* VCO Gain Control 0 */
#define 	vco1		fsc_addr.bit.b2 	/* VCO Gain Control 1 */

#define 	chg0		fsc_addr.bit.b5 	/* LPF Current Control 0 */
#define 	chg1		fsc_addr.bit.b6 	/* LPF Current Control 1 */
#define 	ls			fsc_addr.bit.b7 	/* Frequency Synthesizer Lock Status */

/*----------------------------------------------
	Frequency synthesizer clock control register
----------------------------------------------*/
union byte_def fsccr_addr;
#define 	fsccr	fsccr_addr.byte

#define 	fsccr0		fsccr_addr.bit.b0	  /* Clock source selection */

#define 	fsccr4		fsccr_addr.bit.b4	  /* Divide-by-3 option */

/*============================================*/
/*					Interrupts				  */
/*============================================*/
/*----------------------------------------------
	Address match interrupt enable register
----------------------------------------------*/
union byte_def aier_addr;
#define 	aier	aier_addr.byte

#define 	aier0		aier_addr.bit.b0	/* Address match interrupt 0 enable bit */
#define 	aier1		aier_addr.bit.b1	/* Address match interrupt 1 enable bit */

/*----------------------------------------------
	interrupt cause select register
----------------------------------------------*/
union byte_def ifsr_addr;
#define 	ifsr	ifsr_addr.byte

#define 	ifsr0		ifsr_addr.bit.b0		/* INT0~ interrupt polarity switching bit */
#define 	ifsr1		ifsr_addr.bit.b1		/* INT1~ interrupt polarity switching bit */
#define 	ifsr2		ifsr_addr.bit.b2		/* INT2~ interrupt polarity switching bit */
#define 	ifsr3		ifsr_addr.bit.b3		/* INT3~ interrupt polarity switching bit */

#define 	ifsr6		ifsr_addr.bit.b6		/* Bus collusion interrupt request cause select bit 0 */
#define 	ifsr7		ifsr_addr.bit.b7		/* Bus collusion interrupt request cause select bit 1 */

/*----------------------------------------------
	Key-input mode register
----------------------------------------------*/
union byte_def kupm_addr;
#define 	kupm	kupm_addr.byte

#define 	kis0		kupm_addr.bit.b0		/* P10 Key-input edge select 0 */
#define 	kis1		kupm_addr.bit.b1		/* P10 Key-input edge select 1 */
#define 	kie0		kupm_addr.bit.b2		/* P10 0/P10 1 Key-input enable bit */
#define 	kie1		kupm_addr.bit.b3		/* P10 2/P10 3 Key-input enable bit */
#define 	kie2		kupm_addr.bit.b4		/* P10 4/P10 5 Key-input enable bit */
#define 	kie3		kupm_addr.bit.b5		/* P10 6/P10 7 Key-input enable bit */

/*============================================*/
/*				 Watchdog Timer 			  */
/*============================================*/
/*----------------------------------------------
	Watchdog timer control register
----------------------------------------------*/
union byte_def wdc_addr;
#define 	wdc 	wdc_addr.byte

#define 	wdc7		wdc_addr.bit.b7 	/* Prescaler select bit */

/*============================================*/
/*			   Universal Serial Bus 		  */
/*============================================*/
/*----------------------------------------------
	USB control register
----------------------------------------------*/
union byte_def usbc_addr;
#define 	usbc	usbc_addr.byte

#define 	usbc5		usbc_addr.bit.b5	/* USB clock enable bit */
#define 	usbc6		usbc_addr.bit.b6	/* USB SOF port select bit */
#define 	usbc7		usbc_addr.bit.b7	/* USB enable bit */

/*----------------------------------------------
	USB Attach/Detach register
----------------------------------------------*/
union byte_def usbad_addr;
#define 	usbad	usbad_addr.byte

#define 	p90_second	usbad_addr.bit.b0	 /* Port 90-Second */
#define 	attach_detach	usbad_addr.bit.b1	 /* Attach/Detach */

#define 	vbdt		usbad_addr.bit.b7	 /* Vbus detect enable */

/*============================================*/
/*					Timer A 				  */
/*============================================*/
/*----------------------------------------------
	Trigger select register
----------------------------------------------*/
union byte_def trgsr_addr;
#define 	trgsr	trgsr_addr.byte

#define 	ta1tgl		trgsr_addr.bit.b0	/* Timer A1 event/trigger select bit */
#define 	ta1tgh		trgsr_addr.bit.b1	/* Timer A1 event/trigger select bit */
#define 	ta2tgl		trgsr_addr.bit.b2	/* Timer A2 event/trigger select bit */
#define 	ta2tgh		trgsr_addr.bit.b3	/* Timer A2 event/trigger select bit */
#define 	ta3tgl		trgsr_addr.bit.b4	/* Timer A3 event/trigger select bit */
#define 	ta3tgh		trgsr_addr.bit.b5	/* Timer A3 event/trigger select bit */
#define 	ta4tgl		trgsr_addr.bit.b6	/* Timer A4 event/trigger select bit */
#define 	ta4tgh		trgsr_addr.bit.b7	/* Timer A4 event/trigger select bit */

/*----------------------------------------------
	Count start flag
----------------------------------------------*/
union byte_def tabsr_addr;
#define 	tabsr	tabsr_addr.byte

#define 	ta0s		tabsr_addr.bit.b0	/* Timer A0 count start flag */
#define 	ta1s		tabsr_addr.bit.b1	/* Timer A1 count start flag */
#define 	ta2s		tabsr_addr.bit.b2	/* Timer A2 count start flag */
#define 	ta3s		tabsr_addr.bit.b3	/* Timer A3 count start flag */
#define 	ta4s		tabsr_addr.bit.b4	/* Timer A4 count start flag */

/*----------------------------------------------
	Clock prescaler reset flag
----------------------------------------------*/
union byte_def cpsrf_addr;
#define 	cpsrf	cpsrf_addr.byte

#define 	cpsr		cpsrf_addr.bit.b7	/* Clock prescaler reset flag */

/*----------------------------------------------
	One-shot start flag
----------------------------------------------*/
union byte_def onsf_addr;
#define 	onsf	onsf_addr.byte

#define 	ta0os		onsf_addr.bit.b0	/* Timer A0 one-shot start flag */
#define 	ta1os		onsf_addr.bit.b1	/* Timer A1 one-shot start flag */
#define 	ta2os		onsf_addr.bit.b2	/* Timer A2 one-shot start flag */
#define 	ta3os		onsf_addr.bit.b3	/* Timer A3 one-shot start flag */
#define 	ta4os		onsf_addr.bit.b4	/* Timer A4 one-shot start flag */

#define 	ta0tgl		onsf_addr.bit.b6	/* Timer A0 event/trigger select bit */
#define 	ta0tgh		onsf_addr.bit.b7	/* Timer A0 event/trigger select bit */

/*============================================*/
/*				  A-D Convertor 			  */
/*============================================*/
/*----------------------------------------------
	A-D control register 0
----------------------------------------------*/
union byte_def adcon0_addr;
#define 	adcon0	adcon0_addr.byte

#define 	ch0 		adcon0_addr.bit.b0	/* Analog input pin select bit */
#define 	ch1 		adcon0_addr.bit.b1	/* Analog input pin select bit */
#define 	ch2 		adcon0_addr.bit.b2	/* Analog input pin select bit */
#define 	md0 		adcon0_addr.bit.b3	/* A-D operation mode select bit 0 */
#define 	md1 		adcon0_addr.bit.b4	/* A-D operation mode select bit 0 */
#define 	trg 		adcon0_addr.bit.b5	/* Trigger select bit */
#define 	adst		adcon0_addr.bit.b6	/* A-D conversion start flag */
#define 	cks0		adcon0_addr.bit.b7	/* Frequency select bit 0 */

/*----------------------------------------------
	A-D control register 1
----------------------------------------------*/
union byte_def adcon1_addr;
#define 	adcon1	adcon1_addr.byte

#define 	scan0		adcon1_addr.bit.b0	/* A-D sweep pin select bit */
#define 	scan1		adcon1_addr.bit.b1	/* A-D sweep pin select bit */
#define 	md2 		adcon1_addr.bit.b2	/* A-D operation mode select bit 1 */
#define 	bits		adcon1_addr.bit.b3	/* 8/10-bit mode select bit */
#define 	cks1		adcon1_addr.bit.b4	/* Frequency select bit 1 */
#define 	vcut		adcon1_addr.bit.b5	/* Vref connect bit */

/*----------------------------------------------
	A-D control register 2
----------------------------------------------*/
union byte_def adcon2_addr;
#define 	adcon2	adcon2_addr.byte

#define 	smp 		adcon2_addr.bit.b0	/* A-D conversion method select bit */

/*============================================*/
/*			 CRC calculation circuit		  */
/*============================================*/
/*----------------------------------------------
	CRC mode register
----------------------------------------------*/
union byte_def	crcmr_addr;
#define 	crcmr	crcmr_addr.byte

#define 	crcps		crcmr_addr.bit.b0	/* CRC mode polynomial selection bit */

#define 	crcms		crcmr_addr.bit.b7	/* CRC mode mode selection bit */

/*============================================*/
/*			  Programable I/O ports 		  */
/*============================================*/
/*----------------------------------------------
	Port P0 register
----------------------------------------------*/
union byte_def p0_addr;
#define 	p0		p0_addr.byte

#define 	p0_0		p0_addr.bit.b0		/* Port P0	bit0 */
#define 	p0_1		p0_addr.bit.b1		/* Port P0	bit1 */
#define 	p0_2		p0_addr.bit.b2		/* Port P0	bit2 */
#define 	p0_3		p0_addr.bit.b3		/* Port P0	bit3 */
#define 	p0_4		p0_addr.bit.b4		/* Port P0	bit4 */
#define 	p0_5		p0_addr.bit.b5		/* Port P0	bit5 */
#define 	p0_6		p0_addr.bit.b6		/* Port P0	bit6 */
#define 	p0_7		p0_addr.bit.b7		/* Port P0	bit7 */

/*----------------------------------------------
	Port P0 direction register
----------------------------------------------*/
union byte_def pd0_addr;
#define 	pd0 	pd0_addr.byte

#define 	pd0_0		pd0_addr.bit.b0 	/* P0 direction register  bit0 */
#define 	pd0_1		pd0_addr.bit.b1 	/* P0 direction register  bit1 */
#define 	pd0_2		pd0_addr.bit.b2 	/* P0 direction register  bit2 */
#define 	pd0_3		pd0_addr.bit.b3 	/* P0 direction register  bit3 */
#define 	pd0_4		pd0_addr.bit.b4 	/* P0 direction register  bit4 */
#define 	pd0_5		pd0_addr.bit.b5 	/* P0 direction register  bit5 */
#define 	pd0_6		pd0_addr.bit.b6 	/* P0 direction register  bit6 */
#define 	pd0_7		pd0_addr.bit.b7 	/* P0 direction register  bit7 */

/*----------------------------------------------
	Port P1 register
----------------------------------------------*/
union byte_def p1_addr;
#define 	p1		p1_addr.byte

#define 	p1_0		p1_addr.bit.b0		/* Port P1	bit0 */
#define 	p1_1		p1_addr.bit.b1		/* Port P1	bit1 */
#define 	p1_2		p1_addr.bit.b2		/* Port P1	bit2 */
#define 	p1_3		p1_addr.bit.b3		/* Port P1	bit3 */
#define 	p1_4		p1_addr.bit.b4		/* Port P1	bit4 */
#define 	p1_5		p1_addr.bit.b5		/* Port P1	bit5 */
#define 	p1_6		p1_addr.bit.b6		/* Port P1	bit6 */
#define 	p1_7		p1_addr.bit.b7		/* Port P1	bit7 */

/*----------------------------------------------
	Port P1 direction register
----------------------------------------------*/
union byte_def pd1_addr;
#define 	pd1 	pd1_addr.byte

#define 	pd1_0		pd1_addr.bit.b0 	/* P1 direction register  bit0 */
#define 	pd1_1		pd1_addr.bit.b1 	/* P1 direction register  bit1 */
#define 	pd1_2		pd1_addr.bit.b2 	/* P1 direction register  bit2 */
#define 	pd1_3		pd1_addr.bit.b3 	/* P1 direction register  bit3 */
#define 	pd1_4		pd1_addr.bit.b4 	/* P1 direction register  bit4 */
#define 	pd1_5		pd1_addr.bit.b5 	/* P1 direction register  bit5 */
#define 	pd1_6		pd1_addr.bit.b6 	/* P1 direction register  bit6 */
#define 	pd1_7		pd1_addr.bit.b7 	/* P1 direction register  bit7 */

/*----------------------------------------------
	Port P2 direction register
----------------------------------------------*/
union byte_def p2_addr;
#define 	p2		p2_addr.byte

#define 	p2_0		p2_addr.bit.b0		/* Port P2	bit0 */
#define 	p2_1		p2_addr.bit.b1		/* Port P2	bit1 */
#define 	p2_2		p2_addr.bit.b2		/* Port P2	bit2 */
#define 	p2_3		p2_addr.bit.b3		/* Port P2	bit3 */
#define 	p2_4		p2_addr.bit.b4		/* Port P2	bit4 */
#define 	p2_5		p2_addr.bit.b5		/* Port P2	bit5 */
#define 	p2_6		p2_addr.bit.b6		/* Port P2	bit6 */
#define 	p2_7		p2_addr.bit.b7		/* Port P2	bit7 */

/*----------------------------------------------
	Port P2 register
----------------------------------------------*/
union byte_def pd2_addr;
#define 	pd2 	pd2_addr.byte

#define 	pd2_0		pd2_addr.bit.b0 	/* P2 direction register  bit0 */
#define 	pd2_1		pd2_addr.bit.b1 	/* P2 direction register  bit1 */
#define 	pd2_2		pd2_addr.bit.b2 	/* P2 direction register  bit2 */
#define 	pd2_3		pd2_addr.bit.b3 	/* P2 direction register  bit3 */
#define 	pd2_4		pd2_addr.bit.b4 	/* P2 direction register  bit4 */
#define 	pd2_5		pd2_addr.bit.b5 	/* P2 direction register  bit5 */
#define 	pd2_6		pd2_addr.bit.b6 	/* P2 direction register  bit6 */
#define 	pd2_7		pd2_addr.bit.b7 	/* P2 direction register  bit7 */

/*----------------------------------------------
	Port P3 direction register
----------------------------------------------*/
union byte_def p3_addr;
#define 	p3		p3_addr.byte

#define 	p3_0		p3_addr.bit.b0		/* Port P3	bit0 */
#define 	p3_1		p3_addr.bit.b1		/* Port P3	bit1 */
#define 	p3_2		p3_addr.bit.b2		/* Port P3	bit2 */
#define 	p3_3		p3_addr.bit.b3		/* Port P3	bit3 */
#define 	p3_4		p3_addr.bit.b4		/* Port P3	bit4 */
#define 	p3_5		p3_addr.bit.b5		/* Port P3	bit5 */
#define 	p3_6		p3_addr.bit.b6		/* Port P3	bit6 */
#define 	p3_7		p3_addr.bit.b7		/* Port P3	bit7 */

/*----------------------------------------------
	Port P3 register
----------------------------------------------*/
union byte_def pd3_addr;
#define 	pd3 	pd3_addr.byte

#define 	pd3_0		pd3_addr.bit.b0 	/* P3 direction register  bit0 */
#define 	pd3_1		pd3_addr.bit.b1 	/* P3 direction register  bit1 */
#define 	pd3_2		pd3_addr.bit.b2 	/* P3 direction register  bit2 */
#define 	pd3_3		pd3_addr.bit.b3 	/* P3 direction register  bit3 */
#define 	pd3_4		pd3_addr.bit.b4 	/* P3 direction register  bit4 */
#define 	pd3_5		pd3_addr.bit.b5 	/* P3 direction register  bit5 */
#define 	pd3_6		pd3_addr.bit.b6 	/* P3 direction register  bit6 */
#define 	pd3_7		pd3_addr.bit.b7 	/* P3 direction register  bit7 */

/*----------------------------------------------
	Port P4 register
----------------------------------------------*/
union byte_def p4_addr;
#define 	p4		p4_addr.byte

#define 	p4_0		p4_addr.bit.b0		/* Port P4	bit0 */
#define 	p4_1		p4_addr.bit.b1		/* Port P4	bit1 */
#define 	p4_2		p4_addr.bit.b2		/* Port P4	bit2 */
#define 	p4_3		p4_addr.bit.b3		/* Port P4	bit3 */
#define 	p4_4		p4_addr.bit.b4		/* Port P4	bit4 */
#define 	p4_5		p4_addr.bit.b5		/* Port P4	bit5 */
#define 	p4_6		p4_addr.bit.b6		/* Port P4	bit6 */
#define 	p4_7		p4_addr.bit.b7		/* Port P4	bit7 */

/*----------------------------------------------
	Port P4 direction register
----------------------------------------------*/
union byte_def pd4_addr;
#define 	pd4 	pd4_addr.byte

#define 	pd4_0		pd4_addr.bit.b0 	/* P4 direction register  bit0 */
#define 	pd4_1		pd4_addr.bit.b1 	/* P4 direction register  bit1 */
#define 	pd4_2		pd4_addr.bit.b2 	/* P4 direction register  bit2 */
#define 	pd4_3		pd4_addr.bit.b3 	/* P4 direction register  bit3 */
#define 	pd4_4		pd4_addr.bit.b4 	/* P4 direction register  bit4 */
#define 	pd4_5		pd4_addr.bit.b5 	/* P4 direction register  bit5 */
#define 	pd4_6		pd4_addr.bit.b6 	/* P4 direction register  bit6 */
#define 	pd4_7		pd4_addr.bit.b7 	/* P4 direction register  bit7 */

/*----------------------------------------------
	Port P5 register
----------------------------------------------*/
union byte_def p5_addr;
#define 	p5		p5_addr.byte

#define 	p5_0		p5_addr.bit.b0		/* Port P5	bit0 */
#define 	p5_1		p5_addr.bit.b1		/* Port P5	bit1 */
#define 	p5_2		p5_addr.bit.b2		/* Port P5	bit2 */
#define 	p5_3		p5_addr.bit.b3		/* Port P5	bit3 */
#define 	p5_4		p5_addr.bit.b4		/* Port P5	bit4 */
#define 	p5_5		p5_addr.bit.b5		/* Port P5	bit5 */
#define 	p5_6		p5_addr.bit.b6		/* Port P5	bit6 */
#define 	p5_7		p5_addr.bit.b7		/* Port P5	bit7 */

/*----------------------------------------------
	Port P5 direction register
----------------------------------------------*/
union byte_def pd5_addr;
#define 	pd5 	pd5_addr.byte

#define 	pd5_0		pd5_addr.bit.b0 	/* P5 direction register  bit0 */
#define 	pd5_1		pd5_addr.bit.b1 	/* P5 direction register  bit1 */
#define 	pd5_2		pd5_addr.bit.b2 	/* P5 direction register  bit2 */
#define 	pd5_3		pd5_addr.bit.b3 	/* P5 direction register  bit3 */
#define 	pd5_4		pd5_addr.bit.b4 	/* P5 direction register  bit4 */
#define 	pd5_5		pd5_addr.bit.b5 	/* P5 direction register  bit5 */
#define 	pd5_6		pd5_addr.bit.b6 	/* P5 direction register  bit6 */
#define 	pd5_7		pd5_addr.bit.b7 	/* P5 direction register  bit7 */

/*----------------------------------------------
	Port P6 register
----------------------------------------------*/
union byte_def p6_addr;
#define 	p6		p6_addr.byte

#define 	p6_0		p6_addr.bit.b0		/* Port P6	bit0 */
#define 	p6_1		p6_addr.bit.b1		/* Port P6	bit1 */
#define 	p6_2		p6_addr.bit.b2		/* Port P6	bit2 */
#define 	p6_3		p6_addr.bit.b3		/* Port P6	bit3 */
#define 	p6_4		p6_addr.bit.b4		/* Port P6	bit4 */
#define 	p6_5		p6_addr.bit.b5		/* Port P6	bit5 */
#define 	p6_6		p6_addr.bit.b6		/* Port P6	bit6 */
#define 	p6_7		p6_addr.bit.b7		/* Port P6	bit7 */

/*----------------------------------------------
	Port P6 direction register
----------------------------------------------*/
union byte_def pd6_addr;
#define 	pd6 	pd6_addr.byte

#define 	pd6_0		pd6_addr.bit.b0 	/* P6 direction register  bit0 */
#define 	pd6_1		pd6_addr.bit.b1 	/* P6 direction register  bit1 */
#define 	pd6_2		pd6_addr.bit.b2 	/* P6 direction register  bit2 */
#define 	pd6_3		pd6_addr.bit.b3 	/* P6 direction register  bit3 */
#define 	pd6_4		pd6_addr.bit.b4 	/* P6 direction register  bit4 */
#define 	pd6_5		pd6_addr.bit.b5 	/* P6 direction register  bit5 */
#define 	pd6_6		pd6_addr.bit.b6 	/* P6 direction register  bit6 */
#define 	pd6_7		pd6_addr.bit.b7 	/* P6 direction register  bit7 */

/*----------------------------------------------
	Port P7 register
----------------------------------------------*/
union byte_def p7_addr;
#define 	p7		p7_addr.byte

#define 	p7_0		p7_addr.bit.b0		/* Port P7	bit0 */
#define 	p7_1		p7_addr.bit.b1		/* Port P7	bit1 */
#define 	p7_2		p7_addr.bit.b2		/* Port P7	bit2 */
#define 	p7_3		p7_addr.bit.b3		/* Port P7	bit3 */
#define 	p7_4		p7_addr.bit.b4		/* Port P7	bit4 */
#define 	p7_5		p7_addr.bit.b5		/* Port P7	bit5 */
#define 	p7_6		p7_addr.bit.b6		/* Port P7	bit6 */
#define 	p7_7		p7_addr.bit.b7		/* Port P7	bit7 */

/*----------------------------------------------
	Port P7 direction register
----------------------------------------------*/
union byte_def pd7_addr;
#define 	pd7 	pd7_addr.byte

#define 	pd7_0		pd7_addr.bit.b0 	/* P7 direction register  bit0 */
#define 	pd7_1		pd7_addr.bit.b1 	/* P7 direction register  bit1 */
#define 	pd7_2		pd7_addr.bit.b2 	/* P7 direction register  bit2 */
#define 	pd7_3		pd7_addr.bit.b3 	/* P7 direction register  bit3 */
#define 	pd7_4		pd7_addr.bit.b4 	/* P7 direction register  bit4 */
#define 	pd7_5		pd7_addr.bit.b5 	/* P7 direction register  bit5 */
#define 	pd7_6		pd7_addr.bit.b6 	/* P7 direction register  bit6 */
#define 	pd7_7		pd7_addr.bit.b7 	/* P7 direction register  bit7 */

/*----------------------------------------------
	Port P8 register
----------------------------------------------*/
union byte_def p8_addr;
#define 	p8		p8_addr.byte

#define 	p8_0		p8_addr.bit.b0		/* Port P8	bit0 */
#define 	p8_1		p8_addr.bit.b1		/* Port P8	bit1 */
#define 	p8_2		p8_addr.bit.b2		/* Port P8	bit2 */
#define 	p8_3		p8_addr.bit.b3		/* Port P8	bit3 */
#define 	p8_4		p8_addr.bit.b4		/* Port P8	bit4 */
#define 	p8_5		p8_addr.bit.b5		/* Port P8	bit5 */
#define 	p8_6		p8_addr.bit.b6		/* Port P8	bit6 */
#define 	p8_7		p8_addr.bit.b7		/* Port P8	bit7 */

/*----------------------------------------------
	Port P8 direction register
----------------------------------------------*/
union byte_def pd8_addr;
#define 	pd8 	pd8_addr.byte

#define 	pd8_0		pd8_addr.bit.b0 	/* P8 direction register  bit0 */
#define 	pd8_1		pd8_addr.bit.b1 	/* P8 direction register  bit1 */
#define 	pd8_2		pd8_addr.bit.b2 	/* P8 direction register  bit2 */
#define 	pd8_3		pd8_addr.bit.b3 	/* P8 direction register  bit3 */
#define 	pd8_4		pd8_addr.bit.b4 	/* P8 direction register  bit4 */

#define 	pd8_6		pd8_addr.bit.b6 	/* P8 direction register  bit6 */
#define 	pd8_7		pd8_addr.bit.b7 	/* P8 direction register  bit7 */

/*----------------------------------------------
	Port P9 register
----------------------------------------------*/
union byte_def p9_addr;
#define 	p9		p9_addr.byte

#define 	p9_0		p9_addr.bit.b0		/* Port P9	bit0 */
#define 	vbds		p9_addr.bit.b1		/* Vbus detect state bit */
#define 	p9_2		p9_addr.bit.b2		/* Port P9	bit2 */
#define 	p9_3		p9_addr.bit.b3		/* Port P9	bit3 */

/*----------------------------------------------
	Port P9 direction register
----------------------------------------------*/
union byte_def pd9_addr;
#define 	pd9 	pd9_addr.byte

#define 	pd9_0		pd9_addr.bit.b0 	/* P9 direction register  bit0 */

#define 	pd9_2		pd9_addr.bit.b2 	/* P9 direction register  bit2 */
#define 	pd9_3		pd9_addr.bit.b3 	/* P9 direction register  bit3 */

/*----------------------------------------------
	Port P10 register
----------------------------------------------*/
union byte_def p10_addr;
#define 	p10 	p10_addr.byte

#define 	p10_0		p10_addr.bit.b0 	/* Port P10  bit0 */
#define 	p10_1		p10_addr.bit.b1 	/* Port P10  bit1 */
#define 	p10_2		p10_addr.bit.b2 	/* Port P10  bit2 */
#define 	p10_3		p10_addr.bit.b3 	/* Port P10  bit3 */
#define 	p10_4		p10_addr.bit.b4 	/* Port P10  bit4 */
#define 	p10_5		p10_addr.bit.b5 	/* Port P10  bit5 */
#define 	p10_6		p10_addr.bit.b6 	/* Port P10  bit6 */
#define 	p10_7		p10_addr.bit.b7 	/* Port P10  bit7 */

/*----------------------------------------------
	Port P10 direction register
----------------------------------------------*/
union byte_def pd10_addr;
#define 	pd10	pd10_addr.byte

#define 	pd10_0		pd10_addr.bit.b0	/* P10 direction register  bit0 */
#define 	pd10_1		pd10_addr.bit.b1	/* P10 direction register  bit1 */
#define 	pd10_2		pd10_addr.bit.b2	/* P10 direction register  bit2 */
#define 	pd10_3		pd10_addr.bit.b3	/* P10 direction register  bit3 */
#define 	pd10_4		pd10_addr.bit.b4	/* P10 direction register  bit4 */
#define 	pd10_5		pd10_addr.bit.b5	/* P10 direction register  bit5 */
#define 	pd10_6		pd10_addr.bit.b6	/* P10 direction register  bit6 */
#define 	pd10_7		pd10_addr.bit.b7	/* P10 direction register  bit7 */

/*----------------------------------------------
	P7 drive capacity
----------------------------------------------*/
union byte_def p7dr_addr;
#define 	p7dr	p7dr_addr.byte

#define 	p7dr0		p7dr_addr.bit.b0	/* P70 LED drive capacity */
#define 	p7dr1		p7dr_addr.bit.b1	/* P71 LED drive capacity */
#define 	p7dr2		p7dr_addr.bit.b2	/* P72 LED drive capacity */
#define 	p7dr3		p7dr_addr.bit.b3	/* P73 LED drive capacity */
#define 	p7dr4		p7dr_addr.bit.b4	/* P74 LED drive capacity */
#define 	p7dr5		p7dr_addr.bit.b5	/* P75 LED drive capacity */
#define 	p7dr6		p7dr_addr.bit.b6	/* P76 LED drive capacity */
#define 	p7dr7		p7dr_addr.bit.b7	/* P77 LED drive capacity */

/*----------------------------------------------
	Pull-up control register 0
----------------------------------------------*/
union byte_def pur0_addr;
#define 	pur0	pur0_addr.byte

#define 	pu00		pur0_addr.bit.b0	/* Pull-up P00 to P03 */
#define 	pu01		pur0_addr.bit.b1	/* Pull-up P04 to P07 */
#define 	pu02		pur0_addr.bit.b2	/* Pull-up P10 to P13 */
#define 	pu03		pur0_addr.bit.b3	/* Pull-up P14 to P17 */
#define 	pu04		pur0_addr.bit.b4	/* Pull-up P20 to P23 */
#define 	pu05		pur0_addr.bit.b5	/* Pull-up P24 to P27 */
#define 	pu06		pur0_addr.bit.b6	/* Pull-up P30 to P33 */
#define 	pu07		pur0_addr.bit.b7	/* Pull-up P34 to P37 */

/*----------------------------------------------
	Pull-up control register 1
----------------------------------------------*/
union byte_def pur1_addr;
#define 	pur1	pur1_addr.byte

#define 	pu10		pur1_addr.bit.b0	/* Pull-up P40 to P43 */
#define 	pu11		pur1_addr.bit.b1	/* Pull-up P44 to P47 */
#define 	pu12		pur1_addr.bit.b2	/* Pull-up P50 to P53 */
#define 	pu13		pur1_addr.bit.b3	/* Pull-up P54 to P57 */
#define 	pu14		pur1_addr.bit.b4	/* Pull-up P60 to P63 */
#define 	pu15		pur1_addr.bit.b5	/* Pull-up P64 to P67 */
#define 	pu16		pur1_addr.bit.b6	/* Pull-up P70 to P73 */
#define 	pu17		pur1_addr.bit.b7	/* Pull-up P84 to P77 */

/*----------------------------------------------
	Pull-up control register 2
----------------------------------------------*/
union byte_def pur2_addr;
#define 	pur2	pur2_addr.byte

#define 	pu20		pur2_addr.bit.b0	/* Pull-up P80 to P83 */
#define 	pu21		pur2_addr.bit.b1	/* Pull-up P84 to P87 ; Except P85 */
#define 	pu22		pur2_addr.bit.b2	/* Pull-up P90 to P93 ; Except P91 */

#define 	pu24		pur2_addr.bit.b4	/* Pull-up P100 to P103 */
#define 	pu25		pur2_addr.bit.b5	/* Pull-up P104 to P107 */

/*----------------------------------------------
	Port control register
----------------------------------------------*/
union byte_def pcr_addr;
#define 	pcr 	pcr_addr.byte

#define 	pcr0		pcr_addr.bit.b0 	/* Port P1 control register */

/*============================================*/
/*				  Flash memory				  */
/*============================================*/
/*----------------------------------------------
	Flash memory control register 0
----------------------------------------------*/
union byte_def fmr0_addr;
#define 	fmr0	fmr0_addr.byte

#define 	fmr00		fmr0_addr.bit.b0	   /* RY/BY~ status bit */
#define 	fmr01		fmr0_addr.bit.b1	   /* CPU rewrite mode select bit */
#define 	fmr02		fmr0_addr.bit.b2	   /* Lock bit disable bit */
#define 	fmr03		fmr0_addr.bit.b3	   /* Flash memory reset bit */

#define 	fmr05		fmr0_addr.bit.b5	   /* User ROM area select bit */

/*============================================*/
/*				declare bit (word)			  */
/*============================================*/
union word_def {
	struct {
		char	b0:1;
		char	b1:1;
		char	b2:1;
		char	b3:1;
		char	b4:1;
		char	b5:1;
		char	b6:1;
		char	b7:1;
		char	b8:1;
		char	b9:1;
		char	b10:1;
		char	b11:1;
		char	b12:1;
		char	b13:1;
		char	b14:1;
		char	b15:1;
	} bit;
	struct {
		unsigned char	 low;	/* low	8 bit */
		unsigned char	 high;	/* high 8 bit */
	} byte;
	unsigned short	word;
};
/*----------------------------------------------
   USB power management register
----------------------------------------------*/
union word_def	usbpm_addr;
#define 	usbpm	usbpm_addr.word
#define 	usbpml		usbpm_addr.byte.low 	/* low	8 bit */
#define 	usbpmh		usbpm_addr.byte.high	/* high  8 bit */

#define 	suspend 		usbpm_addr.bit.b0		/* Suspend state flag */
#define 	wakeup			usbpm_addr.bit.b1		/* Remote wakeup */

/*----------------------------------------------
   USB interrupt enable register
----------------------------------------------*/
union word_def	usbie_addr;
#define 	usbie	usbie_addr.word 		/* 16 bit */
#define 	usbiel		usbie_addr.byte.low 	/* low	8 bit */
#define 	usbieh		usbie_addr.byte.high	/* high  8 bit */

#define 	inten0			usbie_addr.bit.b0		/* EP1 IN interrupt enable bit */
#define 	inten1			usbie_addr.bit.b1		/* EP1 OUT interrupt enable bit */
#define 	inten2			usbie_addr.bit.b2		/* EP2 IN interrupt enable bit	*/
#define 	inten3			usbie_addr.bit.b3		/* EP2 OUT interrupt enable bit */
#define 	inten4			usbie_addr.bit.b4		/* EP3 IN interrupt enable bit	*/
#define 	inten5			usbie_addr.bit.b5		/* EP3 OUT interrupt enable bit */
#define 	inten6			usbie_addr.bit.b6		/* EP4 IN interrupt enable bit	*/
#define 	inten7			usbie_addr.bit.b7		/* EP4 OUT interrupt enable bit */
#define 	inten8			usbie_addr.bit.b8		/* Error interrupt enable bit */

/*----------------------------------------------
   USB ISO control register
----------------------------------------------*/
union word_def	usbisoc_addr;
#define 	usbisoc usbisoc_addr.word		/* 16 bit */
#define 	usbisocl	usbisoc_addr.byte.low	/* low	8 bit */
#define 	usbisoch	usbisoc_addr.byte.high	/* high  8 bit */

#define 	auto_fl 		usbisoc_addr.bit.b0 	/* Auto flush */
#define 	iso_upd 		usbisoc_addr.bit.b1 	/* ISO Update */
#define 	art_sof_ena 	usbisoc_addr.bit.b2 	/* Artificial SOF enable */
#define 	art_sof_set 	usbisoc_addr.bit.b3 	/* Artificial SOF set flag */
#define 	clr_art_sof 	usbisoc_addr.bit.b4 	/* Clear artificial SOF set flag */

/*----------------------------------------------
   USB endpoint enable register
----------------------------------------------*/
union word_def	usbepen_addr;
#define 	usbepen usbepen_addr.word		/* 16 bit */
#define 	usbepenl	usbepen_addr.byte.low	/* low	8 bit */
#define 	usbepenh	usbepen_addr.byte.high	/* high  8 bit */

#define 	ep1_out 		usbepen_addr.bit.b0 	/*	EP1 OUT enable */
#define 	ep1_in			usbepen_addr.bit.b1 	/*	EP1 IN enable */
#define 	ep2_out 		usbepen_addr.bit.b2 	/*	EP2 OUT enable */
#define 	ep2_in			usbepen_addr.bit.b3 	/*	EP2 IN enable */
#define 	ep3_out 		usbepen_addr.bit.b4 	/*	EP3 OUT enable */
#define 	ep3_in			usbepen_addr.bit.b5 	/*	EP3 IN enable */
#define 	ep4_out 		usbepen_addr.bit.b6 	/*	EP4 OUT enable */
#define 	ep4_in			usbepen_addr.bit.b7 	/*	EP4 IN enable */

/*----------------------------------------------
   CRC snoop address register
----------------------------------------------*/
union word_def	crcsar_addr;
#define 	crcsar	crcsar_addr.word		 /* 16 bit */
#define 	crcsarl 	crcsar_addr.byte.low	 /* low  8 bit */
#define 	crcsarh 	crcsar_addr.byte.high	 /* high  8 bit */

#define 	crcsr			crcsar_addr.bit.b14 	/* CRC Snoop on read enable bit */
#define 	crcsw			crcsar_addr.bit.b15 	/* CRC Snoop on write enable bit */

/**********************************************/
/*			   declare SFR union			  */
/**********************************************/
/*============================================*/
/*		  declare interrupt control bit 	  */
/*============================================*/
union {
	struct {
		char	ilvl0:1;			/* Interrupt priority level select bit */
		char	ilvl1:1;			/* Interrupt priority level select bit */
		char	ilvl2:1;			/* Interrupt priority level select bit */
		char	ir:1;				/* Interrupt request bit */
		char	pol:1;				/* Polarity select bit or Nothing assiged */
		char	b5:1;				/* Reserved or Nothing assigned */
		char	b6:1;				/* Nothing is assigned */
		char	b7:1;				/* Nothing is assigned */
	} bit;
	unsigned char  byte;
}
rstic_addr,suspic_addr,rsmic_addr,vbdic_addr,ep0ic_addr,usbfic_addr,sofic_addr,
dm0ic_addr,dm1ic_addr,dm2ic_addr,dm3ic_addr,
ta0ic_addr,ta1ic_addr,ta2ic_addr,ta3ic_addr,ta4ic_addr,
s0tic_addr,s1tic_addr,s2tic_addr,s3tic_addr,
s0ric_addr,s1ric_addr,s2ric_addr,s3ric_addr,
s13bcnic_addr,s02bcnic_addr,
adic_addr,kupic_addr,
int0ic_addr,int1ic_addr,int2ic_addr;

/*----------------------------------------------
	USB reset interrupt control register
----------------------------------------------*/
#define 	rstic	rstic_addr.byte

#define 	ilvl0_rstic 	rstic_addr.bit.ilvl0	/* Interrupt priority level select bit */
#define 	ilvl1_rstic 	rstic_addr.bit.ilvl1	/* Interrupt priority level select bit */
#define 	ilvl2_rstic 	rstic_addr.bit.ilvl2	/* Interrupt priority level select bit */
#define 	ir_rstic		rstic_addr.bit.ir		/* Interrupt request bit */

/*----------------------------------------------
	USB suspend interrupt control register
----------------------------------------------*/
#define 	suspic	suspic_addr.byte

#define 	ilvl0_suspic	suspic_addr.bit.ilvl0	/* Interrupt priority level select bit */
#define 	ilvl1_suspic	suspic_addr.bit.ilvl1	/* Interrupt priority level select bit */
#define 	ilvl2_suspic	suspic_addr.bit.ilvl2	/* Interrupt priority level select bit */
#define 	ir_suspic		suspic_addr.bit.ir		/* Interrupt request bit */

/*----------------------------------------------
	USB resume interrupt control register
----------------------------------------------*/
#define 	rsmic	rsmic_addr.byte

#define 	ilvl0_rsmic 	rsmic_addr.bit.ilvl0	/* Interrupt priority level select bit */
#define 	ilvl1_rsmic 	rsmic_addr.bit.ilvl1	/* Interrupt priority level select bit */
#define 	ilvl2_rsmic 	rsmic_addr.bit.ilvl2	/* Interrupt priority level select bit */
#define 	ir_rsmic		rsmic_addr.bit.ir		/* Interrupt request bit */

/*----------------------------------------------
	USB Vbus detect interrupt control register
----------------------------------------------*/
#define 	vbdic	vbdic_addr.byte

#define 	ilvl0_vbdic 	vbdic_addr.bit.ilvl0	/* Interrupt priority level select bit */
#define 	ilvl1_vbdic 	vbdic_addr.bit.ilvl1	/* Interrupt priority level select bit */
#define 	ilvl2_vbdic 	vbdic_addr.bit.ilvl2	/* Interrupt priority level select bit */
#define 	ir_vbdic		vbdic_addr.bit.ir		/* Interrupt request bit */

/*----------------------------------------------
	USB Endpoint 0 interrupt control register
----------------------------------------------*/
#define 	ep0ic	ep0ic_addr.byte

#define 	ilvl0_ep0ic 	ep0ic_addr.bit.ilvl0	/* Interrupt priority level select bit */
#define 	ilvl1_ep0ic 	ep0ic_addr.bit.ilvl1	/* Interrupt priority level select bit */
#define 	ilvl2_ep0ic 	ep0ic_addr.bit.ilvl2	/* Interrupt priority level select bit */
#define 	ir_ep0ic		ep0ic_addr.bit.ir		/* Interrupt request bit */

/*----------------------------------------------
	USB function interrupt control register
----------------------------------------------*/
#define 	usbfic	usbfic_addr.byte

#define 	ilvl0_usbfic	usbfic_addr.bit.ilvl0	/* Interrupt priority level select bit */
#define 	ilvl1_usbfic	usbfic_addr.bit.ilvl1	/* Interrupt priority level select bit */
#define 	ilvl2_usbfic	usbfic_addr.bit.ilvl2	/* Interrupt priority level select bit */
#define 	ir_usbfic		usbfic_addr.bit.ir		/* Interrupt request bit */

/*----------------------------------------------
	USB SOF interrupt control register
----------------------------------------------*/
#define 	sofic	sofic_addr.byte

#define 	ilvl0_sofic 	sofic_addr.bit.ilvl0	/* Interrupt priority level select bit */
#define 	ilvl1_sofic 	sofic_addr.bit.ilvl1	/* Interrupt priority level select bit */
#define 	ilvl2_sofic 	sofic_addr.bit.ilvl2	/* Interrupt priority level select bit */
#define 	ir_sofic		sofic_addr.bit.ir		/* Interrupt request bit */

/*----------------------------------------------
	DMA0 interrupt control register
----------------------------------------------*/
#define 	dm0ic	dm0ic_addr.byte

#define 	ilvl0_dm0ic 	dm0ic_addr.bit.ilvl0	/* Interrupt priority level select bit */
#define 	ilvl1_dm0ic 	dm0ic_addr.bit.ilvl1	/* Interrupt priority level select bit */
#define 	ilvl2_dm0ic 	dm0ic_addr.bit.ilvl2	/* Interrupt priority level select bit */
#define 	ir_dm0ic		dm0ic_addr.bit.ir		/* Interrupt request bit */

/*----------------------------------------------
	DMA1 interrupt control register
----------------------------------------------*/
#define 	dm1ic	dm1ic_addr.byte

#define 	ilvl0_dm1ic 	dm1ic_addr.bit.ilvl0	/* Interrupt priority level select bit */
#define 	ilvl1_dm1ic 	dm1ic_addr.bit.ilvl1	/* Interrupt priority level select bit */
#define 	ilvl2_dm1ic 	dm1ic_addr.bit.ilvl2	/* Interrupt priority level select bit */
#define 	ir_dm1ic		dm1ic_addr.bit.ir		/* Interrupt request bit */

/*----------------------------------------------
	DMA2 interrupt control register
----------------------------------------------*/
#define 	dm2ic	dm2ic_addr.byte

#define 	ilvl0_dm2ic 	dm2ic_addr.bit.ilvl0	/* Interrupt priority level select bit */
#define 	ilvl1_dm2ic 	dm2ic_addr.bit.ilvl1	/* Interrupt priority level select bit */
#define 	ilvl2_dm2ic 	dm2ic_addr.bit.ilvl2	/* Interrupt priority level select bit */
#define 	ir_dm2ic		dm2ic_addr.bit.ir		/* Interrupt request bit */

/*----------------------------------------------
	DMA3 interrupt control register
----------------------------------------------*/
#define 	dm3ic	dm3ic_addr.byte

#define 	ilvl0_dm3ic 	dm3ic_addr.bit.ilvl0	/* Interrupt priority level select bit */
#define 	ilvl1_dm3ic 	dm3ic_addr.bit.ilvl1	/* Interrupt priority level select bit */
#define 	ilvl2_dm3ic 	dm3ic_addr.bit.ilvl2	/* Interrupt priority level select bit */
#define 	ir_dm3ic		dm3ic_addr.bit.ir		/* Interrupt request bit */

/*----------------------------------------------
	Timer A0 interrupt control register
----------------------------------------------*/
#define 	ta0ic	ta0ic_addr.byte

#define 	ilvl0_ta0ic 	ta0ic_addr.bit.ilvl0	/* Interrupt priority level select bit */
#define 	ilvl1_ta0ic 	ta0ic_addr.bit.ilvl1	/* Interrupt priority level select bit */
#define 	ilvl2_ta0ic 	ta0ic_addr.bit.ilvl2	/* Interrupt priority level select bit */
#define 	ir_ta0ic		ta0ic_addr.bit.ir		/* Interrupt request bit */

/*----------------------------------------------
	Timer A1 interrupt control register
----------------------------------------------*/
#define 	ta1ic	ta1ic_addr.byte

#define 	ilvl0_ta1ic 	ta1ic_addr.bit.ilvl0	/* Interrupt priority level select bit */
#define 	ilvl1_ta1ic 	ta1ic_addr.bit.ilvl1	/* Interrupt priority level select bit */
#define 	ilvl2_ta1ic 	ta1ic_addr.bit.ilvl2	/* Interrupt priority level select bit */
#define 	ir_ta1ic		ta1ic_addr.bit.ir		/* Interrupt request bit */

/*----------------------------------------------
	Timer A2 interrupt control register
----------------------------------------------*/
#define 	ta2ic	ta2ic_addr.byte

#define 	ilvl0_ta2ic 	ta2ic_addr.bit.ilvl0	/* Interrupt priority level select bit */
#define 	ilvl1_ta2ic 	ta2ic_addr.bit.ilvl1	/* Interrupt priority level select bit */
#define 	ilvl2_ta2ic 	ta2ic_addr.bit.ilvl2	/* Interrupt priority level select bit */
#define 	ir_ta2ic		ta2ic_addr.bit.ir		/* Interrupt request bit */

/*----------------------------------------------
	Timer A3 interrupt control register
----------------------------------------------*/
#define 	ta3ic	ta3ic_addr.byte

#define 	ilvl0_ta3ic 	ta3ic_addr.bit.ilvl0	/* Interrupt priority level select bit */
#define 	ilvl1_ta3ic 	ta3ic_addr.bit.ilvl1	/* Interrupt priority level select bit */
#define 	ilvl2_ta3ic 	ta3ic_addr.bit.ilvl2	/* Interrupt priority level select bit */
#define 	ir_ta3ic		ta3ic_addr.bit.ir		/* Interrupt request bit */

/*----------------------------------------------
	Timer A4 interrupt control register
----------------------------------------------*/
#define 	ta4ic	ta4ic_addr.byte

#define 	ilvl0_ta4ic 	ta4ic_addr.bit.ilvl0	/* Interrupt priority level select bit */
#define 	ilvl1_ta4ic 	ta4ic_addr.bit.ilvl1	/* Interrupt priority level select bit */
#define 	ilvl2_ta4ic 	ta4ic_addr.bit.ilvl2	/* Interrupt priority level select bit */
#define 	ir_ta4ic		ta4ic_addr.bit.ir		/* Interrupt request bit */

/*----------------------------------------------
	UART0 transmit/nack interrupt control register
----------------------------------------------*/
#define 	s0tic	s0tic_addr.byte

#define 	ilvl0_s0tic 	s0tic_addr.bit.ilvl0	/* Interrupt priority level select bit */
#define 	ilvl1_s0tic 	s0tic_addr.bit.ilvl1	/* Interrupt priority level select bit */
#define 	ilvl2_s0tic 	s0tic_addr.bit.ilvl2	/* Interrupt priority level select bit */
#define 	ir_s0tic		s0tic_addr.bit.ir		/* Interrupt request bit */

/*----------------------------------------------
	UART1 transmit/nack interrupt control register
----------------------------------------------*/
#define 	s1tic	s1tic_addr.byte

#define 	ilvl0_s1tic 	s1tic_addr.bit.ilvl0	/* Interrupt priority level select bit */
#define 	ilvl1_s1tic 	s1tic_addr.bit.ilvl1	/* Interrupt priority level select bit */
#define 	ilvl2_s1tic 	s1tic_addr.bit.ilvl2	/* Interrupt priority level select bit */
#define 	ir_s1tic		s1tic_addr.bit.ir		/* Interrupt request bit */

/*----------------------------------------------
	UART2 transmit/nack interrupt control register
----------------------------------------------*/
#define 	s2tic	s2tic_addr.byte

#define 	ilvl0_s2tic 	s2tic_addr.bit.ilvl0	/* Interrupt priority level select bit */
#define 	ilvl1_s2tic 	s2tic_addr.bit.ilvl1	/* Interrupt priority level select bit */
#define 	ilvl2_s2tic 	s2tic_addr.bit.ilvl2	/* Interrupt priority level select bit */
#define 	ir_s2tic		s2tic_addr.bit.ir		/* Interrupt request bit */

/*----------------------------------------------
	UART3 transmit/nack interrupt control register
----------------------------------------------*/
#define 	s3tic	s3tic_addr.byte

#define 	ilvl0_s3tic 	s3tic_addr.bit.ilvl0	/* Interrupt priority level select bit */
#define 	ilvl1_s3tic 	s3tic_addr.bit.ilvl1	/* Interrupt priority level select bit */
#define 	ilvl2_s3tic 	s3tic_addr.bit.ilvl2	/* Interrupt priority level select bit */
#define 	ir_s3tic		s3tic_addr.bit.ir		/* Interrupt request bit */

/*----------------------------------------------
	UART0 receive/ack interrupt control register
----------------------------------------------*/
#define 	s0ric	s0ric_addr.byte

#define 	ilvl0_s0ric 	s0ric_addr.bit.ilvl0	/* Interrupt priority level select bit */
#define 	ilvl1_s0ric 	s0ric_addr.bit.ilvl1	/* Interrupt priority level select bit */
#define 	ilvl2_s0ric 	s0ric_addr.bit.ilvl2	/* Interrupt priority level select bit */
#define 	ir_s0ric		s0ric_addr.bit.ir		/* Interrupt request bit */

/*----------------------------------------------
	UART1 receive/ack interrupt control register
----------------------------------------------*/
#define 	s1ric	s1ric_addr.byte

#define 	ilvl0_s1ric 	s1ric_addr.bit.ilvl0	/* Interrupt priority level select bit */
#define 	ilvl1_s1ric 	s1ric_addr.bit.ilvl1	/* Interrupt priority level select bit */
#define 	ilvl2_s1ric 	s1ric_addr.bit.ilvl2	/* Interrupt priority level select bit */
#define 	ir_s1ric		s1ric_addr.bit.ir		/* Interrupt request bit */

/*----------------------------------------------
	UART2 receive/ack interrupt control register
----------------------------------------------*/
#define 	s2ric	s2ric_addr	  .byte

#define 	ilvl0_s2ric 	s2ric_addr.bit.ilvl0	/* Interrupt priority level select bit */
#define 	ilvl1_s2ric 	s2ric_addr.bit.ilvl1	/* Interrupt priority level select bit */
#define 	ilvl2_s2ric 	s2ric_addr.bit.ilvl2	/* Interrupt priority level select bit */
#define 	ir_s2ric		s2ric_addr.bit.ir		/* Interrupt request bit */

/*----------------------------------------------
	UART3 receive/ack interrupt control register
----------------------------------------------*/
#define 	s3ric	s3ric_addr.byte

#define 	ilvl0_s3ric 	s3ric_addr.bit.ilvl0	/* Interrupt priority level select bit */
#define 	ilvl1_s3ric 	s3ric_addr.bit.ilvl1	/* Interrupt priority level select bit */
#define 	ilvl2_s3ric 	s3ric_addr.bit.ilvl2	/* Interrupt priority level select bit */
#define 	ir_s3ric		s3ric_addr.bit.ir		/* Interrupt request bit */

/*----------------------------------------------
	UART1/3 Bus collision interrupt control register
----------------------------------------------*/
#define 	s13bcnic	s13bcnic_addr.byte

#define 	ilvl0_s13bcnic	s13bcnic_addr.bit.ilvl0 /* Interrupt priority level select bit */
#define 	ilvl1_s13bcnic	s13bcnic_addr.bit.ilvl1 /* Interrupt priority level select bit */
#define 	ilvl2_s13bcnic	s13bcnic_addr.bit.ilvl2 /* Interrupt priority level select bit */
#define 	ir_s13bcnic 	s13bcnic_addr.bit.ir	/* Interrupt request bit */

/*----------------------------------------------
	UART0/2 Bus collision interrupt control register
----------------------------------------------*/
#define 	s02bcnic	s02bcnic_addr.byte

#define 	ilvl0_s02bcnic	s02bcnic_addr.bit.ilvl0 /* Interrupt priority level select bit */
#define 	ilvl1_s02bcnic	s02bcnic_addr.bit.ilvl1 /* Interrupt priority level select bit */
#define 	ilvl2_s02bcnic	s02bcnic_addr.bit.ilvl2 /* Interrupt priority level select bit */
#define 	ir_s02bcnic 	s02bcnic_addr.bit.ir	/* Interrupt request bit */

/*----------------------------------------------
	A-D conversion interrupt control register
----------------------------------------------*/
#define 	adic	adic_addr.byte

#define 	ilvl0_adic		adic_addr.bit.ilvl0 	/* Interrupt priority level select bit */
#define 	ilvl1_adic		adic_addr.bit.ilvl1 	/* Interrupt priority level select bit */
#define 	ilvl2_adic		adic_addr.bit.ilvl2 	/* Interrupt priority level select bit */
#define 	ir_adic 		adic_addr.bit.ir		/* Interrupt request bit */

/*----------------------------------------------
	Key input interrupt control register
----------------------------------------------*/
#define 	kupic	kupic_addr.byte

#define 	ilvl0_kupic 	kupic_addr.bit.ilvl0	/* Interrupt priority level select bit */
#define 	ilvl1_kupic 	kupic_addr.bit.ilvl1	/* Interrupt priority level select bit */
#define 	ilvl2_kupic 	kupic_addr.bit.ilvl2	/* Interrupt priority level select bit */
#define 	ir_kupic		kupic_addr.bit.ir		/* Interrupt request bit */

/*----------------------------------------------
	INT0~ interrupt control register
----------------------------------------------*/
#define 	int0ic	int0ic_addr.byte

#define 	ilvl0_int0ic	int0ic_addr.bit.ilvl0	/* Interrupt priority level select bit */
#define 	ilvl1_int0ic	int0ic_addr.bit.ilvl1	/* Interrupt priority level select bit */
#define 	ilvl2_int0ic	int0ic_addr.bit.ilvl2	/* Interrupt priority level select bit */
#define 	ir_int0ic		int0ic_addr.bit.ir		/* Interrupt request bit */
#define 	pol_int0ic		int0ic_addr.bit.pol 	/* Polarity select bit */

/*----------------------------------------------
	INT1~ interrupt control register
----------------------------------------------*/
#define 	int1ic	int1ic_addr.byte

#define 	ilvl0_int1ic	int1ic_addr.bit.ilvl0	/* Interrupt priority level select bit */
#define 	ilvl1_int1ic	int1ic_addr.bit.ilvl1	/* Interrupt priority level select bit */
#define 	ilvl2_int1ic	int1ic_addr.bit.ilvl2	/* Interrupt priority level select bit */
#define 	ir_int1ic		int1ic_addr.bit.ir		/* Interrupt request bit */
#define 	pol_int1ic		int1ic_addr.bit.pol 	/* Polarity select bit */

/*----------------------------------------------
	INT2~ interrupt control register
----------------------------------------------*/
#define 	int2ic	int2ic_addr.byte

#define 	ilvl0_int2ic	int2ic_addr.bit.ilvl0	/* Interrupt priority level select bit */
#define 	ilvl1_int2ic	int2ic_addr.bit.ilvl1	/* Interrupt priority level select bit */
#define 	ilvl2_int2ic	int2ic_addr.bit.ilvl2	/* Interrupt priority level select bit */
#define 	ir_int2ic		int2ic_addr.bit.ir		/* Interrupt request bit */
#define 	pol_int2ic		int2ic_addr.bit.pol 	/* Polarity select bit */

/*============================================*/
/*		  declare USB DMAx request bit		  */
/*============================================*/
union {
	struct {
		char	b0:1;				/* Reserved */
		char	dmaxr1:1;			/* EP1 IN FIFO write request select bit */
		char	dmaxr2:1;			/* EP2 IN FIFO write request select bit */
		char	dmaxr3:1;			/* EP3 IN FIFO write request select bit */
		char	dmaxr4:1;			/* EP4 IN FIFO write request select bit */
		char	b5:1;				/* Reserved */
		char	dmaxr6:1;			/* EP1 OUT FIFO read request select bit */
		char	dmaxr7:1;			/* EP2 OUT FIFO read request select bit */
		char	dmaxr8:1;			/* EP3 OUT FIFO read request select bit */
		char	dmaxr9:1;			/* EP4 OUT FIFO read request select bit */
		char	b10:1;				/* Reserved */
		char	b11:1;				/* Reserved */
		char	b12:1;				/* Reserved */
		char	b13:1;				/* Reserved */
		char	b14:1;				/* Reserved */
		char	b15:1;				/* Reserved */
	} bit;
	struct {
		unsigned char	 low;	/* low	8 bit */
		unsigned char	 high;	/* high 8 bit */
	} byte;
	unsigned short	word;
} usbdma0_addr,usbdma1_addr,usbdma2_addr,usbdma3_addr;

/*----------------------------------------------
	USB DMA0 request register
----------------------------------------------*/
#define 	usbdma0 usbdma0_addr.word		/* 16 bit */
#define 	usbdma0l	usbdma0_addr.byte.low	/* low	8 bit */
#define 	usbdma0h	usbdma0_addr.byte.high	/* high  8 bit */

#define 	dma0r1			usbdma0_addr.bit.dmaxr1 /* USB DMA0 EP1 IN FIFO write request select bit */
#define 	dma0r2			usbdma0_addr.bit.dmaxr2 /* USB DMA0 EP2 IN FIFO write request select bit */
#define 	dma0r3			usbdma0_addr.bit.dmaxr3 /* USB DMA0 EP3 IN FIFO write request select bit */
#define 	dma0r4			usbdma0_addr.bit.dmaxr4 /* USB DMA0 EP4 IN FIFO write request select bit */

#define 	dma0r6			usbdma0_addr.bit.dmaxr6 /* USB DMA0 EP1 OUT FIFO read request select bit */
#define 	dma0r7			usbdma0_addr.bit.dmaxr7 /* USB DMA0 EP2 OUT FIFO read request select bit */
#define 	dma0r8			usbdma0_addr.bit.dmaxr8 /* USB DMA0 EP3 OUT FIFO read request select bit */
#define 	dma0r9			usbdma0_addr.bit.dmaxr9 /* USB DMA0 EP4 OUT FIFO read request select bit */

/*----------------------------------------------
	USB DMA1 request register
----------------------------------------------*/
#define 	usbdma1 usbdma1_addr.word		/* 16 bit */
#define 	usbdma1l	usbdma1_addr.byte.low	/* low	8 bit */
#define 	usbdma1h	usbdma1_addr.byte.high	/* high  8 bit */

#define 	dma1r1			usbdma1_addr.bit.dmaxr1 /* USB DMA1 EP1 IN FIFO write request select bit */
#define 	dma1r2			usbdma1_addr.bit.dmaxr2 /* USB DMA1 EP2 IN FIFO write request select bit */
#define 	dma1r3			usbdma1_addr.bit.dmaxr3 /* USB DMA1 EP3 IN FIFO write request select bit */
#define 	dma1r4			usbdma1_addr.bit.dmaxr4 /* USB DMA1 EP4 IN FIFO write request select bit */

#define 	dma1r6			usbdma1_addr.bit.dmaxr6 /* USB DMA1 EP1 OUT FIFO read request select bit */
#define 	dma1r7			usbdma1_addr.bit.dmaxr7 /* USB DMA1 EP2 OUT FIFO read request select bit */
#define 	dma1r8			usbdma1_addr.bit.dmaxr8 /* USB DMA1 EP3 OUT FIFO read request select bit */
#define 	dma1r9			usbdma1_addr.bit.dmaxr9 /* USB DMA1 EP4 OUT FIFO read request select bit */

/*----------------------------------------------
	USB DMA2 request register
----------------------------------------------*/
#define 	usbdma2 usbdma2_addr.word		/* 16 bit */
#define 	usbdma2l	usbdma2_addr.byte.low	/* low	8 bit */
#define 	usbdma2h	usbdma2_addr.byte.high	/* high  8 bit */

#define 	dma2r1			usbdma2_addr.bit.dmaxr1 /* USB DMA2 EP1 IN FIFO write request select bit */
#define 	dma2r2			usbdma2_addr.bit.dmaxr2 /* USB DMA2 EP2 IN FIFO write request select bit */
#define 	dma2r3			usbdma2_addr.bit.dmaxr3 /* USB DMA2 EP3 IN FIFO write request select bit */
#define 	dma2r4			usbdma2_addr.bit.dmaxr4 /* USB DMA2 EP4 IN FIFO write request select bit */

#define 	dma2r6			usbdma2_addr.bit.dmaxr6 /* USB DMA2 EP1 OUT FIFO read request select bit */
#define 	dma2r7			usbdma2_addr.bit.dmaxr7 /* USB DMA2 EP2 OUT FIFO read request select bit */
#define 	dma2r8			usbdma2_addr.bit.dmaxr8 /* USB DMA2 EP3 OUT FIFO read request select bit */
#define 	dma2r9			usbdma2_addr.bit.dmaxr9 /* USB DMA2 EP4 OUT FIFO read request select bit */

/*----------------------------------------------
	USB DMA3 request register
----------------------------------------------*/
#define 	usbdma3 usbdma3_addr.word		/* 16 bit */
#define 	usbdma3l	usbdma3_addr.byte.low	/* low	8 bit */
#define 	usbdma3h	usbdma3_addr.byte.high	/* high  8 bit */

#define 	dma3r1			usbdma3_addr.bit.dmaxr1 /* USB DMA3 EP1 IN FIFO write request select bit */
#define 	dma3r2			usbdma3_addr.bit.dmaxr2 /* USB DMA3 EP2 IN FIFO write request select bit */
#define 	dma3r3			usbdma3_addr.bit.dmaxr3 /* USB DMA3 EP3 IN FIFO write request select bit */
#define 	dma3r4			usbdma3_addr.bit.dmaxr4 /* USB DMA3 EP4 IN FIFO write request select bit */

#define 	dma3r6			usbdma3_addr.bit.dmaxr6 /* USB DMA3 EP1 OUT FIFO read request select bit */
#define 	dma3r7			usbdma3_addr.bit.dmaxr7 /* USB DMA3 EP2 OUT FIFO read request select bit */
#define 	dma3r8			usbdma3_addr.bit.dmaxr8 /* USB DMA3 EP3 OUT FIFO read request select bit */
#define 	dma3r9			usbdma3_addr.bit.dmaxr9 /* USB DMA3 EP4 OUT FIFO read request select bit */

/*============================================*/
/*		 declare USB EPx0 con./sta. bit 	  */
/*============================================*/
union {
	struct {
		char	ep0csr0:1;			/* OUT_BUF_RDY flag */
		char	ep0csr1:1;			/* IN_BUF_RDY flag */
		char	ep0csr2:1;			/* SETUP flag */
		char	ep0csr3:1;			/* DATA_END flag */
		char	ep0csr4:1;			/* FORCE_STALL flag */
		char	ep0csr5:1;			/* SETUP_END flag */
		char	ep0csr6:1;			/* CLR_OUT_BUF_RDY */
		char	ep0csr7:1;			/* SET_IN_BUF_RDY */
		char	ep0csr8:1;			/* CLR_SETUP */
		char	ep0csr9:1;			/* SET_DATA_END */
		char	ep0csr10:1; 		/* CLR_FORCE_STALL */
		char	ep0csr11:1; 		/* CLR_SETUP_END */
		char	ep0csr12:1; 		/* SEND_STALL */
		char	ep0csr13:1; 		/* DATA_END_MASK */
		char	b14:1;				/* Reserved */
		char	b15:1;				/* Reserved */
	} bit;
	struct {
		unsigned char	 low;	/* low	8 bit */
		unsigned char	 high;	/* high 8 bit */
	} byte;
	unsigned short	word;
} ep0cs_addr;

/*----------------------------------------------
	USB EP0 control/status register
----------------------------------------------*/
#define 	ep0cs	ep0cs_addr.word 		/* 16 bit */
#define 	ep0csl		ep0cs_addr.byte.low 	/* low	8 bit */
#define 	ep0csh		ep0cs_addr.byte.high	/* high  8 bit */

#define 	out_buf_rdy_ep0cs		ep0cs_addr.bit.ep0csr0	/* USB EP0 OUT_BUF_RDY flag */
#define 	in_buf_rdy_ep0cs		ep0cs_addr.bit.ep0csr1	/* USB EP0 IN_BUF_RDY flag */
#define 	setup_ep0cs 			ep0cs_addr.bit.ep0csr2	/* USB EP0 SETUP flag */
#define 	data_end_ep0cs			ep0cs_addr.bit.ep0csr3	/* USB EP0 DATA_END flag */
#define 	force_stall_ep0cs		ep0cs_addr.bit.ep0csr4	/* USB EP0 FORCE_STALL flag */
#define 	setup_end_ep0cs 		ep0cs_addr.bit.ep0csr5	/* USB EP0 SETUP_END flag */
#define 	clr_out_buf_rdy_ep0cs	ep0cs_addr.bit.ep0csr6	/* USB EP0 CLR_OUT_BUF_RDY */
#define 	set_in_buf_rdy_ep0cs	ep0cs_addr.bit.ep0csr7	/* USB EP0 SET_IN_BUF_RDY */
#define 	clr_setup_ep0cs 		ep0cs_addr.bit.ep0csr8	/* USB EP0 CLR_SETUP */
#define 	set_data_end_ep0cs		ep0cs_addr.bit.ep0csr9	/* USB EP0 SET_DATA_END */
#define 	clr_force_stall_ep0cs	ep0cs_addr.bit.ep0csr10 /* USB EP0 CLR_FORCE_STALL */
#define 	clr_setup_end_ep0cs 	ep0cs_addr.bit.ep0csr11 /* USB EP0 CLR_SETUP_END */
#define 	send_stall_ep0cs		ep0cs_addr.bit.ep0csr12 /* USB EP0 SEND_STALL */
#define 	data_end_mask_ep0cs 	ep0cs_addr.bit.ep0csr13 /* USB EP0 DATA_END_MASK */

/*============================================*/
/*		declare USB EPxIN con./sta. bit 	  */
/*============================================*/
union {
	struct {
		char	inxcsr0:1;			/* IN_BUF_STS0 flag */
		char	inxcsr1:1;			/* IN_BUF_STS1 flag */
		char	inxcsr2:1;			/* UNDER-RUN flag */
		char	inxcsr3:1;			/* SET_IN_BUF_RDY */
		char	inxcsr4:1;			/* CLR_UNDER_RUN */
		char	inxcsr5:1;			/* TOGGLE_INIT */
		char	inxcsr6:1;			/* FLUSH */
		char	inxcsr7:1;			/* INTPT */
		char	inxcsr8:1;			/* ISO */
		char	inxcsr9:1;			/* SEND_STALL */
		char	inxcsr10:1; 		/* AUTO_SET */
		char	b11:1;				/* Reserved */
		char	b12:1;				/* Reserved */
		char	b13:1;				/* Reserved */
		char	b14:1;				/* Reserved */
		char	b15:1;				/* Reserved */
	} bit;
	struct {
		unsigned char	 low;	/* low	8 bit */
		unsigned char	 high;	/* high 8 bit */
	} byte;
	unsigned short	word;
} ep1ics_addr,ep2ics_addr,ep3ics_addr,ep4ics_addr;

/*----------------------------------------------
	USB EP1 IN control/status register
----------------------------------------------*/
#define 	ep1ics	ep1ics_addr.word		/* 16 bit */
#define 	ep1icsl 	ep1ics_addr.byte.low	/* low	8 bit */
#define 	ep1icsh 	ep1ics_addr.byte.high	/* high  8 bit */

#define 	in_buf_sts0_ep1ics		ep1ics_addr.bit.inxcsr0 /* USB EP1 IN IN_BUF_STS0 flag */
#define 	in_buf_sts1_ep1ics		ep1ics_addr.bit.inxcsr1 /* USB EP1 IN IN_BUF_STS1 flag */
#define 	under_run_ep1ics		ep1ics_addr.bit.inxcsr2 /* USB EP1 IN UNDER-RUN flag */
#define 	set_in_buf_rdy_ep1ics	ep1ics_addr.bit.inxcsr3 /* USB EP1 IN SET_IN_BUF_RDY */
#define 	clr_under_run_ep1ics	ep1ics_addr.bit.inxcsr4 /* USB EP1 IN CLR_UNDER_RUN */
#define 	toggle_init_ep1ics		ep1ics_addr.bit.inxcsr5 /* USB EP1 IN TOGGLE_INIT */
#define 	flush_ep1ics			ep1ics_addr.bit.inxcsr6 /* USB EP1 IN FLUSH */
#define 	intpt_ep1ics			ep1ics_addr.bit.inxcsr7 /* USB EP1 IN INTPT */
#define 	iso_ep1ics				ep1ics_addr.bit.inxcsr8 /* USB EP1 IN ISO */
#define 	send_stall_ep1ics		ep1ics_addr.bit.inxcsr9 /* USB EP1 IN SEND_STALL */
#define 	auto_set_ep1ics 		ep1ics_addr.bit.inxcsr10/* USB EP1 IN AUTO_SET */

/*----------------------------------------------
	USB EP2 IN control/status register
----------------------------------------------*/
#define 	ep2ics	ep2ics_addr.word		/* 16 bit */
#define 	ep2icsl 	ep2ics_addr.byte.low	/* low	8 bit */
#define 	ep2icsh 	ep2ics_addr.byte.high	/* high  8 bit */

#define 	in_buf_sts0_ep2ics		ep2ics_addr.bit.inxcsr0 /* USB EP2 IN IN_BUF_STS0 flag */
#define 	in_buf_sts1_ep2ics		ep2ics_addr.bit.inxcsr1 /* USB EP2 IN IN_BUF_STS1 flag */
#define 	under_run_ep2ics		ep2ics_addr.bit.inxcsr2 /* USB EP2 IN UNDER-RUN flag */
#define 	set_in_buf_rdy_ep2ics	ep2ics_addr.bit.inxcsr3 /* USB EP2 IN SET_IN_BUF_RDY */
#define 	clr_under_run_ep2ics	ep2ics_addr.bit.inxcsr4 /* USB EP2 IN CLR_UNDER_RUN */
#define 	toggle_init_ep2ics		ep2ics_addr.bit.inxcsr5 /* USB EP2 IN TOGGLE_INIT */
#define 	flush_ep2ics			ep2ics_addr.bit.inxcsr6 /* USB EP2 IN FLUSH */
#define 	intpt_ep2ics			ep2ics_addr.bit.inxcsr7 /* USB EP2 IN INTPT */
#define 	iso_ep2ics				ep2ics_addr.bit.inxcsr8 /* USB EP2 IN ISO */
#define 	send_stall_ep2ics		ep2ics_addr.bit.inxcsr9 /* USB EP2 IN SEND_STALL */
#define 	auto_set_ep2ics 		ep2ics_addr.bit.inxcsr10/* USB EP2 IN AUTO_SET */

/*----------------------------------------------
	USB EP3 IN control/status register
----------------------------------------------*/
#define 	ep3ics	ep3ics_addr.word		/* 16 bit */
#define 	ep3icsl 	ep3ics_addr.byte.low	/* low	8 bit */
#define 	ep3icsh 	ep3ics_addr.byte.high	/* high  8 bit */

#define 	in_buf_sts0_ep3ics		ep3ics_addr.bit.inxcsr0 /* USB EP3 IN IN_BUF_STS0 flag */
#define 	in_buf_sts1_ep3ics		ep3ics_addr.bit.inxcsr1 /* USB EP3 IN IN_BUF_STS1 flag */
#define 	under_run_ep3ics		ep3ics_addr.bit.inxcsr2 /* USB EP3 IN UNDER-RUN flag */
#define 	set_in_buf_rdy_ep3ics	ep3ics_addr.bit.inxcsr3 /* USB EP3 IN SET_IN_BUF_RDY */
#define 	clr_under_run_ep3ics	ep3ics_addr.bit.inxcsr4 /* USB EP3 IN CLR_UNDER_RUN */
#define 	toggle_init_ep3ics		ep3ics_addr.bit.inxcsr5 /* USB EP3 IN TOGGLE_INIT */
#define 	flush_ep3ics			ep3ics_addr.bit.inxcsr6 /* USB EP3 IN FLUSH */
#define 	intpt_ep3ics			ep3ics_addr.bit.inxcsr7 /* USB EP3 IN INTPT */
#define 	iso_ep3ics				ep3ics_addr.bit.inxcsr8 /* USB EP3 IN ISO */
#define 	send_stall_ep3ics		ep3ics_addr.bit.inxcsr9 /* USB EP3 IN SEND_STALL */
#define 	auto_set_ep3ics 		ep3ics_addr.bit.inxcsr10/* USB EP3 IN AUTO_SET */

/*----------------------------------------------
	USB EP4 IN control/status register
----------------------------------------------*/
#define 	ep4ics	ep4ics_addr.word		/* 16 bit */
#define 	ep4icsl 	ep4ics_addr.byte.low	/* low	8 bit */
#define 	ep4icsh 	ep4ics_addr.byte.high	/* high  8 bit */

#define 	in_buf_sts0_ep4ics		ep4ics_addr.bit.inxcsr0 /* USB EP4 IN IN_BUF_STS0 flag */
#define 	in_buf_sts1_ep4ics		ep4ics_addr.bit.inxcsr1 /* USB EP4 IN IN_BUF_STS1 flag */
#define 	under_run_ep4ics		ep4ics_addr.bit.inxcsr2 /* USB EP4 IN UNDER-RUN flag */
#define 	set_in_buf_rdy_ep4ics	ep4ics_addr.bit.inxcsr3 /* USB EP4 IN SET_IN_BUF_RDY */
#define 	clr_under_run_ep4ics	ep4ics_addr.bit.inxcsr4 /* USB EP4 IN CLR_UNDER_RUN */
#define 	toggle_init_ep4ics		ep4ics_addr.bit.inxcsr5 /* USB EP4 IN TOGGLE_INIT */
#define 	flush_ep4ics			ep4ics_addr.bit.inxcsr6 /* USB EP4 IN FLUSH */
#define 	intpt_ep4ics			ep4ics_addr.bit.inxcsr7 /* USB EP4 IN INTPT */
#define 	iso_ep4ics				ep4ics_addr.bit.inxcsr8 /* USB EP4 IN ISO */
#define 	send_stall_ep4ics		ep4ics_addr.bit.inxcsr9 /* USB EP4 IN SEND_STALL */
#define 	auto_set_ep4ics 		ep4ics_addr.bit.inxcsr10/* USB EP4 IN AUTO_SET */

/*============================================*/
/*		declare USB EPxOUT con./sta. bit	  */
/*============================================*/
union {
	struct {
		char	outxcsr0:1; 		/* OUT_BUF_STS0 flag */
		char	outxcsr1:1; 		/* OUT_BUF_STS1 flag */
		char	outxcsr2:1; 		/* OVER-RUN flag */
		char	outxcsr3:1; 		/* FORCE_STALL flag */
		char	outxcsr4:1; 		/* DATA_ERR flag */
		char	outxcsr5:1; 		/* CLR_OUT_BUF_RDY */
		char	outxcsr6:1; 		/* CLR_OVER_RUN */
		char	outxcsr7:1; 		/* CLR_FORCE_STALL */
		char	outxcsr8:1; 		/* CLR_DATA_ERR */
		char	outxcsr9:1; 		/* TOGGLE_INIT */
		char	outxcsr10:1;		/* FLUSH bit */
		char	outxcsr11:1;		/* ISO bit */
		char	outxcsr12:1;		/* SEND_STALL bit */
		char	outxcsr13:1;		/* AUTO_CLR bit */
		char	b14:1;				/* Reserved */
		char	b15:1;				/* Reserved */
	} bit;
	struct {
		unsigned char	 low;	/* low	8 bit */
		unsigned char	 high;	/* high 8 bit */
	} byte;
	unsigned short	word;
} ep1ocs_addr,ep2ocs_addr,ep3ocs_addr,ep4ocs_addr;

/*----------------------------------------------
	USB EP1 OUT control/status register
----------------------------------------------*/
#define 	ep1ocs	ep1ocs_addr.word		/* 16 bit */
#define 	ep1ocsl 	ep1ocs_addr.byte.low	/* low	8 bit */
#define 	ep1ocsh 	ep1ocs_addr.byte.high	/* high  8 bit */

#define 	out_buf_sts0_ep1ocs 	ep1ocs_addr.bit.outxcsr0	/* USB EP1 OUT OUT_BUF_STS0 flag */
#define 	out_buf_sts1_ep1ocs 	ep1ocs_addr.bit.outxcsr1	/* USB EP1 OUT OUT_BUF_STS1 flag */
#define 	over_run_ep1ocs 		ep1ocs_addr.bit.outxcsr2	/* USB EP1 OUT OVER-RUN flag */
#define 	force_stall_ep1ocs		ep1ocs_addr.bit.outxcsr3	/* USB EP1 OUT FORCE_STALL flag */
#define 	data_err_ep1ocs 		ep1ocs_addr.bit.outxcsr4	/* USB EP1 OUT DATA_ERR flag */
#define 	clr_out_buf_rdy_ep1ocs	ep1ocs_addr.bit.outxcsr5	/* USB EP1 OUT CLR_OUT_BUF_RDY */
#define 	clr_over_run_ep1ocs 	ep1ocs_addr.bit.outxcsr6	/* USB EP1 OUT CLR_OVER_RUN */
#define 	clr_force_stall_ep1ocs	ep1ocs_addr.bit.outxcsr7	/* USB EP1 OUT CLR_FORCE_STALL */
#define 	clr_data_err_ep1ocs 	ep1ocs_addr.bit.outxcsr8	/* USB EP1 OUT CLR_DATA_ERR */
#define 	toggle_init_ep1ocs		ep1ocs_addr.bit.outxcsr9	/* USB EP1 OUT TOGGLE_INIT bit */
#define 	flush_ep1ocs			ep1ocs_addr.bit.outxcsr10	/* USB EP1 OUT FLUSH bit */
#define 	iso_ep1ocs				ep1ocs_addr.bit.outxcsr11	/* USB EP1 OUT ISO bit */
#define 	send_stall_ep1ocs		ep1ocs_addr.bit.outxcsr12	/* USB EP1 OUT SEND_STALL bit */
#define 	auto_clr_ep1ocs 		ep1ocs_addr.bit.outxcsr13	/* USB EP1 OUT AUTO_CLR bit */

/*----------------------------------------------
	USB EP2 OUT control/status register
----------------------------------------------*/
#define 	ep2ocs	ep2ocs_addr.word		/* 16 bit */
#define 	ep2ocsl 	ep2ocs_addr.byte.low	/* low	8 bit */
#define 	ep2ocsh 	ep2ocs_addr.byte.high	/* high  8 bit */

#define 	out_buf_sts0_ep2ocs 	ep2ocs_addr.bit.outxcsr0	/* USB EP2 OUT OUT_BUF_STS0 flag */
#define 	out_buf_sts1_ep2ocs 	ep2ocs_addr.bit.outxcsr1	/* USB EP2 OUT OUT_BUF_STS1 flag */
#define 	over_run_ep2ocs 		ep2ocs_addr.bit.outxcsr2	/* USB EP2 OUT OVER-RUN flag */
#define 	force_stall_ep2ocs		ep2ocs_addr.bit.outxcsr3	/* USB EP2 OUT FORCE_STALL flag */
#define 	data_err_ep2ocs 		ep2ocs_addr.bit.outxcsr4	/* USB EP2 OUT DATA_ERR flag */
#define 	clr_out_buf_rdy_ep2ocs	ep2ocs_addr.bit.outxcsr5	/* USB EP2 OUT CLR_OUT_BUF_RDY */
#define 	clr_over_run_ep2ocs 	ep2ocs_addr.bit.outxcsr6	/* USB EP2 OUT CLR_OVER_RUN */
#define 	clr_force_stall_ep2ocs	ep2ocs_addr.bit.outxcsr7	/* USB EP2 OUT CLR_FORCE_STALL */
#define 	clr_data_err_ep2ocs 	ep2ocs_addr.bit.outxcsr8	/* USB EP2 OUT CLR_DATA_ERR */
#define 	toggle_init_ep2ocs		ep2ocs_addr.bit.outxcsr9	/* USB EP2 OUT TOGGLE_INIT bit */
#define 	flush_ep2ocs			ep2ocs_addr.bit.outxcsr10	/* USB EP2 OUT FLUSH bit */
#define 	iso_ep2ocs				ep2ocs_addr.bit.outxcsr11	/* USB EP2 OUT ISO bit */
#define 	send_stall_ep2ocs		ep2ocs_addr.bit.outxcsr12	/* USB EP2 OUT SEND_STALL bit */
#define 	auto_clr_ep2ocs 		ep2ocs_addr.bit.outxcsr13	/* USB EP2 OUT AUTO_CLR bit */

/*----------------------------------------------
	USB EP3 OUT control/status register
----------------------------------------------*/
#define 	ep3ocs	ep3ocs_addr.word		/* 16 bit */
#define 	ep3ocsl 	ep3ocs_addr.byte.low	/* low	8 bit */
#define 	ep3ocsh 	ep3ocs_addr.byte.high	/* high  8 bit */

#define 	out_buf_sts0_ep3ocs 	ep3ocs_addr.bit.outxcsr0	/* USB EP3 OUT OUT_BUF_STS0 flag */
#define 	out_buf_sts1_ep3ocs 	ep3ocs_addr.bit.outxcsr1	/* USB EP3 OUT OUT_BUF_STS1 flag */
#define 	over_run_ep3ocs 		ep3ocs_addr.bit.outxcsr2	/* USB EP3 OUT OVER-RUN flag */
#define 	force_stall_ep3ocs		ep3ocs_addr.bit.outxcsr3	/* USB EP3 OUT FORCE_STALL flag */
#define 	data_err_ep3ocs 		ep3ocs_addr.bit.outxcsr4	/* USB EP3 OUT DATA_ERR flag */
#define 	clr_out_buf_rdy_ep3ocs	ep3ocs_addr.bit.outxcsr5	/* USB EP3 OUT CLR_OUT_BUF_RDY */
#define 	clr_over_run_ep3ocs 	ep3ocs_addr.bit.outxcsr6	/* USB EP3 OUT CLR_OVER_RUN */
#define 	clr_force_stall_ep3ocs	ep3ocs_addr.bit.outxcsr7	/* USB EP3 OUT CLR_FORCE_STALL */
#define 	clr_data_err_ep3ocs 	ep3ocs_addr.bit.outxcsr8	/* USB EP3 OUT CLR_DATA_ERR */
#define 	toggle_init_ep3ocs		ep3ocs_addr.bit.outxcsr9	/* USB EP3 OUT TOGGLE_INIT bit */
#define 	flush_ep3ocs			ep3ocs_addr.bit.outxcsr10	/* USB EP3 OUT FLUSH bit */
#define 	iso_ep3ocs				ep3ocs_addr.bit.outxcsr11	/* USB EP3 OUT ISO bit */
#define 	send_stall_ep3ocs		ep3ocs_addr.bit.outxcsr12	/* USB EP3 OUT SEND_STALL bit */
#define 	auto_clr_ep3ocs 		ep3ocs_addr.bit.outxcsr13	/* USB EP3 OUT AUTO_CLR bit */

/*----------------------------------------------
	USB EP4 OUT control/status register
----------------------------------------------*/
#define 	ep4ocs	ep4ocs_addr.word		/* 16 bit */
#define 	ep4ocsl 	ep4ocs_addr.byte.low	/* low	8 bit */
#define 	ep4ocsh 	ep4ocs_addr.byte.high	/* high  8 bit */

#define 	out_buf_sts0_ep4ocs 	ep4ocs_addr.bit.outxcsr0	/* USB EP4 OUT OUT_BUF_STS0 flag */
#define 	out_buf_sts1_ep4ocs 	ep4ocs_addr.bit.outxcsr1	/* USB EP4 OUT OUT_BUF_STS1 flag */
#define 	over_run_ep4ocs 		ep4ocs_addr.bit.outxcsr2	/* USB EP4 OUT OVER-RUN flag */
#define 	force_stall_ep4ocs		ep4ocs_addr.bit.outxcsr3	/* USB EP4 OUT FORCE_STALL flag */
#define 	data_err_ep4ocs 		ep4ocs_addr.bit.outxcsr4	/* USB EP4 OUT DATA_ERR flag */
#define 	clr_out_buf_rdy_ep4ocs	ep4ocs_addr.bit.outxcsr5	/* USB EP4 OUT CLR_OUT_BUF_RDY */
#define 	clr_over_run_ep4ocs 	ep4ocs_addr.bit.outxcsr6	/* USB EP4 OUT CLR_OVER_RUN */
#define 	clr_force_stall_ep4ocs	ep4ocs_addr.bit.outxcsr7	/* USB EP4 OUT CLR_FORCE_STALL */
#define 	clr_data_err_ep4ocs 	ep4ocs_addr.bit.outxcsr8	/* USB EP4 OUT CLR_DATA_ERR */
#define 	toggle_init_ep4ocs		ep4ocs_addr.bit.outxcsr9	/* USB EP4 OUT TOGGLE_INIT bit */
#define 	flush_ep4ocs			ep4ocs_addr.bit.outxcsr10	/* USB EP4 OUT FLUSH bit */
#define 	iso_ep4ocs				ep4ocs_addr.bit.outxcsr11	/* USB EP4 OUT ISO bit */
#define 	send_stall_ep4ocs		ep4ocs_addr.bit.outxcsr12	/* USB EP4 OUT SEND_STALL bit */
#define 	auto_clr_ep4ocs 		ep4ocs_addr.bit.outxcsr13	/* USB EP4 OUT AUTO_CLR bit */

/*============================================*/
/*	   USB EP0 max packet size register 	*/
/*============================================*/
union {
	struct {
		char	epxmp0:1;			/* Maximum packet size 0 */
		char	epxmp1:1;			/* Maximum packet size 1 */
		char	epxmp2:1;			/* Maximum packet size 2 */
		char	epxmp3:1;			/* Maximum packet size 3 */
		char	epxmp4:1;			/* Maximum packet size 4 */
		char	epxmp5:1;			/* Maximum packet size 5 */
		char	epxmp6:1;			/* Maximum packet size 6 */
		char	b7:1;				/* Reserved */
		char	b8:1;				/* Reserved */
		char	b9:1;				/* Reserved */
		char	b10:1;				/* Reserved */
		char	b11:1;				/* Reserved */
		char	b12:1;				/* Reserved */
		char	b13:1;				/* Reserved */
		char	b14:1;				/* Reserved */
		char	b15:1;				/* Reserved */
	} bit;
	struct {
		unsigned char	 low;	/* low	8 bit */
		unsigned char	 high;	/* high 8 bit */
	} byte;
	unsigned short	word;
} ep0mp_addr;

/*----------------------------------------------
	USB EP0 max packet size register
----------------------------------------------*/
#define 	ep0mp	ep0mp_addr.word 		/* 16 bit */
#define 	ep0mpl		ep0mp_addr.byte.low 	/* low	8 bit */
#define 	ep0mph		ep0mp_addr.byte.high	/* high  8 bit */

#define 	ep0mpr0 	ep0mp_addr.bit.epxmpr0	/* Maximum packet size 0 */
#define 	ep0mpr1 	ep0mp_addr.bit.epxmpr1	/* Maximum packet size 1 */
#define 	ep0mpr2 	ep0mp_addr.bit.epxmpr2	/* Maximum packet size 2 */
#define 	ep0mpr3 	ep0mp_addr.bit.epxmpr3	/* Maximum packet size 3 */
#define 	ep0mpr4 	ep0mp_addr.bit.epxmpr4	/* Maximum packet size 4 */
#define 	ep0mpr5 	ep0mp_addr.bit.epxmpr5	/* Maximum packet size 5 */
#define 	ep0mpr6 	ep0mp_addr.bit.epxmpr6	/* Maximum packet size 6 */

/*============================================*/
/*	   declare USB EPx IN/OUT config. bit	  */
/*============================================*/
union {
	struct {
		char	buf_num0:1; 		/* FIFO buffer start number 0 */
		char	buf_num1:1; 		/* FIFO buffer start number 1 */
		char	buf_num2:1; 		/* FIFO buffer start number 2 */
		char	buf_num3:1; 		/* FIFO buffer start number 3 */
		char	buf_num4:1; 		/* FIFO buffer start number 4 */
		char	buf_num5:1; 		/* FIFO buffer start number 5 */
		char	buf_size0:1;		/* FIFO buffer size 0 */
		char	buf_size1:1;		/* FIFO buffer size 1 */
		char	buf_size2:1;		/* FIFO buffer size 2 */
		char	buf_size3:1;		/* FIFO buffer size 3 */
		char	dbl_buf:1;			/* Double buffer mode */
		char	continue_m:1;		/* Continuous transfer mode */
		char	b12:1;				/* Reserved */
		char	b13:1;				/* Reserved */
		char	b14:1;				/* Reserved */
		char	b15:1;				/* Reserved */
	} bit;
	struct {
		unsigned char	 low;	/* low	8 bit */
		unsigned char	 high;	/* high 8 bit */
	} byte;
	unsigned short	word;
} ep1ifc_addr,ep2ifc_addr,ep3ifc_addr,ep4ifc_addr,
  ep1ofc_addr,ep2ofc_addr,ep3ofc_addr,ep4ofc_addr;

/*----------------------------------------------
	USB EP1 IN FIFO configuration register
----------------------------------------------*/
#define 	ep1ifc	ep1ifc_addr.word		/* 16 bit */
#define 	ep1ifcl 	ep1ifc_addr.byte.low	/* low	8 bit */
#define 	ep1ifch 	ep1ifc_addr.byte.high	/* high  8 bit */

#define 	buf_num0_ep1ifc  ep1ifc_addr.bit.buf_num0	/* USB EP1 IN FIFO buffer start number 0 */
#define 	buf_num1_ep1ifc  ep1ifc_addr.bit.buf_num1	/* USB EP1 IN FIFO buffer start number 1 */
#define 	buf_num2_ep1ifc  ep1ifc_addr.bit.buf_num2	/* USB EP1 IN FIFO buffer start number 2 */
#define 	buf_num3_ep1ifc  ep1ifc_addr.bit.buf_num3	/* USB EP1 IN FIFO buffer start number 3 */
#define 	buf_num4_ep1ifc  ep1ifc_addr.bit.buf_num4	/* USB EP1 IN FIFO buffer start number 4 */
#define 	buf_num5_ep1ifc  ep1ifc_addr.bit.buf_num5	/* USB EP1 IN FIFO buffer start number 5 */
#define 	buf_size0_ep1ifc ep1ifc_addr.bit.buf_size0	/* USB EP1 IN FIFO buffer size 0 */
#define 	buf_size1_ep1ifc ep1ifc_addr.bit.buf_size1	/* USB EP1 IN FIFO buffer size 1 */
#define 	buf_size2_ep1ifc ep1ifc_addr.bit.buf_size2	/* USB EP1 IN FIFO buffer size 2 */
#define 	buf_size3_ep1ifc ep1ifc_addr.bit.buf_size3	/* USB EP1 IN FIFO buffer size 3 */
#define 	dbl_buf_ep1ifc	 ep1ifc_addr.bit.dbl_buf	/* USB EP1 IN FIFO Double buffer mode */
#define 	continue_ep1ifc  ep1ifc_addr.bit.continue_m /* USB EP1 IN FIFO Continuous transfer mode */

/*----------------------------------------------
	USB EP2 IN FIFO configuration register
----------------------------------------------*/
#define 	ep2ifc	ep2ifc_addr.word		/* 16 bit */
#define 	ep2ifcl 	ep2ifc_addr.byte.low	/* low	8 bit */
#define 	ep2ifch 	ep2ifc_addr.byte.high	/* high  8 bit */

#define 	buf_num0_ep2ifc  ep2ifc_addr.bit.buf_num0	/* USB EP2 IN FIFO buffer start number 0 */
#define 	buf_num1_ep2ifc  ep2ifc_addr.bit.buf_num1	/* USB EP2 IN FIFO buffer start number 1 */
#define 	buf_num2_ep2ifc  ep2ifc_addr.bit.buf_num2	/* USB EP2 IN FIFO buffer start number 2 */
#define 	buf_num3_ep2ifc  ep2ifc_addr.bit.buf_num3	/* USB EP2 IN FIFO buffer start number 3 */
#define 	buf_num4_ep2ifc  ep2ifc_addr.bit.buf_num4	/* USB EP2 IN FIFO buffer start number 4 */
#define 	buf_num5_ep2ifc  ep2ifc_addr.bit.buf_num5	/* USB EP2 IN FIFO buffer start number 5 */
#define 	buf_size0_ep2ifc ep2ifc_addr.bit.buf_size0	/* USB EP2 IN FIFO buffer size 0 */
#define 	buf_size1_ep2ifc ep2ifc_addr.bit.buf_size1	/* USB EP2 IN FIFO buffer size 1 */
#define 	buf_size2_ep2ifc ep2ifc_addr.bit.buf_size2	/* USB EP2 IN FIFO buffer size 2 */
#define 	buf_size3_ep2ifc ep2ifc_addr.bit.buf_size3	/* USB EP2 IN FIFO buffer size 3 */
#define 	dbl_buf_ep2ifc	 ep2ifc_addr.bit.dbl_buf	/* USB EP2 IN FIFO Double buffer mode */
#define 	continue_ep2ifc  ep2ifc_addr.bit.continue_m /* USB EP2 IN FIFO Continuous transfer mode */

/*----------------------------------------------
	USB EP3 IN FIFO configuration register
----------------------------------------------*/
#define 	ep3ifc	ep3ifc_addr.word		/* 16 bit */
#define 	ep3ifcl 	ep3ifc_addr.byte.low	/* low	8 bit */
#define 	ep3ifch 	ep3ifc_addr.byte.high	/* high  8 bit */

#define 	buf_num0_ep3ifc  ep3ifc_addr.bit.buf_num0	/* USB EP3 IN FIFO buffer start number 0 */
#define 	buf_num1_ep3ifc  ep3ifc_addr.bit.buf_num1	/* USB EP3 IN FIFO buffer start number 1 */
#define 	buf_num2_ep3ifc  ep3ifc_addr.bit.buf_num2	/* USB EP3 IN FIFO buffer start number 2 */
#define 	buf_num3_ep3ifc  ep3ifc_addr.bit.buf_num3	/* USB EP3 IN FIFO buffer start number 3 */
#define 	buf_num4_ep3ifc  ep3ifc_addr.bit.buf_num4	/* USB EP3 IN FIFO buffer start number 4 */
#define 	buf_num5_ep3ifc  ep3ifc_addr.bit.buf_num5	/* USB EP3 IN FIFO buffer start number 5 */
#define 	buf_size0_ep3ifc ep3ifc_addr.bit.buf_size0	/* USB EP3 IN FIFO buffer size 0 */
#define 	buf_size1_ep3ifc ep3ifc_addr.bit.buf_size1	/* USB EP3 IN FIFO buffer size 1 */
#define 	buf_size2_ep3ifc ep3ifc_addr.bit.buf_size2	/* USB EP3 IN FIFO buffer size 2 */
#define 	buf_size3_ep3ifc ep3ifc_addr.bit.buf_size3	/* USB EP3 IN FIFO buffer size 3 */
#define 	dbl_buf_ep3ifc	 ep3ifc_addr.bit.dbl_buf	/* USB EP3 IN FIFO Double buffer mode */
#define 	continue_ep3ifc  ep3ifc_addr.bit.continue_m /* USB EP3 IN FIFO Continuous transfer mode */

/*----------------------------------------------
	USB EP4 IN FIFO configuration register
----------------------------------------------*/
#define 	ep4ifc	ep4ifc_addr.word		/* 16 bit */
#define 	ep4ifcl 	ep4ifc_addr.byte.low	/* low	8 bit */
#define 	ep4ifch 	ep4ifc_addr.byte.high	/* high  8 bit */

#define 	buf_num0_ep4ifc  ep4ifc_addr.bit.buf_num0	/* USB EP4 IN FIFO buffer start number 0 */
#define 	buf_num1_ep4ifc  ep4ifc_addr.bit.buf_num1	/* USB EP4 IN FIFO buffer start number 1 */
#define 	buf_num2_ep4ifc  ep4ifc_addr.bit.buf_num2	/* USB EP4 IN FIFO buffer start number 2 */
#define 	buf_num3_ep4ifc  ep4ifc_addr.bit.buf_num3	/* USB EP4 IN FIFO buffer start number 3 */
#define 	buf_num4_ep4ifc  ep4ifc_addr.bit.buf_num4	/* USB EP4 IN FIFO buffer start number 4 */
#define 	buf_num5_ep4ifc  ep4ifc_addr.bit.buf_num5	/* USB EP4 IN FIFO buffer start number 5 */
#define 	buf_size0_ep4ifc ep4ifc_addr.bit.buf_size0	/* USB EP4 IN FIFO buffer size 0 */
#define 	buf_size1_ep4ifc ep4ifc_addr.bit.buf_size1	/* USB EP4 IN FIFO buffer size 1 */
#define 	buf_size2_ep4ifc ep4ifc_addr.bit.buf_size2	/* USB EP4 IN FIFO buffer size 2 */
#define 	buf_size3_ep4ifc ep4ifc_addr.bit.buf_size3	/* USB EP4 IN FIFO buffer size 3 */
#define 	dbl_buf_ep4ifc	 ep4ifc_addr.bit.dbl_buf	/* USB EP4 IN FIFO Double buffer mode */
#define 	continue_ep4ifc  ep4ifc_addr.bit.continue_m /* USB EP4 IN FIFO Continuous transfer mode */

/*----------------------------------------------
	USB EP1 OUT FIFO configuration register
----------------------------------------------*/
#define 	ep1ofc	ep1ofc_addr.word		/* 16 bit */
#define 	ep1ofcl 	ep1ofc_addr.byte.low	/* low	8 bit */
#define 	ep1ofch 	ep1ofc_addr.byte.high	/* high  8 bit */

#define 	buf_num0_ep1ofc  ep1ofc_addr.bit.buf_num0	/* USB EP1 OUT FIFO buffer start number 0 */
#define 	buf_num1_ep1ofc  ep1ofc_addr.bit.buf_num1	/* USB EP1 OUT FIFO buffer start number 1 */
#define 	buf_num2_ep1ofc  ep1ofc_addr.bit.buf_num2	/* USB EP1 OUT FIFO buffer start number 2 */
#define 	buf_num3_ep1ofc  ep1ofc_addr.bit.buf_num3	/* USB EP1 OUT FIFO buffer start number 3 */
#define 	buf_num4_ep1ofc  ep1ofc_addr.bit.buf_num4	/* USB EP1 OUT FIFO buffer start number 4 */
#define 	buf_num5_ep1ofc  ep1ofc_addr.bit.buf_num5	/* USB EP1 OUT FIFO buffer start number 5 */
#define 	buf_size0_ep1ofc ep1ofc_addr.bit.buf_size0	/* USB EP1 OUT FIFO buffer size 0 */
#define 	buf_size1_ep1ofc ep1ofc_addr.bit.buf_size1	/* USB EP1 OUT FIFO buffer size 1 */
#define 	buf_size2_ep1ofc ep1ofc_addr.bit.buf_size2	/* USB EP1 OUT FIFO buffer size 2 */
#define 	buf_size3_ep1ofc ep1ofc_addr.bit.buf_size3	/* USB EP1 OUT FIFO buffer size 3 */
#define 	dbl_buf_ep1ofc	 ep1ofc_addr.bit.dbl_buf	/* USB EP1 OUT FIFO Double buffer mode */
#define 	continue_ep1ofc  ep1ofc_addr.bit.continue_m /* USB EP1 OUT FIFO Continuous transfer mode */

/*----------------------------------------------
	USB EP2 OUT FIFO configuration register
----------------------------------------------*/
#define 	ep2ofc	ep2ofc_addr.word		/* 16 bit */
#define 	ep2ofcl 	ep2ofc_addr.byte.low	/* low	8 bit */
#define 	ep2ofch 	ep2ofc_addr.byte.high	/* high  8 bit */

#define 	buf_num0_ep2ofc  ep2ofc_addr.bit.buf_num0	/* USB EP2 OUT FIFO buffer start number 0 */
#define 	buf_num1_ep2ofc  ep2ofc_addr.bit.buf_num1	/* USB EP2 OUT FIFO buffer start number 1 */
#define 	buf_num2_ep2ofc  ep2ofc_addr.bit.buf_num2	/* USB EP2 OUT FIFO buffer start number 2 */
#define 	buf_num3_ep2ofc  ep2ofc_addr.bit.buf_num3	/* USB EP2 OUT FIFO buffer start number 3 */
#define 	buf_num4_ep2ofc  ep2ofc_addr.bit.buf_num4	/* USB EP2 OUT FIFO buffer start number 4 */
#define 	buf_num5_ep2ofc  ep2ofc_addr.bit.buf_num5	/* USB EP2 OUT FIFO buffer start number 5 */
#define 	buf_size0_ep2ofc ep2ofc_addr.bit.buf_size0	/* USB EP2 OUT FIFO buffer size 0 */
#define 	buf_size1_ep2ofc ep2ofc_addr.bit.buf_size1	/* USB EP2 OUT FIFO buffer size 1 */
#define 	buf_size2_ep2ofc ep2ofc_addr.bit.buf_size2	/* USB EP2 OUT FIFO buffer size 2 */
#define 	buf_size3_ep2ofc ep2ofc_addr.bit.buf_size3	/* USB EP2 OUT FIFO buffer size 3 */
#define 	dbl_buf_ep2ofc	 ep2ofc_addr.bit.dbl_buf	/* USB EP2 OUT FIFO Double buffer mode */
#define 	continue_ep2ofc  ep2ofc_addr.bit.continue_m /* USB EP2 OUT FIFO Continuous transfer mode */

/*----------------------------------------------
	USB EP3 OUT FIFO configuration register
----------------------------------------------*/
#define 	ep3ofc	ep3ofc_addr.word		/* 16 bit */
#define 	ep3ofcl 	ep3ofc_addr.byte.low	/* low	8 bit */
#define 	ep3ofch 	ep3ofc_addr.byte.high	/* high  8 bit */

#define 	buf_num0_ep3ofc  ep3ofc_addr.bit.buf_num0	/* USB EP3 OUT FIFO buffer start number 0 */
#define 	buf_num1_ep3ofc  ep3ofc_addr.bit.buf_num1	/* USB EP3 OUT FIFO buffer start number 1 */
#define 	buf_num2_ep3ofc  ep3ofc_addr.bit.buf_num2	/* USB EP3 OUT FIFO buffer start number 2 */
#define 	buf_num3_ep3ofc  ep3ofc_addr.bit.buf_num3	/* USB EP3 OUT FIFO buffer start number 3 */
#define 	buf_num4_ep3ofc  ep3ofc_addr.bit.buf_num4	/* USB EP3 OUT FIFO buffer start number 4 */
#define 	buf_num5_ep3ofc  ep3ofc_addr.bit.buf_num5	/* USB EP3 OUT FIFO buffer start number 5 */
#define 	buf_size0_ep3ofc ep3ofc_addr.bit.buf_size0	/* USB EP3 OUT FIFO buffer size 0 */
#define 	buf_size1_ep3ofc ep3ofc_addr.bit.buf_size1	/* USB EP3 OUT FIFO buffer size 1 */
#define 	buf_size2_ep3ofc ep3ofc_addr.bit.buf_size2	/* USB EP3 OUT FIFO buffer size 2 */
#define 	buf_size3_ep3ofc ep3ofc_addr.bit.buf_size3	/* USB EP3 OUT FIFO buffer size 3 */
#define 	dbl_buf_ep3ofc	 ep3ofc_addr.bit.dbl_buf	/* USB EP3 OUT FIFO Double buffer mode */
#define 	continue_ep3ofc  ep3ofc_addr.bit.continue_m /* USB EP3 OUT FIFO Continuous transfer mode */

/*----------------------------------------------
	USB EP4 OUT FIFO configuration register
----------------------------------------------*/
#define 	ep4ofc	ep4ofc_addr.word		/* 16 bit */
#define 	ep4ofcl 	ep4ofc_addr.byte.low	/* low	8 bit */
#define 	ep4ofch 	ep4ofc_addr.byte.high	/* high  8 bit */

#define 	buf_num0_ep4ofc  ep4ofc_addr.bit.buf_num0	/* USB EP4 OUT FIFO buffer start number 0 */
#define 	buf_num1_ep4ofc  ep4ofc_addr.bit.buf_num1	/* USB EP4 OUT FIFO buffer start number 1 */
#define 	buf_num2_ep4ofc  ep4ofc_addr.bit.buf_num2	/* USB EP4 OUT FIFO buffer start number 2 */
#define 	buf_num3_ep4ofc  ep4ofc_addr.bit.buf_num3	/* USB EP4 OUT FIFO buffer start number 3 */
#define 	buf_num4_ep4ofc  ep4ofc_addr.bit.buf_num4	/* USB EP4 OUT FIFO buffer start number 4 */
#define 	buf_num5_ep4ofc  ep4ofc_addr.bit.buf_num5	/* USB EP4 OUT FIFO buffer start number 5 */
#define 	buf_size0_ep4ofc ep4ofc_addr.bit.buf_size0	/* USB EP4 OUT FIFO buffer size 0 */
#define 	buf_size1_ep4ofc ep4ofc_addr.bit.buf_size1	/* USB EP4 OUT FIFO buffer size 1 */
#define 	buf_size2_ep4ofc ep4ofc_addr.bit.buf_size2	/* USB EP4 OUT FIFO buffer size 2 */
#define 	buf_size3_ep4ofc ep4ofc_addr.bit.buf_size3	/* USB EP4 OUT FIFO buffer size 3 */
#define 	dbl_buf_ep4ofc	 ep4ofc_addr.bit.dbl_buf	/* USB EP4 OUT FIFO Double buffer mode */
#define 	continue_ep4ofc  ep4ofc_addr.bit.continue_m /* USB EP4 OUT FIFO Continuous transfer mode */

/*============================================*/
/*		  declare DMAx cause select bit 	  */
/*============================================*/
union {
	struct {
		char	dsel0:1;			/* DMA request cause select bit */
		char	dsel1:1;			/* DMA request cause select bit */
		char	dsel2:1;			/* DMA request cause select bit */
		char	dsel3:1;			/* DMA request cause select bit */
		char	dsel4:1;			/* DMA request cause select bit */
		char	b5:1;				/* Nothing is assigned */
		char	b6:1;				/* Nothing is assigned */
		char	dsr:1;				/* Software DMA request bit */
	} bit;
	unsigned char  byte;
} dm0sl_addr,dm1sl_addr,dm2sl_addr,dm3sl_addr;

/*----------------------------------------------
	DMA0 cause select register
----------------------------------------------*/
#define 	dm0sl	dm0sl_addr.byte

#define 	dsel0_dm0sl dm0sl_addr.bit.dsel0		/* DMA request cause select bit */
#define 	dsel1_dm0sl dm0sl_addr.bit.dsel1		/* DMA request cause select bit */
#define 	dsel2_dm0sl dm0sl_addr.bit.dsel2		/* DMA request cause select bit */
#define 	dsel3_dm0sl dm0sl_addr.bit.dsel3		/* DMA request cause select bit */
#define 	dsel4_dm0sl dm0sl_addr.bit.dsel4		/* DMA request cause select bit */
#define 	dsr_dm0sl	dm0sl_addr.bit.dsr			/* Software DMA request bit */

/*----------------------------------------------
	DMA1 cause select register
----------------------------------------------*/
#define 	dm1sl	dm1sl_addr.byte

#define 	dsel0_dm1sl dm1sl_addr.bit.dsel0		/* DMA request cause select bit */
#define 	dsel1_dm1sl dm1sl_addr.bit.dsel1		/* DMA request cause select bit */
#define 	dsel2_dm1sl dm1sl_addr.bit.dsel2		/* DMA request cause select bit */
#define 	dsel3_dm1sl dm1sl_addr.bit.dsel3		/* DMA request cause select bit */
#define 	dsel4_dm1sl dm1sl_addr.bit.dsel4		/* DMA request cause select bit */
#define 	dsr_dm1sl	dm1sl_addr.bit.dsr			/* Software DMA request bit */

/*----------------------------------------------
	DMA2 cause select register
----------------------------------------------*/
#define 	dm2sl	dm2sl_addr.byte

#define 	dsel0_dm2sl dm2sl_addr.bit.dsel0		/* DMA request cause select bit */
#define 	dsel1_dm2sl dm2sl_addr.bit.dsel1		/* DMA request cause select bit */
#define 	dsel2_dm2sl dm2sl_addr.bit.dsel2		/* DMA request cause select bit */
#define 	dsel3_dm2sl dm2sl_addr.bit.dsel3		/* DMA request cause select bit */
#define 	dsel4_dm2sl dm2sl_addr.bit.dsel4		/* DMA request cause select bit */
#define 	dsr_dm2sl	dm2sl_addr.bit.dsr			/* Software DMA request bit */

/*----------------------------------------------
	DMA3 cause select register
----------------------------------------------*/
#define 	dm3sl	dm3sl_addr.byte

#define 	dsel0_dm3sl dm3sl_addr.bit.dsel0		/* DMA request cause select bit */
#define 	dsel1_dm3sl dm3sl_addr.bit.dsel1		/* DMA request cause select bit */
#define 	dsel2_dm3sl dm3sl_addr.bit.dsel2		/* DMA request cause select bit */
#define 	dsel3_dm3sl dm3sl_addr.bit.dsel3		/* DMA request cause select bit */
#define 	dsel4_dm3sl dm3sl_addr.bit.dsel4		/* DMA request cause select bit */
#define 	dsr_dm3sl	dm3sl_addr.bit.dsr			/* Software DMA request bit */

/*============================================*/
/*		  declare DMAx control bit			  */
/*============================================*/
union {
	struct {
		char	dmbit:1;			/* Transfer unit bit select bit */
		char	dmasl:1;			/* Repeat transfer mode select bit */
		char	dmas:1; 			/* DMA request bit */
		char	dmae:1; 			/* DMA enable bit */
		char	dsd:1;				/* Source address direction select bit */
		char	dad:1;				/* Destination address direction select bit */
		char	b6:1;				/* Nothing is assigned */
		char	b7:1;				/* Nothing is assigned */
	} bit;
	unsigned char  byte;
} dm0con_addr,dm1con_addr,dm2con_addr,dm3con_addr;

/*----------------------------------------------
	DMA0 control register
----------------------------------------------*/
#define 	dm0con	dm0con_addr.byte

#define 	dmbit_dm0con	dm0con_addr.bit.dmbit	/* Transfer unit bit select bit */
#define 	dmasl_dm0con	dm0con_addr.bit.dmasl	/* Repeat transfer mode select bit */
#define 	dmas_dm0con 	dm0con_addr.bit.dmas	/* DMA request bit */
#define 	dmae_dm0con 	dm0con_addr.bit.dmae	/* DMA enable bit */
#define 	dsd_dm0con		dm0con_addr.bit.dsd 	/* Source address direction select bit */
#define 	dad_dm0con		dm0con_addr.bit.dad 	/* Destination address direction select bit */

/*----------------------------------------------
	DMA1 control register
----------------------------------------------*/
#define 	dm1con	dm1con_addr.byte

#define 	dmbit_dm1con	dm1con_addr.bit.dmbit	/* Transfer unit bit select bit */
#define 	dmasl_dm1con	dm1con_addr.bit.dmasl	/* Repeat transfer mode select bit */
#define 	dmas_dm1con 	dm1con_addr.bit.dmas	/* DMA request bit */
#define 	dmae_dm1con 	dm1con_addr.bit.dmae	/* DMA enable bit */
#define 	dsd_dm1con		dm1con_addr.bit.dsd 	/* Source address direction select bit */
#define 	dad_dm1con		dm1con_addr.bit.dad 	/* Destination address direction select bit */

/*----------------------------------------------
	DMA2 control register
----------------------------------------------*/
#define 	dm2con	dm2con_addr.byte

#define 	dmbit_dm2con	dm2con_addr.bit.dmbit	/* Transfer unit bit select bit */
#define 	dmasl_dm2con	dm2con_addr.bit.dmasl	/* Repeat transfer mode select bit */
#define 	dmas_dm2con 	dm2con_addr.bit.dmas	/* DMA request bit */
#define 	dmae_dm2con 	dm2con_addr.bit.dmae	/* DMA enable bit */
#define 	dsd_dm2con		dm2con_addr.bit.dsd 	/* Source address direction select bit */
#define 	dad_dm2con		dm2con_addr.bit.dad 	/* Destination address direction select bit */

/*----------------------------------------------
	DMA3 control register
----------------------------------------------*/
#define 	dm3con	dm3con_addr.byte

#define 	dmbit_dm3con	dm3con_addr.bit.dmbit	/* Transfer unit bit select bit */
#define 	dmasl_dm3con	dm3con_addr.bit.dmasl	/* Repeat transfer mode select bit */
#define 	dmas_dm3con 	dm3con_addr.bit.dmas	/* DMA request bit */
#define 	dmae_dm3con 	dm3con_addr.bit.dmae	/* DMA enable bit */
#define 	dsd_dm3con		dm3con_addr.bit.dsd 	/* Source address direction select bit */
#define 	dad_dm3con		dm3con_addr.bit.dad 	/* Destination address direction select bit */

/*============================================*/
/*		  declare Timer A0 mode bit 		  */
/*============================================*/
union {
	struct {
		char	tmod0:1;			/* Operation mode select bit */
		char	tmod1:1;			/* Operation mode select bit */
		char	mr0:1;
		char	mr1:1;
		char	mr2:1;
		char	mr3:1;
		char	tck0:1; 			/* Count source select bit */
		char	tck1:1; 			/* Count source select bit */
	} bit;
	unsigned char  byte;
} ta0mr_addr,ta1mr_addr,ta2mr_addr,ta3mr_addr,ta4mr_addr;

/*----------------------------------------------
	Timer A0 mode register
----------------------------------------------*/
#define 	ta0mr	ta0mr_addr.byte

#define 	tmod0_ta0mr ta0mr_addr.bit.tmod0		/* Operation mode select bit */
#define 	tmod1_ta0mr ta0mr_addr.bit.tmod1		/* Operation mode select bit */
#define 	mr0_ta0mr	ta0mr_addr.bit.mr0
#define 	mr1_ta0mr	ta0mr_addr.bit.mr1
#define 	mr2_ta0mr	ta0mr_addr.bit.mr2
#define 	mr3_ta0mr	ta0mr_addr.bit.mr3
#define 	tck0_ta0mr	ta0mr_addr.bit.tck0 		/* Count source select bit */
#define 	tck1_ta0mr	ta0mr_addr.bit.tck1 		/* Count source select bit */

/*----------------------------------------------
	Timer A1 mode register
----------------------------------------------*/
#define 	ta1mr	ta1mr_addr.byte

#define 	tmod0_ta1mr ta1mr_addr.bit.tmod0		/* Operation mode select bit */
#define 	tmod1_ta1mr ta1mr_addr.bit.tmod1		/* Operation mode select bit */
#define 	mr0_ta1mr	ta1mr_addr.bit.mr0
#define 	mr1_ta1mr	ta1mr_addr.bit.mr1
#define 	mr2_ta1mr	ta1mr_addr.bit.mr2
#define 	mr3_ta1mr	ta1mr_addr.bit.mr3
#define 	tck0_ta1mr	ta1mr_addr.bit.tck0 		/* Count source select bit */
#define 	tck1_ta1mr	ta1mr_addr.bit.tck1 		/* Count source select bit */

/*----------------------------------------------
	Timer A2 mode register
----------------------------------------------*/
#define 	ta2mr	ta2mr_addr.byte

#define 	tmod0_ta2mr ta2mr_addr.bit.tmod0		/* Operation mode select bit */
#define 	tmod1_ta2mr ta2mr_addr.bit.tmod1		/* Operation mode select bit */
#define 	mr0_ta2mr	ta2mr_addr.bit.mr0
#define 	mr1_ta2mr	ta2mr_addr.bit.mr1
#define 	mr2_ta2mr	ta2mr_addr.bit.mr2
#define 	mr3_ta2mr	ta2mr_addr.bit.mr3
#define 	tck0_ta2mr	ta2mr_addr.bit.tck0 		/* Count source select bit */
#define 	tck1_ta2mr	ta2mr_addr.bit.tck1 		/* Count source select bit */

/*----------------------------------------------
	Timer A3 mode register
----------------------------------------------*/
#define 	ta3mr	ta3mr_addr.byte

#define 	tmod0_ta3mr ta3mr_addr.bit.tmod0		/* Operation mode select bit */
#define 	tmod1_ta3mr ta3mr_addr.bit.tmod1		/* Operation mode select bit */
#define 	mr0_ta3mr	ta3mr_addr.bit.mr0
#define 	mr1_ta3mr	ta3mr_addr.bit.mr1
#define 	mr2_ta3mr	ta3mr_addr.bit.mr2
#define 	mr3_ta3mr	ta3mr_addr.bit.mr3
#define 	tck0_ta3mr	ta3mr_addr.bit.tck0 		/* Count source select bit */
#define 	tck1_ta3mr	ta3mr_addr.bit.tck1 		/* Count source select bit */

/*----------------------------------------------
	Timer A4 mode register
----------------------------------------------*/
#define 	ta4mr	ta4mr_addr.byte

#define 	tmod0_ta4mr ta4mr_addr.bit.tmod0		/* Operation mode select bit */
#define 	tmod1_ta4mr ta4mr_addr.bit.tmod1		/* Operation mode select bit */
#define 	mr0_ta4mr	ta4mr_addr.bit.mr0
#define 	mr1_ta4mr	ta4mr_addr.bit.mr1
#define 	mr2_ta4mr	ta4mr_addr.bit.mr2
#define 	mr3_ta4mr	ta4mr_addr.bit.mr3
#define 	tck0_ta4mr	ta4mr_addr.bit.tck0 		/* Count source select bit */
#define 	tck1_ta4mr	ta4mr_addr.bit.tck1 		/* Count source select bit */

/*============================================*/
/*		declare UARTx receive buffer bit	 */
/*============================================*/
union{
	struct{
		char	b0:1;
		char	b1:1;
		char	b2:1;
		char	b3:1;
		char	b4:1;
		char	b5:1;
		char	b6:1;
		char	b7:1;
		char	b8:1;
		char	b9:1;
		char	b10:1;
		char	abt:1;				/* Arbitration lost detecting flag */
		char	oer:1;				/* Overrun error flag */
		char	fer:1;				/* Framing error flag*/
		char	per:1;				/* Parity error flag */
		char	sum:1;				/* Error sum flag */
	}bit;
	struct{
		unsigned char	 low;		/* Low	8 bit */
		unsigned char	 high;		/* High 8 bit */
	}byte;
	unsigned short	word;
} u0rb_addr,u1rb_addr,u2rb_addr,u3rb_addr;
/*----------------------------------------------
	UART0 receive buffer register
----------------------------------------------*/
#define 	u0rb	u0rb_addr.word
#define 	u0rbl		u0rb_addr.byte.low
#define 	u0rbh		u0rb_addr.byte.high

#define 	oer_u0rb	u0rb_addr.bit.oer		/* Overrun error flag */
#define 	fer_u0rb	u0rb_addr.bit.fer		/* Framing error flag*/
#define 	per_u0rb	u0rb_addr.bit.per		/* Parity error flag */
#define 	sum_u0rb	u0rb_addr.bit.sum		/* Error sum flag */

/*----------------------------------------------
	UART1 receive buffer register
----------------------------------------------*/
#define 	u1rb	u1rb_addr.word
#define 	u1rbl		u1rb_addr.byte.low
#define 	u1rbh		u1rb_addr.byte.high

#define 	oer_u1rb	u1rb_addr.bit.oer		/* Overrun error flag */
#define 	fer_u1rb	u1rb_addr.bit.fer		/* Framing error flag*/
#define 	per_u1rb	u1rb_addr.bit.per		/* Parity error flag */
#define 	sum_u1rb	u1rb_addr.bit.sum		/* Error sum flag */

/*----------------------------------------------
	UART2 receive buffer register
----------------------------------------------*/
#define 	u2rb	u2rb_addr.word
#define 	u2rbl		u2rb_addr.byte.low
#define 	u2rbh		u2rb_addr.byte.high

#define 	abt_u2rb	u2rb_addr.bit.abt		/* Arbitration lost detecting flag */
#define 	oer_u2rb	u2rb_addr.bit.oer		/* Overrun error flag */
#define 	fer_u2rb	u2rb_addr.bit.fer		/* Framing error flag*/
#define 	per_u2rb	u2rb_addr.bit.per		/* Parity error flag */
#define 	sum_u2rb	u2rb_addr.bit.sum		/* Error sum flag */

/*----------------------------------------------
	UART3 receive buffer register
----------------------------------------------*/
#define 	u3rb	u3rb_addr.word
#define 	u3rbl		u3rb_addr.byte.low
#define 	u3rbh		u3rb_addr.byte.high

#define 	abt_u3rb	u3rb_addr.bit.abt		/* Arbitration lost detecting flag */
#define 	oer_u3rb	u3rb_addr.bit.oer		/* Overrun error flag */
#define 	fer_u3rb	u3rb_addr.bit.fer		/* Framing error flag*/
#define 	per_u3rb	u3rb_addr.bit.per		/* Parity error flag */
#define 	sum_u3rb	u3rb_addr.bit.sum		/* Error sum flag */

/*============================================*/
/*		 declare UARTx trs/rcv mode bit 	  */
/*============================================*/
union{
	struct{
		char	smd0:1; 			/* Serial I/O mode select bit */
		char	smd1:1; 			/* Serial I/O mode select bit */
		char	smd2:1; 			/* Serial I/O mode select bit */
		char	ckdir:1;			/* Internal/external clock select bit */
		char	stps:1; 			/* Stop bit length select bit */
		char	pry:1;				/* Odd/even parity select bit */
		char	prye:1; 			/* Parity enable bit */
		char	iopol:1;			/* TxD,RxD input/output polarity switch bit */
	} bit;
	unsigned char  byte;
} u0mr_addr,u1mr_addr,u2mr_addr,u3mr_addr;

/*----------------------------------------------
	UART0 transmit/receive mode register
----------------------------------------------*/
#define 	u0mr	u0mr_addr.byte

#define 	smd0_u0mr	u0mr_addr.bit.smd0	/* Serial I/O mode select bit */
#define 	smd1_u0mr	u0mr_addr.bit.smd1	/* Serial I/O mode select bit */
#define 	smd2_u0mr	u0mr_addr.bit.smd2	/* Serial I/O mode select bit */
#define 	ckdir_u0mr	u0mr_addr.bit.ckdir /* Internal/external clock select bit */
#define 	stps_u0mr	u0mr_addr.bit.stps	/* Stop bit length select bit */
#define 	pry_u0mr	u0mr_addr.bit.pry	/* Odd/even parity select bit */
#define 	prye_u0mr	u0mr_addr.bit.prye	/* Parity enable bit */
#define 	iopol_u0mr	u0mr_addr.bit.iopol /* TxD,RxD input/output polarity switch bit */

/*----------------------------------------------
	UART1 transmit/receive mode register
----------------------------------------------*/
#define 	u1mr	u1mr_addr.byte

#define 	smd0_u1mr	u1mr_addr.bit.smd0	/* Serial I/O mode select bit */
#define 	smd1_u1mr	u1mr_addr.bit.smd1	/* Serial I/O mode select bit */
#define 	smd2_u1mr	u1mr_addr.bit.smd2	/* Serial I/O mode select bit */
#define 	ckdir_u1mr	u1mr_addr.bit.ckdir /* Internal/external clock select bit */
#define 	stps_u1mr	u1mr_addr.bit.stps	/* Stop bit length select bit */
#define 	pry_u1mr	u1mr_addr.bit.pry	/* Odd/even parity select bit */
#define 	prye_u1mr	u1mr_addr.bit.prye	/* Parity enable bit */
#define 	iopol_u1mr	u1mr_addr.bit.iopol /* TxD,RxD input/output polarity switch bit */

/*----------------------------------------------
	UART2 transmit/receive mode register
----------------------------------------------*/
#define 	u2mr	u2mr_addr.byte

#define 	smd0_u2mr	u2mr_addr.bit.smd0	/* Serial I/O mode select bit */
#define 	smd1_u2mr	u2mr_addr.bit.smd1	/* Serial I/O mode select bit */
#define 	smd2_u2mr	u2mr_addr.bit.smd2	/* Serial I/O mode select bit */
#define 	ckdir_u2mr	u2mr_addr.bit.ckdir /* Internal/external clock select bit */
#define 	stps_u2mr	u2mr_addr.bit.stps	/* Stop bit length select bit */
#define 	pry_u2mr	u2mr_addr.bit.pry	/* Odd/even parity select bit */
#define 	prye_u2mr	u2mr_addr.bit.prye	/* Parity enable bit */
#define 	iopol_u2mr	u2mr_addr.bit.iopol /* TxD,RxD input/output polarity switch bit */

/*----------------------------------------------
	UART3 transmit/receive mode register
----------------------------------------------*/
#define 	u3mr	u3mr_addr.byte

#define 	smd0_u3mr	u3mr_addr.bit.smd0	/* Serial I/O mode select bit */
#define 	smd1_u3mr	u3mr_addr.bit.smd1	/* Serial I/O mode select bit */
#define 	smd2_u3mr	u3mr_addr.bit.smd2	/* Serial I/O mode select bit */
#define 	ckdir_u3mr	u3mr_addr.bit.ckdir /* Internal/external clock select bit */
#define 	stps_u3mr	u3mr_addr.bit.stps	/* Stop bit length select bit */
#define 	pry_u3mr	u3mr_addr.bit.pry	/* Odd/even parity select bit */
#define 	prye_u3mr	u3mr_addr.bit.prye	/* Parity enable bit */
#define 	iopol_u3mr	u3mr_addr.bit.iopol /* TxD,RxD input/output polarity switch bit */

/*============================================*/
/*	   declare UARTx trs/rcv control0 bit	  */
/*============================================*/
union {
	struct {
		char	clk0:1; 		/* BRG count source select bit */
		char	clk1:1; 		/* BRG count source select bit */
		char	crs:1;			/* CTS~/RTS~ function select bit */
		char	txept:1;		/* Transmit register empty flag */
		char	crd:1;			/* CTS~/RTS~ disable bit */
		char	nch:1;			/* Data output select bit */
		char	ckpol:1;		/* CLK polarity select bit */
		char	uform:1;		/* Transfer format select bit */
	} bit;
	unsigned char  byte;
} u0c0_addr,u1c0_addr,u2c0_addr,u3c0_addr;

/*----------------------------------------------
	UART0 transmit/receive control register 0
----------------------------------------------*/
#define 	u0c0	u0c0_addr.byte

#define 	clk0_u0c0	u0c0_addr.bit.clk0	/* BRG count source select bit */
#define 	clk1_u0c0	u0c0_addr.bit.clk1	/* BRG count source select bit */
#define 	crs_u0c0	u0c0_addr.bit.crs	/* CTS~/RTS~ function select bit */
#define 	txept_u0c0	u0c0_addr.bit.txept /* Transmit register empty flag */
#define 	crd_u0c0	u0c0_addr.bit.crd	/* CTS~/RTS~ disable bit */
#define 	nch_u0c0	u0c0_addr.bit.nch	/* Data output select bit */
#define 	ckpol_u0c0	u0c0_addr.bit.ckpol /* CLK polarity select bit */
#define 	uform_u0c0	u0c0_addr.bit.uform /* Transfer format select bit */

/*----------------------------------------------
	UART1 transmit/receive control register 0
----------------------------------------------*/
#define 	u1c0	u1c0_addr.byte

#define 	clk0_u1c0	u1c0_addr.bit.clk0	/* BRG count source select bit */
#define 	clk1_u1c0	u1c0_addr.bit.clk1	/* BRG count source select bit */
#define 	crs_u1c0	u1c0_addr.bit.crs	/* CTS~/RTS~ function select bit */
#define 	txept_u1c0	u1c0_addr.bit.txept /* Transmit register empty flag */
#define 	crd_u1c0	u1c0_addr.bit.crd	/* CTS~/RTS~ disable bit */
#define 	nch_u1c0	u1c0_addr.bit.nch	/* Data output select bit */
#define 	ckpol_u1c0	u1c0_addr.bit.ckpol /* CLK polarity select bit */
#define 	uform_u1c0	u1c0_addr.bit.uform /* Transfer format select bit */

/*----------------------------------------------
	UART2 transmit/receive control register 0
----------------------------------------------*/
#define 	u2c0	u2c0_addr.byte

#define 	clk0_u2c0	u2c0_addr.bit.clk0	/* BRG count source select bit */
#define 	clk1_u2c0	u2c0_addr.bit.clk1	/* BRG count source select bit */
#define 	crs_u2c0	u2c0_addr.bit.crs	/* CTS~/RTS~ function select bit */
#define 	txept_u2c0	u2c0_addr.bit.txept /* Transmit register empty flag */
#define 	crd_u2c0	u2c0_addr.bit.crd	/* CTS~/RTS~ disable bit */

#define 	ckpol_u2c0	u2c0_addr.bit.ckpol /* CLK polarity select bit */
#define 	uform_u2c0	u2c0_addr.bit.uform /* Transfer format select bit */

/*----------------------------------------------
	UART3 transmit/receive control register 0
----------------------------------------------*/
#define 	u3c0	u3c0_addr.byte

#define 	clk0_u3c0	u3c0_addr.bit.clk0	/* BRG count source select bit */
#define 	clk1_u3c0	u3c0_addr.bit.clk1	/* BRG count source select bit */
#define 	crs_u3c0	u3c0_addr.bit.crs	/* CTS~/RTS~ function select bit */
#define 	txept_u3c0	u3c0_addr.bit.txept /* Transmit register empty flag */
#define 	crd_u3c0	u3c0_addr.bit.crd	/* CTS~/RTS~ disable bit */
#define 	nch_u3c0	u3c0_addr.bit.nch	/* Data output select bit */
#define 	ckpol_u3c0	u3c0_addr.bit.ckpol /* CLK polarity select bit */
#define 	uform_u3c0	u3c0_addr.bit.uform /* Transfer format select bit */

/*============================================*/
/*	   declare UARTx trs/rcv control1 bit	  */
/*============================================*/
union {
	struct {
		char	te:1;				/* Transmit enable bit */
		char	ti:1;				/* Transmit buffer empty flag */
		char	re:1;				/* Receive enable bit */
		char	ri:1;				/* Receive complete flag */
		char	uiirs:1;			/* UARTi transmit interrupt cause select bit */
		char	uirrm:1;			/* UARTi continuous receive mode enable bit */
		char	uilch:1;			/* Data logic select bit */
		char	uiere:1;			/* Clock divide synchronizing stop bit/Error signal output enable bit */
	} bit;
	unsigned char  byte;
} u0c1_addr,u1c1_addr,u2c1_addr,u3c1_addr;

/*----------------------------------------------
	UART0 transmit/receive control register 1
----------------------------------------------*/
#define 	u0c1	u0c1_addr.byte

#define 	te_u0c1 	u0c1_addr.bit.te	/* Transmit enable bit */
#define 	ti_u0c1 	u0c1_addr.bit.ti	/* Transmit buffer empty flag */
#define 	re_u0c1 	u0c1_addr.bit.re	/* Receive enable bit */
#define 	ri_u0c1 	u0c1_addr.bit.ri	/* Receive complete flag */
#define 	u0irs		u0c1_addr.bit.uiirs /* UART0 transmit interrupt cause select bit */
#define 	u0rrm		u0c1_addr.bit.uirrm /* UART0 continuous receive mode enable bit */
#define 	u0lch		u0c1_addr.bit.uilch /* Data logic select bit */
#define 	u0ere		u0c1_addr.bit.uiere /* Clock divide synchronizing stop bit/Error signal output enable bit */

/*----------------------------------------------
	UART1 transmit/receive control register 1
----------------------------------------------*/
#define 	u1c1	u1c1_addr.byte

#define 	te_u1c1 	u1c1_addr.bit.te	/* Transmit enable bit */
#define 	ti_u1c1 	u1c1_addr.bit.ti	/* Transmit buffer empty flag */
#define 	re_u1c1 	u1c1_addr.bit.re	/* Receive enable bit */
#define 	ri_u1c1 	u1c1_addr.bit.ri	/* Receive complete flag */
#define 	u1irs		u1c1_addr.bit.uiirs /* UART1 transmit interrupt cause select bit */
#define 	u1rrm		u1c1_addr.bit.uirrm /* UART1 continuous receive mode enable bit */
#define 	u1lch		u1c1_addr.bit.uilch /* Data logic select bit */
#define 	u1ere		u1c1_addr.bit.uiere /* Clock divide synchronizing stop bit/Error signal output enable bit */

/*----------------------------------------------
	UART2 transmit/receive control register 1
----------------------------------------------*/
#define 	u2c1	u2c1_addr.byte

#define 	te_u2c1 	u2c1_addr.bit.te	/* Transmit enable bit */
#define 	ti_u2c1 	u2c1_addr.bit.ti	/* Transmit buffer empty flag */
#define 	re_u2c1 	u2c1_addr.bit.re	/* Receive enable bit */
#define 	ri_u2c1 	u2c1_addr.bit.ri	/* Receive complete flag */
#define 	u2irs		u2c1_addr.bit.uiirs /* UART2 transmit interrupt cause select bit */
#define 	u2rrm		u2c1_addr.bit.uirrm /* UART2 continuous receive mode enable bit */
#define 	u2lch		u2c1_addr.bit.uilch /* Data logic select bit */
#define 	u2ere		u2c1_addr.bit.uiere /* Clock divide synchronizing stop bit/Error signal output enable bit */

/*----------------------------------------------
	UART3 transmit/receive control register 1
----------------------------------------------*/
#define 	u3c1	u3c1_addr.byte

#define 	te_u3c1 	u3c1_addr.bit.te	/* Transmit enable bit */
#define 	ti_u3c1 	u3c1_addr.bit.ti	/* Transmit buffer empty flag */
#define 	re_u3c1 	u3c1_addr.bit.re	/* Receive enable bit */
#define 	ri_u3c1 	u3c1_addr.bit.ri	/* Receive complete flag */
#define 	u3irs		u3c1_addr.bit.uiirs /* UART3 transmit interrupt cause select bit */
#define 	u3rrm		u3c1_addr.bit.uirrm /* UART3 continuous receive mode enable bit */
#define 	u3lch		u3c1_addr.bit.uilch /* Data logic select bit */
#define 	u3ere		u3c1_addr.bit.uiere /* Clock divide synchronizing stop bit/Error signal output enable bit */

/*============================================*/
/*		 declare UARTx special mode bit 	  */
/*============================================*/
union {
	struct {
		char	iicm:1; 			/* I2C mode select bit */
		char	abc:1;				/* Arbitration lost detecting flag control bit */
		char	bbs:1;				/* Bus busy flag */
		char	lsyn:1; 			/* SCLL sync output enable bit */
		char	abscs:1;			/* Bus collision detect sampling clock select bit */
		char	acse:1; 			/* Auto-clear function select bit of transmit enable bit */
		char	sss:1;				/* Transmit start condition select bit */
		char	sclkdiv:1;			/* Clock divide set bit */
	} bit;
	unsigned char  byte;
} u0smr_addr,u1smr_addr,u2smr_addr,u3smr_addr;

/*----------------------------------------------
	UART0 special mode register
----------------------------------------------*/
#define 	u0smr	u0smr_addr.byte

#define 	iicm_u0smr		u0smr_addr.bit.iicm 	/* I2C mode select bit */
#define 	abc_u0smr		u0smr_addr.bit.abc		/* Arbitration lost detecting flag control bit */
#define 	bbs_u0smr		u0smr_addr.bit.bbs		/* Bus busy flag */
#define 	lsyn_u0smr		u0smr_addr.bit.lsyn 	/* SCLL sync output enable bit */
#define 	abscs_u0smr 	u0smr_addr.bit.abscs	/* Bus collision detect sampling clock select bit */
#define 	acse_u0smr		u0smr_addr.bit.acse 	/* Auto-clear function select bit of transmit enable bit */
#define 	sss_u0smr		u0smr_addr.bit.sss		/* Transmit start condition select bit */
#define 	sclkdiv_u0smr	u0smr_addr.bit.sclkdiv	/* Clock divide set bit */

/*----------------------------------------------
	UART1 special mode register
----------------------------------------------*/
#define 	u1smr	u1smr_addr.byte

#define 	iicm_u1smr		u1smr_addr.bit.iicm 	/* I2C mode select bit */
#define 	abc_u1smr		u1smr_addr.bit.abc		/* Arbitration lost detecting flag control bit */
#define 	bbs_u1smr		u1smr_addr.bit.bbs		/* Bus busy flag */
#define 	lsyn_u1smr		u1smr_addr.bit.lsyn 	/* SCLL sync output enable bit */
#define 	abscs_u1smr 	u1smr_addr.bit.abscs	/* Bus collision detect sampling clock select bit */
#define 	acse_u1smr		u1smr_addr.bit.acse 	/* Auto-clear function select bit of transmit enable bit */
#define 	sss_u1smr		u1smr_addr.bit.sss		/* Transmit start condition select bit */
#define 	sclkdiv_u1smr	u1smr_addr.bit.sclkdiv	/* Clock divide set bit */

/*----------------------------------------------
	UART2 special mode register
----------------------------------------------*/
#define 	u2smr	u2smr_addr.byte

#define 	iicm_u2smr		u2smr_addr.bit.iicm 	/* I2C mode select bit */
#define 	abc_u2smr		u2smr_addr.bit.abc		/* Arbitration lost detecting flag control bit */
#define 	bbs_u2smr		u2smr_addr.bit.bbs		/* Bus busy flag */
#define 	lsyn_u2smr		u2smr_addr.bit.lsyn 	/* SCLL sync output enable bit */
#define 	abscs_u2smr 	u2smr_addr.bit.abscs	/* Bus collision detect sampling clock select bit */
#define 	acse_u2smr		u2smr_addr.bit.acse 	/* Auto-clear function select bit of transmit enable bit */
#define 	sss_u2smr		u2smr_addr.bit.sss		/* Transmit start condition select bit */
#define 	sclkdiv_u2smr	u2smr_addr.bit.sclkdiv	/* Clock divide set bit */

/*----------------------------------------------
	UART3 special mode register
----------------------------------------------*/
#define 	u3smr	u3smr_addr.byte

#define 	iicm_u3smr		u3smr_addr.bit.iicm 	/* I2C mode select bit */
#define 	abc_u3smr		u3smr_addr.bit.abc		/* Arbitration lost detecting flag control bit */
#define 	bbs_u3smr		u3smr_addr.bit.bbs		/* Bus busy flag */
#define 	lsyn_u3smr		u3smr_addr.bit.lsyn 	/* SCLL sync output enable bit */
#define 	abscs_u3smr 	u3smr_addr.bit.abscs	/* Bus collision detect sampling clock select bit */
#define 	acse_u3smr		u3smr_addr.bit.acse 	/* Auto-clear function select bit of transmit enable bit */
#define 	sss_u3smr		u3smr_addr.bit.sss		/* Transmit start condition select bit */
#define 	sclkdiv_u3smr	u3smr_addr.bit.sclkdiv	/* Clock divide set bit */

/*============================================*/
/*		 declare UARTx special mode2 bit	  */
/*============================================*/
union {
	struct {
		char	iicm2:1;			/* I2C mode select bit 2 */
		char	csc:1;				/* Clock synchronous bit */
		char	swc:1;				/* SCL wait output bit */
		char	als:1;				/* SDA output stop bit */
		char	stc:1;				/* UARTi initialize bit */
		char	swc2:1; 			/* SCL Wait output bit 2 */
		char	sdhi:1; 			/* SDA output inhbit bit */
		char	su1him:1;			/* Clock divide synchroniing enable bit*/
	} bit;
	unsigned char  byte;
} u0smr2_addr,u1smr2_addr,u2smr2_addr,u3smr2_addr;

/*----------------------------------------------
	UART0 special mode register 2
----------------------------------------------*/
#define 	u0smr2	u0smr2_addr.byte

#define 	iicm2_u0smr2	u0smr2_addr.bit.iicm2	/* I2C mode select bit 2 */
#define 	csc_u0smr2		u0smr2_addr.bit.csc 	/* Clock synchronous bit */
#define 	swc_u0smr2		u0smr2_addr.bit.swc 	/* SCL wait output bit */
#define 	als_u0smr2		u0smr2_addr.bit.als 	/* SDA output stop bit */
#define 	stc_u0smr2		u0smr2_addr.bit.stc 	/* UARTi initialize bit */
#define 	swc2_u0smr2 	u0smr2_addr.bit.swc2	/* SCL Wait output bit 2 */
#define 	sdhi_u0smr2 	u0smr2_addr.bit.sdhi	/* SDA output inhbit bit */
#define 	su1him_u0smr2	u0smr2_addr.bit.su1him	/* Clock divide synchroniing enable bit*/

/*----------------------------------------------
	UART1 special mode register 2
----------------------------------------------*/
#define 	u1smr2	u1smr2_addr.byte

#define 	iicm2_u1smr2	u1smr2_addr.bit.iicm2	/* I2C mode select bit 2 */
#define 	csc_u1smr2		u1smr2_addr.bit.csc 	/* Clock synchronous bit */
#define 	swc_u1smr2		u1smr2_addr.bit.swc 	/* SCL wait output bit */
#define 	als_u1smr2		u1smr2_addr.bit.als 	/* SDA output stop bit */
#define 	stc_u1smr2		u1smr2_addr.bit.stc 	/* UARTi initialize bit */
#define 	swc2_u1smr2 	u1smr2_addr.bit.swc2	/* SCL Wait output bit 2 */
#define 	sdhi_u1smr2 	u1smr2_addr.bit.sdhi	/* SDA output inhbit bit */
#define 	su1him_u1smr2	u1smr2_addr.bit.su1him	/* Clock divide synchroniing enable bit*/

/*----------------------------------------------
	UART2 special mode register 2
----------------------------------------------*/
#define 	u2smr2	u2smr2_addr.byte

#define 	iicm2_u2smr2	u2smr2_addr.bit.iicm2	/* I2C mode select bit 2 */
#define 	csc_u2smr2		u2smr2_addr.bit.csc 	/* Clock synchronous bit */
#define 	swc_u2smr2		u2smr2_addr.bit.swc 	/* SCL wait output bit */
#define 	als_u2smr2		u2smr2_addr.bit.als 	/* SDA output stop bit */
#define 	stc_u2smr2		u2smr2_addr.bit.stc 	/* UARTi initialize bit */
#define 	swc2_u2smr2 	u2smr2_addr.bit.swc2	/* SCL Wait output bit 2 */
#define 	sdhi_u2smr2 	u2smr2_addr.bit.sdhi	/* SDA output inhbit bit */
#define 	su1him_u2smr2	u2smr2_addr.bit.su1him	/* Clock divide synchroniing enable bit*/

/*----------------------------------------------
	UART3 special mode register 2
----------------------------------------------*/
#define 	u3smr2	u3smr2_addr.byte

#define 	iicm2_u3smr2	u3smr2_addr.bit.iicm2	/* I2C mode select bit 2 */
#define 	csc_u3smr2		u3smr2_addr.bit.csc 	/* Clock synchronous bit */
#define 	swc_u3smr2		u3smr2_addr.bit.swc 	/* SCL wait output bit */
#define 	als_u3smr2		u3smr2_addr.bit.als 	/* SDA output stop bit */
#define 	stc_u3smr2		u3smr2_addr.bit.stc 	/* UARTi initialize bit */
#define 	swc2_u3smr2 	u3smr2_addr.bit.swc2	/* SCL Wait output bit 2 */
#define 	sdhi_u3smr2 	u3smr2_addr.bit.sdhi	/* SDA output inhbit bit */
#define 	su1him_u3smr2	u3smr2_addr.bit.su1him	/* Clock divide synchroniing enable bit*/

/*============================================*/
/*		 declare UARTx special mode3 bit	  */
/*============================================*/
union {
	struct {
		char	sse:1;				/* SS~ port function enable bit */
		char	ckph:1; 			/* Clock phase set bit */
		char	dinc:1; 			/* Serial input port set bit */
		char	nodc:1; 			/* Clock output select bit */
		char	err:1;				/* Fault error flag */
		char	dl0:1;				/* SDA(TxDi) digital delay time set bit */
		char	dl1:1;				/* SDA(TxDi) digital delay time set bit */
		char	dl2:1;				/* SDA(TxDi) digital delay time set bit */
	} bit;
	unsigned char  byte;
} u0smr3_addr,u1smr3_addr,u2smr3_addr,u3smr3_addr;

/*----------------------------------------------
	UART0 special mode register 3
----------------------------------------------*/
#define 	u0smr3	u0smr3_addr.byte

#define 	sse_u0smr3	u0smr3_addr.bit.sse 	/* SS~ port function enable bit */
#define 	ckph_u0smr3 u0smr3_addr.bit.ckph	/* Clock phase set bit */
#define 	dinc_u0smr3 u0smr3_addr.bit.dinc	/* Serial input port set bit */
#define 	nodc_u0smr3 u0smr3_addr.bit.nodc	/* Clock output select bit */
#define 	err_u0smr3	u0smr3_addr.bit.err 	/* Fault error flag */
#define 	dl0_u0smr3	u0smr3_addr.bit.dl0 	/* SDA(TxD0) digital delay time set bit */
#define 	dl1_u0smr3	u0smr3_addr.bit.dl1 	/* SDA(TxD0) digital delay time set bit */
#define 	dl2_u0smr3	u0smr3_addr.bit.dl2 	/* SDA(TxD0) digital delay time set bit */

/*----------------------------------------------
	UART1 special mode register 3
----------------------------------------------*/
#define 	u1smr3	u1smr3_addr.byte

#define 	sse_u1smr3	u1smr3_addr.bit.sse 	/* SS~ port function enable bit */
#define 	ckph_u1smr3 u1smr3_addr.bit.ckph	/* Clock phase set bit */
#define 	dinc_u1smr3 u1smr3_addr.bit.dinc	/* Serial input port set bit */
#define 	nodc_u1smr3 u1smr3_addr.bit.nodc	/* Clock output select bit */
#define 	err_u1smr3	u1smr3_addr.bit.err 	/* Fault error flag */
#define 	dl0_u1smr3	u1smr3_addr.bit.dl0 	/* SDA(TxD1) digital delay time set bit */
#define 	dl1_u1smr3	u1smr3_addr.bit.dl1 	/* SDA(TxD1) digital delay time set bit */
#define 	dl2_u1smr3	u1smr3_addr.bit.dl2 	/* SDA(TxD1) digital delay time set bit */

/*----------------------------------------------
	UART2 special mode register 3
----------------------------------------------*/
#define 	u2smr3	u2smr3_addr.byte

#define 	sse_u2smr3	u2smr3_addr.bit.sse 	/* SS~ port function enable bit */
#define 	ckph_u2smr3 u2smr3_addr.bit.ckph	/* Clock phase set bit */
#define 	dinc_u2smr3 u2smr3_addr.bit.dinc	/* Serial input port set bit */
#define 	nodc_u2smr3 u2smr3_addr.bit.nodc	/* Clock output select bit */
#define 	err_u2smr3	u2smr3_addr.bit.err 	/* Fault error flag */
#define 	dl0_u2smr3	u2smr3_addr.bit.dl0 	/* SDA(TxD2) digital delay time set bit */
#define 	dl1_u2smr3	u2smr3_addr.bit.dl1 	/* SDA(TxD2) digital delay time set bit */
#define 	dl2_u2smr3	u2smr3_addr.bit.dl2 	/* SDA(TxD2) digital delay time set bit */

/*----------------------------------------------
	UART3 special mode register 3
----------------------------------------------*/
#define 	u3smr3	u3smr3_addr.byte

#define 	sse_u3smr3	u3smr3_addr.bit.sse 	/* SS~ port function enable bit */
#define 	ckph_u3smr3 u3smr3_addr.bit.ckph	/* Clock phase set bit */
#define 	dinc_u3smr3 u3smr3_addr.bit.dinc	/* Serial input port set bit */
#define 	nodc_u3smr3 u3smr3_addr.bit.nodc	/* Clock output select bit */
#define 	err_u3smr3	u3smr3_addr.bit.err 	/* Fault error flag */
#define 	dl0_u3smr3	u3smr3_addr.bit.dl0 	/* SDA(TxD3) digital delay time set bit */
#define 	dl1_u3smr3	u3smr3_addr.bit.dl1 	/* SDA(TxD3) digital delay time set bit */
#define 	dl2_u3smr3	u3smr3_addr.bit.dl2 	/* SDA(TxD3) digital delay time set bit */

/*============================================*/
/*		 declare UARTx special mode4 bit	  */
/*============================================*/
union {
	struct {
		char	stareq:1;			/* Start condition generate bit */
		char	rstareq:1;			/* Restart condition generate bit */
		char	stpreq:1;			/* Stop condition generate bit */
		char	stapsel:1;			/* SCL,SDA output select bit */
		char	ackd:1; 			/* ACK data bit */
		char	ackc:1; 			/* ACK data output enable bit */
		char	sclhi:1;			/* SCL output stop enable bit */
		char	swc9:1; 			/* SCL wait output bit 3 */
	} bit;
	unsigned char  byte;
} u0smr4_addr,u1smr4_addr,u2smr4_addr,u3smr4_addr;

/*----------------------------------------------
	UART0 special mode register 4
----------------------------------------------*/
#define 	u0smr4	u0smr4_addr.byte

#define 	stareq_u0smr4	u0smr4_addr.bit.stareq	/* Start condition generate bit */
#define 	rstareq_u0smr4	u0smr4_addr.bit.rstareq /* Restart condition generate bit */
#define 	stpreq_u0smr4	u0smr4_addr.bit.stpreq	/* Stop condition generate bit */
#define 	stapsel_u0smr4	u0smr4_addr.bit.stapsel /* SCL,SDA output select bit */
#define 	ackd_u0smr4 	u0smr4_addr.bit.ackd	/* ACK data bit */
#define 	ackc_u0smr4 	u0smr4_addr.bit.ackc	/* ACK data output enable bit */
#define 	sclhi_u0smr4	u0smr4_addr.bit.sclhi	/* SCL output stop enable bit */
#define 	swc9_u0smr4 	u0smr4_addr.bit.swc9	/* SCL wait output bit 3 */

/*----------------------------------------------
	UART1 special mode register 4
----------------------------------------------*/
#define 	u1smr4	u1smr4_addr.byte

#define 	stareq_u1smr4	u1smr4_addr.bit.stareq	/* Start condition generate bit */
#define 	rstareq_u1smr4	u1smr4_addr.bit.rstareq /* Restart condition generate bit */
#define 	stpreq_u1smr4	u1smr4_addr.bit.stpreq	/* Stop condition generate bit */
#define 	stapsel_u1smr4	u1smr4_addr.bit.stapsel /* SCL,SDA output select bit */
#define 	ackd_u1smr4 	u1smr4_addr.bit.ackd	/* ACK data bit */
#define 	ackc_u1smr4 	u1smr4_addr.bit.ackc	/* ACK data output enable bit */
#define 	sclhi_u1smr4	u1smr4_addr.bit.sclhi	/* SCL output stop enable bit */
#define 	swc9_u1smr4 	u1smr4_addr.bit.swc9	/* SCL wait output bit 3 */

/*----------------------------------------------
	UART2 special mode register 4
----------------------------------------------*/
#define 	u2smr4	u2smr4_addr.byte

#define 	stareq_u2smr4	u2smr4_addr.bit.stareq	/* Start condition generate bit */
#define 	rstareq_u2smr4	u2smr4_addr.bit.rstareq /* Restart condition generate bit */
#define 	stpreq_u2smr4	u2smr4_addr.bit.stpreq	/* Stop condition generate bit */
#define 	stapsel_u2smr4	u2smr4_addr.bit.stapsel /* SCL,SDA output select bit */
#define 	ackd_u2smr4 	u2smr4_addr.bit.ackd	/* ACK data bit */
#define 	ackc_u2smr4 	u2smr4_addr.bit.ackc	/* ACK data output enable bit */
#define 	sclhi_u2smr4	u2smr4_addr.bit.sclhi	/* SCL output stop enable bit */
#define 	swc9_u2smr4 	u2smr4_addr.bit.swc9	/* SCL wait output bit 3 */

/*----------------------------------------------
	UART3 special mode register 4
----------------------------------------------*/
#define 	u3smr4	u3smr4_addr.byte

#define 	stareq_u3smr4	u3smr4_addr.bit.stareq	/* Start condition generate bit */
#define 	rstareq_u3smr4	u3smr4_addr.bit.rstareq /* Restart condition generate bit */
#define 	stpreq_u3smr4	u3smr4_addr.bit.stpreq	/* Stop condition generate bit */
#define 	stapsel_u3smr4	u3smr4_addr.bit.stapsel /* SCL,SDA output select bit */
#define 	ackd_u3smr4 	u3smr4_addr.bit.ackd	/* ACK data bit */
#define 	ackc_u3smr4 	u3smr4_addr.bit.ackc	/* ACK data output enable bit */
#define 	sclhi_u3smr4	u3smr4_addr.bit.sclhi	/* SCL output stop enable bit */
#define 	swc9_u3smr4 	u3smr4_addr.bit.swc9	/* SCL wait output bit 3 */

/*============================================*/
/*		declare SSIx mode register 0 bit	  */
/*============================================*/
union {
	struct {
		char	ssisen:1;			 /* Serial Sound Interface enable bit */
		char	xmten:1;			/* Transmitter enable bit */
		char	rxen:1; 			/* Receiver enable bit */
		char	rfben:1;			/* Rate feedback counter enable bit */
		char	cwid0:1;			/* Channel width select bit 0 */
		char	cwid1:1;			/* Channel width select bit 1 */
		char	rfmt0:1;			/* Receiver format select bit 0 */
		char	rfmt1:1;			/* Receiver format select bit 1 */
	} bit;
	unsigned char  byte;
} ssi0mr0_addr,ssi1mr0_addr;

/*----------------------------------------------
	Serial Sound Interface 0 mode register 0
----------------------------------------------*/
#define 	ssi0mr0 ssi0mr0_addr.byte

#define 	ssien_ssi0mr0	ssi0mr0_addr.bit.ssien	/* Serial Sound Interface enable bit */
#define 	xmten_ssi0mr0	ssi0mr0_addr.bit.xmten	/* Transmitter enable bit */
#define 	rxen_ssi0mr0	ssi0mr0_addr.bit.rxen	/* Receiver enable bit */
#define 	rfben_ssi0mr0	ssi0mr0_addr.bit.rfben	/* Rate feedback counter enable bit */
#define 	cwid0_ssi0mr0	ssi0mr0_addr.bit.cwid0	/* Channel width select bit 0 */
#define 	cwid1_ssi0mr0	ssi0mr0_addr.bit.cwid1	/* Channel width select bit 1 */
#define 	rfmt0_ssi0mr0	ssi0mr0_addr.bit.rfmt0	/* Receiver format select bit 0 */
#define 	rfmt1_ssi0mr0	ssi0mr0_addr.bit.rfmt1	/* Receiver format select bit 1 */

/*----------------------------------------------
	Serial Sound Interface 1 mode register 0
----------------------------------------------*/
#define 	ssi1mr0 ssi1mr0_addr.byte

#define 	ssien_ssi1mr0	ssi1mr0_addr.bit.ssien	/* Serial Sound Interface enable bit */
#define 	xmten_ssi1mr0	ssi1mr0_addr.bit.xmten	/* Transmitter enable bit */
#define 	rxen_ssi1mr0	ssi1mr0_addr.bit.rxen	/* Receiver enable bit */
#define 	rfben_ssi1mr0	ssi1mr0_addr.bit.rfben	/* Rate feedback counter enable bit */
#define 	cwid0_ssi1mr0	ssi1mr0_addr.bit.cwid0	/* Channel width select bit 0 */
#define 	cwid1_ssi1mr0	ssi1mr0_addr.bit.cwid1	/* Channel width select bit 1 */
#define 	rfmt0_ssi1mr0	ssi1mr0_addr.bit.rfmt0	/* Receiver format select bit 0 */
#define 	rfmt1_ssi1mr0	ssi1mr0_addr.bit.rfmt1	/* Receiver format select bit 1 */

/*============================================*/
/*		declare SSIx mode register 1 bit	  */
/*============================================*/
union {
	struct {
		char	xmtfmt:1;			/* Transmit format select bit */
		char	b1:1;				/* Reserved */
		char	rfbsrc:1;			/* Rate feedback counter source */
		char	sckp:1; 			/* SCK polarity */
		char	wsp:1;				/* WS polarity */
		char	wsdly:1;			/* WS delay */
		char	b6:1;				/* Reserved */
		char	b7:1;				/* Reserved */
	} bit;
	unsigned char  byte;
} ssi0mr1_addr,ssi1mr1_addr;

/*----------------------------------------------
	ssi0 mode register 1
----------------------------------------------*/
#define 	ssi0mr1 ssi0mr1_addr.byte

#define 	xmtfmt_ssi0mr1	ssi0mr1_addr.bit.xmtfmt /* Transmit format select bit */

#define 	rfbsrc_ssi0mr1	ssi0mr1_addr.bit.rfbsrc /* Rate feedback counter source */
#define 	sckp_ssi0mr1	ssi0mr1_addr.bit.sckp	/* SCK polarity */
#define 	wsp_ssi0mr1 	ssi0mr1_addr.bit.wsp	/* WS polarity */
#define 	wsdly_ssi0mr1	ssi0mr1_addr.bit.wsdly	/* WS delay */

/*----------------------------------------------
	ssi1 mode register 1
----------------------------------------------*/
#define 	ssi1mr1 ssi1mr1_addr.byte

#define 	xmtfmt_ssi1mr1	ssi1mr1_addr.bit.xmtfmt /* Transmit format select bit */

#define 	rfbsrc_ssi1mr1	ssi1mr1_addr.bit.rfbsrc /* Rate feedback counter source */
#define 	sckp_ssi1mr1	ssi1mr1_addr.bit.sckp	/* SCK polarity */
#define 	wsp_ssi1mr1 	ssi1mr1_addr.bit.wsp	/* WS polarity */
#define 	wsdly_ssi1mr1	ssi1mr1_addr.bit.wsdly	/* WS delay */

/**********************************************/
/*			 declare SFR union bytes		  */
/**********************************************/
/*============================================*/
/*				  declare word				  */
/*============================================*/
union {
	struct {
		unsigned char	 low;	/* low	8 bit */
		unsigned char	 high;	/* high 8 bit */
	} byte;
	unsigned short	word;
}
  usba_addr,usbfn_addr,usbis_addr,usbic_addr,
  ep0wc_addr,ep1wc_addr,ep2wc_addr,ep3wc_addr,ep4wc_addr,
  ep1imp_addr,ep2imp_addr,ep3imp_addr,ep4imp_addr,
  ep1omp_addr,ep2omp_addr,ep3omp_addr,ep4omp_addr,
  ep0i_addr,ep1i_addr,ep2i_addr,ep3i_addr,ep4i_addr,
  ep0o_addr,ep1o_addr,ep2o_addr,ep3o_addr,ep4o_addr,
  u0tb_addr,u1tb_addr,u2tb_addr,u3tb_addr,
  ad0_addr,ad1_addr,ad2_addr,ad3_addr,ad4_addr,ad5_addr,ad6_addr,ad7_addr;

/*----------------------------------------------
	Universal Serial Bus
----------------------------------------------*/
#define 	usba	usba_addr.word			/* USB address register 16 bit */
#define 	usbal		usba_addr.byte.low		/* USB address register low  8 bit */
#define 	usbah		usba_addr.byte.high 	/* USB address register high 8 bit */
#define 	usbis	usbis_addr.word 		/* USB interrupt status register 16bit */
#define 	usbisl		usbis_addr.byte.low 	/* USB interrupt status register low  8 bit */
#define 	usbish		usbis_addr.byte.high	/* USB interrupt status register high 8 bit */
#define 	usbic	usbic_addr.word 		/* USB interrupt clear register 16 bit */
#define 	usbicl		usbic_addr.byte.low 	/* USB interrupt clear register low  8 bit*/
#define 	usbich		usbic_addr.byte.high	/* USB interrupt clear register high 8 bit*/
#define 	usbfn	usbfn_addr.word 		/* USB frame number register 16 bit */
#define 	usbfnl		usbfn_addr.byte.low 	/* USB frame number register low  8 bit*/
#define 	usbfnh		usbfn_addr.byte.high	/* USB frame number register high 8 bit*/
#define 	ep0wc	ep0wc_addr.word 		/* USB EP0 write count register 16 bit */
#define 	ep0wcl		ep0wc_addr.byte.low 	/* USB EP0 write count register low  8 bit*/
#define 	ep0wch		ep0wc_addr.byte.high	/* USB EP0 write count register high 8 bit*/
#define 	ep1wc	ep1wc_addr.word 		/* USB EP1 OUT write count register 16 bit */
#define 	ep1wcl		ep1wc_addr.byte.low 	/* USB EP1 OUT write count register low  8 bit*/
#define 	ep1wch		ep1wc_addr.byte.high	/* USB EP1 OUT write count register high 8 bit*/
#define 	ep2wc	ep2wc_addr.word 		/* USB EP2 OUT write count register 16 bit */
#define 	ep2wcl		ep2wc_addr.byte.low 	/* USB EP2 OUT write count register low  8 bit*/
#define 	ep2wch		ep2wc_addr.byte.high	/* USB EP2 OUT write count register high 8 bit*/
#define 	ep3wc	ep3wc_addr.word 		/* USB EP3 OUT write count register 16 bit */
#define 	ep3wcl		ep3wc_addr.byte.low 	/* USB EP3 OUT write count register low  8 bit*/
#define 	ep3wch		ep3wc_addr.byte.high	/* USB EP3 OUT write count register high 8 bit*/
#define 	ep4wc	ep4wc_addr.word 		/* USB EP4 OUT write count register 16 bit */
#define 	ep4wcl		ep4wc_addr.byte.low 	/* USB EP4 OUT write count register low  8 bit*/
#define 	ep4wch		ep4wc_addr.byte.high	/* USB EP4 OUT write count register high 8 bit*/
#define 	ep1imp	ep1imp_addr.word		/* USB EP1 IN max packet size register 16 bit */
#define 	ep1impl 	ep1imp_addr.byte.low	/* USB EP1 IN max packet size register low	8 bit*/
#define 	ep1imph 	ep1imp_addr.byte.high	/* USB EP1 IN max packet size register high 8 bit*/
#define 	ep2imp	ep2imp_addr.word		/* USB EP2 IN max packet size register 16 bit */
#define 	ep2impl 	ep2imp_addr.byte.low	/* USB EP2 IN max packet size register low	8 bit*/
#define 	ep2imph 	ep2imp_addr.byte.high	/* USB EP2 IN max packet size register high 8 bit*/
#define 	ep3imp	ep3imp_addr.word		/* USB EP3 IN max packet size register 16 bit */
#define 	ep3impl 	ep3imp_addr.byte.low	/* USB EP3 IN max packet size register low	8 bit*/
#define 	ep3imph 	ep3imp_addr.byte.high	/* USB EP3 IN max packet size register high 8 bit*/
#define 	ep4imp	ep4imp_addr.word		/* USB EP4 IN max packet size register 16 bit */
#define 	ep4impl 	ep4imp_addr.byte.low	/* USB EP4 IN max packet size register low	8 bit*/
#define 	ep4imph 	ep4imp_addr.byte.high	/* USB EP4 IN max packet size register high 8 bit*/
#define 	ep1omp	ep1omp_addr.word		/* USB EP1 OUT max packet size register 16 bit */
#define 	ep1ompl 	ep1omp_addr.byte.low	/* USB EP1 OUT max packet size register low  8 bit*/
#define 	ep1omph 	ep1omp_addr.byte.high	/* USB EP1 OUT max packet size register high 8 bit*/
#define 	ep2omp	ep2omp_addr.word		/* USB EP2 OUT max packet size register 16 bit */
#define 	ep2ompl 	ep2omp_addr.byte.low	/* USB EP2 OUT max packet size register low  8 bit*/
#define 	ep2omph 	ep2omp_addr.byte.high	/* USB EP2 OUT max packet size register high 8 bit*/
#define 	ep3omp	ep3omp_addr.word		/* USB EP3 OUT max packet size register 16 bit */
#define 	ep3ompl 	ep3omp_addr.byte.low	/* USB EP3 OUT max packet size register low  8 bit*/
#define 	ep3omph 	ep3omp_addr.byte.high	/* USB EP3 OUT max packet size register high 8 bit*/
#define 	ep4omp	ep4omp_addr.word		/* USB EP4 OUT max packet size register 16 bit */
#define 	ep4ompl 	ep4omp_addr.byte.low	/* USB EP4 OUT max packet size register low  8 bit*/
#define 	ep4omph 	ep4omp_addr.byte.high	/* USB EP4 OUT max packet size register high 8 bit*/
#define 	ep0i	ep0i_addr.word			/* USB EP0 IN  FIFO register 16 bit */
#define 	ep0il		ep0i_addr.byte.low		/* USB EP0 IN  FIFO register low 8 bit */
#define 	ep1i	ep1i_addr.word			/* USB EP1 IN  FIFO register 16 bit */
#define 	ep1il		ep1i_addr.byte.low		/* USB EP1 IN  FIFO register low 8 bit */
#define 	ep2i	ep2i_addr.word			/* USB EP2 IN  FIFO register 16 bit */
#define 	ep2il		ep2i_addr.byte.low		/* USB EP2 IN  FIFO register low 8 bit */
#define 	ep3i	ep3i_addr.word			/* USB EP3 IN  FIFO register 16 bit */
#define 	ep3il		ep3i_addr.byte.low		/* USB EP3 IN  FIFO register low 8 bit */
#define 	ep4i	ep4i_addr.word			/* USB EP4 IN  FIFO register 16 bit */
#define 	ep4il		ep4i_addr.byte.low		/* USB EP4 IN  FIFO register low 8 bit */
#define 	ep0o	ep0o_addr.word			/* USB EP0 OUT FIFO register 16 bit */
#define 	ep0ol		ep0o_addr.byte.low		/* USB EP0 OUT FIFO register low 8 bit */
#define 	ep1o	ep1o_addr.word			/* USB EP1 OUT FIFO register 16 bit */
#define 	ep1ol		ep1o_addr.byte.low		/* USB EP1 OUT FIFO register low 8 bit */
#define 	ep2o	ep2o_addr.word			/* USB EP2 OUT FIFO register 16 bit */
#define 	ep2ol		ep2o_addr.byte.low		/* USB EP2 OUT FIFO register low 8 bit */
#define 	ep3o	ep3o_addr.word			/* USB EP3 OUT FIFO register 16 bit */
#define 	ep3ol		ep3o_addr.byte.low		/* USB EP3 OUT FIFO register low 8 bit */
#define 	ep4o	ep4o_addr.word			/* USB EP4 OUT FIFO register 16 bit */
#define 	ep4ol		ep4o_addr.byte.low		/* USB EP4 OUT FIFO register low 8 bit */

/*----------------------------------------------
	Serial Communication
----------------------------------------------*/
#define 	u0tb	u0tb_addr.word			/* UART0 Transmit buffer register 16 bit ; Use "MOV" instruction when writing to this register. */
#define 	u0tbl		u0tb_addr.byte.low		/* UART0 Transmit buffer register low  8 bit */
#define 	u0tbh		u0tb_addr.byte.high 	/* UART0 Transmit buffer register high 8 bit */
#define 	u1tb	u1tb_addr.word			/* UART1 Transmit buffer register 16 bit ; Use "MOV" instruction when writing to this register. */
#define 	u1tbl		u1tb_addr.byte.low		/* UART1 Transmit buffer register low  8 bit */
#define 	u1tbh		u1tb_addr.byte.high 	/* UART1 Transmit buffer register high 8 bit */
#define 	u2tb	u2tb_addr.word			/* UART2 Transmit buffer register 16 bit ; Use "MOV" instruction when writing to this register. */
#define 	u2tbl		u2tb_addr.byte.low		/* UART2 Transmit buffer register low  8 bit */
#define 	u2tbh		u2tb_addr.byte.high 	/* UART2 Transmit buffer register high 8 bit */
#define 	u3tb	u3tb_addr.word			/* UART3 Transmit buffer register 16 bit ; Use "MOV" instruction when writing to this register. */
#define 	u3tbl		u3tb_addr.byte.low		/* UART3 Transmit buffer register low  8 bit */
#define 	u3tbh		u3tb_addr.byte.high 	/* UART3 Transmit buffer register high 8 bit */

/*----------------------------------------------
	A-D Convertor
----------------------------------------------*/
#define 	ad0 	ad0_addr.word			/* A-D register 0 16 bit */
#define 	ad0l		ad0_addr.byte.low		/* A-D register 0 low  8 bit */
#define 	ad0h		ad0_addr.byte.high		/* A-D register 0 high 8 bit */
#define 	ad1 	ad1_addr.word			/* A-D register 1 16 bit */
#define 	ad1l		ad1_addr.byte.low		/* A-D register 1 low  8 bit */
#define 	ad1h		ad1_addr.byte.high		/* A-D register 1 high 8 bit */
#define 	ad2 	ad2_addr.word			/* A-D register 2 16 bit */
#define 	ad2l		ad2_addr.byte.low		/* A-D register 2 low  8 bit */
#define 	ad2h		ad2_addr.byte.high		/* A-D register 2 high 8 bit */
#define 	ad3 	ad3_addr.word			/* A-D register 3 16 bit */
#define 	ad3l		ad3_addr.byte.low		/* A-D register 3 low  8 bit */
#define 	ad3h		ad3_addr.byte.high		/* A-D register 3 high 8 bit */
#define 	ad4 	ad4_addr.word			/* A-D register 4 16 bit */
#define 	ad4l		ad4_addr.byte.low		/* A-D register 4 low  8 bit */
#define 	ad4h		ad4_addr.byte.high		/* A-D register 4 high 8 bit */
#define 	ad5 	ad5_addr.word			/* A-D register 5 16 bit */
#define 	ad5l		ad5_addr.byte.low		/* A-D register 5 low  8 bit */
#define 	ad5h		ad5_addr.byte.high		/* A-D register 5 high 8 bit */
#define 	ad6 	ad6_addr.word			/* A-D register 6 16 bit */
#define 	ad6l		ad6_addr.byte.low		/* A-D register 6 low  8 bit */
#define 	ad6h		ad6_addr.byte.high		/* A-D register 6 high 8 bit */
#define 	ad7 	ad7_addr.word			/* A-D register 7 16 bit */
#define 	ad7l		ad7_addr.byte.low		/* A-D register 7 low  8 bit */
#define 	ad7h		ad7_addr.byte.high		/* A-D register 7 high 8 bit */

/*============================================*/
/*			declare double word 			  */
/*============================================*/
union {
	struct {
		unsigned char	low;			/* low	8 bit */
		unsigned char	mid;			/* mid	8 bit */
		unsigned char	high;			/* high 8 bit */
		unsigned char	nc; 			/* non use */
	} byte;
	unsigned long	dword;
} rmad0_addr,rmad1_addr,
  sar0_addr,sar1_addr,sar2_addr,sar3_addr,
  dar0_addr,dar1_addr,dar2_addr,dar3_addr;

/*----------------------------------------------
	Address match interrupt register
----------------------------------------------*/
#define 	rmad0	rmad0_addr.dword		/* Address match interrupt register 0 32 bit */
#define 	rmad0l		rmad0_addr.byte.low 	/* Address match interrupt register 0 low  8 bit */
#define 	rmad0m		rmad0_addr.byte.mid 	/* Address match interrupt register 0 mid  8 bit */
#define 	rmad0h		rmad0_addr.byte.high	/* Address match interrupt register 0 high 8 bit */
#define 	rmad1	rmad1_addr.dword		/* Address match interrupt register 1 32 bit */
#define 	rmad1l		rmad1_addr.byte.low 	/* Address match interrupt register 1 low  8 bit */
#define 	rmad1m		rmad1_addr.byte.mid 	/* Address match interrupt register 1 mid  8 bit */
#define 	rmad1h		rmad1_addr.byte.high	/* Address match interrupt register 1 high 8 bit */

/*----------------------------------------------
	DMAx source/destination pointer
----------------------------------------------*/
#define 	sar0	sar0_addr.dword 		/* DMA0 source pointer 32 bit */
#define 	sar0l		sar0_addr.byte.low		/* DMA0 source pointer low	8 bit */
#define 	sar0m		sar0_addr.byte.mid		/* DMA0 source pointer mid	8 bit */
#define 	sar0h		sar0_addr.byte.high 	/* DMA0 source pointer high 8 bit */
#define 	sar1	sar1_addr.dword 		/* DMA1 source pointer 32 bit */
#define 	sar1l		sar1_addr.byte.low		/* DMA1 source pointer low	8 bit */
#define 	sar1m		sar1_addr.byte.mid		/* DMA1 source pointer mid	8 bit */
#define 	sar1h		sar1_addr.byte.high 	/* DMA1 source pointer high 8 bit */
#define 	sar2	sar2_addr.dword 		/* DMA2 source pointer 32 bit */
#define 	sar2l		sar2_addr.byte.low		/* DMA2 source pointer low	8 bit */
#define 	sar2m		sar2_addr.byte.mid		/* DMA2 source pointer mid	8 bit */
#define 	sar2h		sar2_addr.byte.high 	/* DMA2 source pointer high 8 bit */
#define 	sar3	sar3_addr.dword 		/* DMA3 source pointer 32 bit */
#define 	sar3l		sar3_addr.byte.low		/* DMA3 source pointer low	8 bit */
#define 	sar3m		sar3_addr.byte.mid		/* DMA3 source pointer mid	8 bit */
#define 	sar3h		sar3_addr.byte.high 	/* DMA3 source pointer high 8 bit */
#define 	dar0	dar0_addr.dword 		/* DMA0 destination pointer 32 bit */
#define 	dar0l		dar0_addr.byte.low		/* DMA0 destination pointer low  8 bit */
#define 	dar0m		dar0_addr.byte.mid		/* DMA0 destination pointer mid  8 bit */
#define 	dar0h		dar0_addr.byte.high 	/* DMA0 destination pointer high 8 bit */
#define 	dar1	dar1_addr.dword 		/* DMA1 destination pointer 32 bit */
#define 	dar1l		dar1_addr.byte.low		/* DMA1 destination pointer low  8 bit */
#define 	dar1m		dar1_addr.byte.mid		/* DMA1 destination pointer mid  8 bit */
#define 	dar1h		dar1_addr.byte.high 	/* DMA1 destination pointer high 8 bit */
#define 	dar2	dar2_addr.dword 		/* DMA2 destination pointer 32 bit */
#define 	dar2l		dar2_addr.byte.low		/* DMA2 destination pointer low  8 bit */
#define 	dar2m		dar2_addr.byte.mid		/* DMA2 destination pointer mid  8 bit */
#define 	dar2h		dar2_addr.byte.high 	/* DMA2 destination pointer high 8 bit */
#define 	dar3	dar3_addr.dword 		/* DMA3 destination pointer 32 bit */
#define 	dar3l		dar3_addr.byte.low		/* DMA3 destination pointer low  8 bit */
#define 	dar3m		dar3_addr.byte.mid		/* DMA3 destination pointer mid  8 bit */
#define 	dar3h		dar3_addr.byte.high 	/* DMA3 destination pointer high 8 bit */
/*-----------<< End of File >>----------------*/

